Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 StyleBox[ButtonBox["Mathematica",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:guide/Mathematica"],
  FontSlant->"Italic"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["L G S BLOCH TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[
       Dynamic[{"ActionMenu", None}, 
        Part[{"Return Flux from a CW Laser Guide Star" :> 
          Documentation`HelpLookup[
           "paclet:LGSBloch/tutorial/ReturnFluxFromACWLaserGuideStar"], 
          "Integration Over the LGS Beam" :> 
          Documentation`HelpLookup[
           "paclet:LGSBloch/tutorial/IntegrationOverTheLGSBeam"]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"Return Flux from a CW Laser Guide Star\"\>", 
       2->"\<\"Integration Over the LGS Beam\"\>"}, 
       FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[
       Dynamic[{"ActionMenu", None}, 
        Part[{"LGSBloch Package" :> 
          Documentation`HelpLookup["paclet:LGSBloch/guide/LGSBloch"], 
          "AtomicDensityMatrix Package" :> 
          Documentation`HelpLookup[
           "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]}, #, 2]& , 
        Evaluator -> Automatic], {1->"\<\"LGSBloch Package\"\>", 
       2->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[
       Dynamic[{"ActionMenu", None}, 
        Part[{"StepPulseFlux" :> 
          Documentation`HelpLookup["paclet:LGSBloch/ref/StepPulseFlux"]}, #, 
         2]& , Evaluator -> Automatic], {1->"\<\"StepPulseFlux\"\>"}, 
       FrameBox["\<\"Functions \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Functions \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[
       Dynamic[{"ActionMenu", None}, 
        Part[{"LGSBloch/tutorial/Return Flux from a Pulsed Laser Guide Star" :> 
          None, "Copy Mathematica url" :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                 "LGSBloch/tutorial/Return Flux from a Pulsed Laser Guide \
Star"]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          "Copy web url" :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    "http://rochesterscientific.com/ADM/LGSBloch/tutorial/\
Return Flux from a Pulsed Laser Guide Star.html"], StandardForm]], "Input", 
                  TextClipboardType -> "PlainText"]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          "Go to web url" :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                "http://rochesterscientific.com/ADM/", 
                 "LGSBloch/tutorial/Return Flux from a Pulsed Laser Guide \
Star", ".html"]], None}]}]}, #, 2]& , Evaluator -> Automatic], {
       1->"\<\"LGSBloch/tutorial/Return Flux from a Pulsed Laser Guide Star\"\
\>", 2->"\<\"Copy Mathematica url\"\>", Delimiter, 4->"\<\"Copy web url\"\>", 
       5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Return Flux from a Pulsed Laser Guide Star", "Title",
 CellID->509267359],

Cell["\<\
In this tutorial we calculate the return flux from a sodium LGS with a pulsed \
laser.\
\>", "Text",
 CellID->1534169418],

Cell[BoxData[GridBox[{
   {
    RowBox[{
     ButtonBox["StepPulseFlux",
      BaseStyle->"Link",
      ButtonData->"paclet:LGSBloch/ref/StepPulseFlux"], "[", 
     RowBox[{
      StyleBox["sys", "TI"], ",", " ", 
      StyleBox["params", "TI"], ",", " ", 
      StyleBox["maxPeriods", "TI"], ",", " ", 
      StyleBox["amplitude", "TI"], ",", " ", 
      StyleBox["brightPeriod", "TI"], ",", " ", 
      StyleBox["detuning", "TI"], ",", " ", 
      StyleBox["file", "TI"]}], "]"}], Cell[TextData[{
     "Calculate return flux for a pulsed laser with parameters ",
     Cell[BoxData[
      StyleBox["params", "TI"]], "InlineFormula"],
     " and scaled electric field amplitude as a function of time ",
     Cell[BoxData[
      StyleBox["amplitude", "TI"]], "InlineFormula"],
     "."
    }], "TableText"]}
  }]], "DefinitionBox",
 CellID->2096742444],

Cell["Function to calculate time-dependent return flux.", "Caption",
 CellID->1891092685],

Cell["Load the package.", "MathCaption",
 CellID->1329584674],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LGSBloch`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1971712093],

Cell["Generate the system of equations for the Na D2 line.", "MathCaption",
 CellID->909197065],

Cell[BoxData[
 RowBox[{
  RowBox[{"NaD2LGS", "=", 
   RowBox[{"GenerateLGSSystem", "[", "]"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1528923050],

Cell["\<\
Define a time series of electric field amplitudes that describe a laser that \
turns on at time 0.001 ns and turns off at 100 ns.\
\>", "MathCaption",
 CellID->1169896830],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"amplitudeVector", "=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1.", " ", 
        SuperscriptBox["10", 
         RowBox[{"-", "12"}]]}], ",", "0"}], "}"}], "}"}], ",", 
    RowBox[{"Rest", "@", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"t", " ", 
          SuperscriptBox["10", 
           RowBox[{"-", "9"}]]}], ",", " ", "1."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "0", ",", "100.", ",", "5."}], "}"}]}], "]"}]}], 
    ",", 
    RowBox[{"Rest", "@", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"t", " ", 
          SuperscriptBox["10", 
           RowBox[{"-", "9"}]]}], ",", " ", "0."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "100.", ",", "200.", ",", "5."}], "}"}]}], 
      "]"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1063733357],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.`*^-12", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5.`*^-9", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.5000000000000002`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2.`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2.5000000000000002`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3.0000000000000004`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3.5`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4.`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4.5000000000000006`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5.0000000000000004`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5.5`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6.000000000000001`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6.5`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7.`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7.500000000000001`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8.`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8.500000000000001`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9.000000000000001`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9.5`*^-8", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.0000000000000001`*^-7", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.05`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.1`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.1500000000000001`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.2000000000000002`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.2500000000000002`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.3`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.35`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.4`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.4500000000000001`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.5000000000000002`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.55`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.6`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.65`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.7000000000000001`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.7500000000000002`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.8000000000000002`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.85`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.9`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.95`*^-7", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2.0000000000000002`*^-7", ",", "0.`"}], "}"}]}], 
  "}"}]], "Output",
 ImageSize->{550, 170},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->2494752]
}, Open  ]],

Cell[TextData[{
 "Find time-dependent return flux using ",
 Cell[BoxData[
  ButtonBox["StepPulseFlux",
   BaseStyle->"Link",
   ButtonData->"paclet:LGSBloch/ref/StepPulseFlux"]], "InlineFormula"],
 "."
}], "MathCaption",
 CellID->1625329363],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListLinePlot", "[", 
  RowBox[{
   RowBox[{"StepPulseFlux", "[", 
    RowBox[{"NaD2LGS", ",", " ", 
     RowBox[{"{", "}"}], ",", " ", "1", ",", " ", "amplitudeVector", ",", " ",
      "1", ",", " ", 
     RowBox[{"0", "&"}], ",", " ", "\"\<StepPulseFluxRes.dat\>\"", ",", 
     RowBox[{"VerbosityLevel", "\[Rule]", "0"}]}], "]"}], "[", 
   RowBox[{"[", "3", "]"}], "]"}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->548272300],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 112},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->38542508]
}, Open  ]],

Cell[TextData[{
 "More details about the ",
 Cell[BoxData[
  ButtonBox["StepPulseFlux",
   BaseStyle->"Link",
   ButtonData->"paclet:LGSBloch/ref/StepPulseFlux"]], "InlineFormula"],
 " function are given in its usage message:"
}], "MathCaption",
 CellID->229066162],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "StepPulseFlux"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1488908507],

Cell[BoxData[
 StyleBox["\<\"Solve the time-dependent problem for periodic irradiation \
pattern and integrate flux return over the last period. Uses phiv[] to solve \
the inhomogeneous problem (d/dt)\[Rho] = A\[Rho]+\\!\\(\\*\\nStyleBox[\\\"b\\\
\",\\nFontSlant->\\\"Italic\\\"]\\) for piecewise constant \
coefficients.\\n\\nInput:\\n\\n\\!\\(\\*\\nStyleBox[\\\"syst\\\",\\nFontSlant-\
>\\\"Italic\\\"]\\): Bloch equation \
system\\n\\t\\n\\!\\(\\*\\nStyleBox[\\\"params\\\",\\nFontSlant->\\\"Italic\\\
\"]\\): Physical simulation parameters for \
PsiMeso[]\\n\\n\\!\\(\\*\\nStyleBox[\\\"nperiodsIn\\\",\\nFontSlant->\\\"\
Italic\\\"]\\): maximum number of periods to \
simulate\\n\\t\\n\\!\\(\\*\\nStyleBox[\\\"complexE\\\",\\nFontSlant->\\\"\
Italic\\\"]\\): Vector, subdividing the pulse into n subspans, scaling the \
irradiance in each subspan so that \
I\[LeftDoubleBracket]j\[RightDoubleBracket] == IMeso |complexE\
\[LeftDoubleBracket]j,2\[RightDoubleBracket]|^2, and Arg[complexE\
\[LeftDoubleBracket]j,2\[RightDoubleBracket]] is the optical phase at step j. \
The entries complexE\[LeftDoubleBracket]j,1\[RightDoubleBracket] contain the \
corresponding time steps relative to the beginning of the simulated period. \
Hence, complexE\[LeftDoubleBracket]-1,1\[RightDoubleBracket] equals the \
duration of the simulated period. The time steps do not have to be constant. \
Note that all time steps, including complexE\[LeftDoubleBracket]1,1\
\[RightDoubleBracket], must be larger than 0 and strictly \
increasing.\\n\\t\\n\\!\\(\\*\\nStyleBox[\\\"brightPeriodSkip\\\",\\\
nFontSlant->\\\"Italic\\\"]\\): Concentrate the light to every \
BrightPeriodSkip'th period (e.g., if brightPeriodSkip = 2, run every other \
period at twice the irradiance as when setting brightPeriodSkip = 1). Set \
brightPeriodSkip = 1 to make every period the \
same.\\n\\t\\n\\!\\(\\*\\nStyleBox[\\\"\[CapitalDelta]fLaserFunction\\\",\\\
nFontSlant->\\\"Italic\\\"]\\): \[CapitalDelta]fLaserFunction[] sets the \
laser central frequency offset as a function of \
time\\n\\t\\n\\!\\(\\*\\nStyleBox[\\\"fname\\\",\\nFontSlant->\\\"Italic\\\"]\
\\): File name to save the results structure \\\"res\\\" in, using \
Export[fname,res]\\n\\t\\n\\!\\(\\*\\nStyleBox[\\\"opts\\\",\\nFontSlant->\\\"\
Italic\\\"]\\): option set for PsiMeso[]\\n\\nOutput:\\n\\nGlobal`Res = \
{psiAvg, psiAvgTotal, psiSpanAll, psiAvgHist, Iavg, popgr8All, popex16All, \
{PhiVErrors \[Rule] errAll, PsiIavg \[Rule] psiIavg1, GroundPopulation \
\[Rule] popgr, ExcitedPopulation \[Rule] popex, FinalGroundPops \[Rule] \
groundPops, FinalExcitedPops \[Rule] excitedPops, ExcitedPops \[Rule] \
excitedPopsAll, LastDM \[Rule] {w, vg}, RFParamsOut \[Rule] {rfparams1, \
params1, opts}}}\\n\\n\\!\\(\\*\\nStyleBox[\\\"psiAvg\\\",\\nFontSlant->\\\"\
Italic\\\"]\\): Specific return flux averaged over the last period \
[ph/s/sr/atom/(W/m^2)]\\n\\n\\!\\(\\*\\nStyleBox[\\\"psiAvgTotal\\\",\\\
nFontSlant->\\\"Italic\\\"]\\): psiAvg summed over all periods \
[ph/s/sr/atom/(W/m^2)]\\n\\n\\!\\(\\*\\nStyleBox[\\\"psiSpanAll\\\",\\\
nFontSlant->\\\"Italic\\\"]\\): vector of pairs {tn, return flux(tn)}, return \
flux [ph/s/sr/atom/(W/m^2)]\\n\\n\\!\\(\\*\\nStyleBox[\\\"psiAvgHist\\\",\\\
nFontSlant->\\\"Italic\\\"]\\): vector of psiAvg values for each period\\n\\n\
\\!\\(\\*\\nStyleBox[\\\"Iavg\\\",\\nFontSlant->\\\"Italic\\\"]\\): \
Irradiance, averaged over a simulation period \
[W/m^2]\\n\\n\\!\\(\\*\\nStyleBox[\\\"popgr8All\\\",\\nFontSlant->\\\"Italic\\\
\"]\\): Array of dimension Nx8, where N equals the length of psiSpanAll and \
corresponds to the time steps given by psiSpanAll\[LeftDoubleBracket]All,1\
\[RightDoubleBracket]. The values of opgr8All yield the 8 ground state \
populations of the velocity class that is closest to +5 MHz, where in many \
systems a peak of the polarization is observed (\\\"busy velocity class\\\"), \
normalized by the total ground+excited state population in this velocity \
class. For darkness in equilibrium we thus have \
popgr8All\[LeftDoubleBracket]All,All\[RightDoubleBracket]==1/8. The states \
are ordered {(F=2,m=2), (F=2,m=1)..., (F=2,m=-2), (F=1,m=1), (F=1,m=0), \
(F=2,m=-1)} (with LightPolarization->+1, the (F=2,m=2) is pumped most \
strongly) popex16All: same as popgr8All, but for the 16 excited states. \
Sequence starts with (F=3,m=3).\\n\\n\\!\\(\\*\\nStyleBox[\\\"PhiVErrors\\\",\
\\nFontSlant->\\\"Italic\\\"]\\): vector of numerical errors returned by \
phiv[], corresponding to psiSpanAll psiIavg: value of psi for average \
irradiance\\n\\n\\!\\(\\*\\nStyleBox[\\\"popgr\\\",\\nFontSlant->\\\"Italic\\\
\"]\\): ground state \
population\\n\\n\\!\\(\\*\\nStyleBox[\\\"popex\\\",\\nFontSlant->\\\"Italic\\\
\"]\\): Excited state \
population\\n\\n\\!\\(\\*\\nStyleBox[\\\"w\\\",\\nFontSlant->\\\"Italic\\\"]\\\
): final solution vector (b)\\n\\nThe routine computes the average return \
flux psiAvg defined as\\n\\n   psiAvg = 1/(trep * Iavg) \
\\!\\(\\*SubsuperscriptBox[\\(\[Integral]\\), \\(t0\\), \\(t0\\\\  + \\\\ \
trep\\)]\\)Psi(t) dt, \\n\\n\\twhere Psi(t) is the instantaneous \
non-normalized return flux in ph/s/sr/atom, t0 is the begin of the last \
period, and Iavg = Ipulse*duty, where Ipulse is the pulse \
irradiance.\\n\\nThe iteration starts from thermal equilibrium (InitialState \
\[Rule] LightOff) or from the steady-state solution at Ipulse (InitialState \
\[Rule] LightOn) and stops once the difference of psiAvg between two \
subsequent iterations drops below some threshold. In the verbose simulation \
output, \\\"peak cw psi\\\" is the steady-state result psi(I_peak), and \
\\\"flux from avg irradiance\\\" is similarly psi(I_avg). To achieve \
convergence, allow for a total simulation time of several times 16ns. At low \
irradiance, you may have to simulate several collision time scales.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3714399609-3386978",
 CellID->476494153]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "MORE ABOUT", "TutorialMoreAboutSection", CellSize -> {5000, Inherited}],
      
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["LGSBloch Package",
 BaseStyle->"Link",
 ButtonData->"paclet:LGSBloch/guide/LGSBloch"]], "TutorialMoreAbout",
 CellID->186527365],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->925823761],

Cell["", "SectionFooterSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "RelatedTutorialsSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "RELATED TUTORIALS", "RelatedTutorialsSection", 
      CellSize -> {5000, Inherited}], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "Related Tutorials"}], "RelatedTutorialsSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->415694126],

Cell["", "SectionHeaderSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["Return Flux from a CW Laser Guide Star",
 BaseStyle->"Link",
 ButtonData->
  "paclet:LGSBloch/tutorial/ReturnFluxFromACWLaserGuideStar"]], \
"RelatedTutorials",
 CellID->1076242152],

Cell[TextData[ButtonBox["Integration Over the LGS Beam",
 BaseStyle->"Link",
 ButtonData->
  "paclet:LGSBloch/tutorial/IntegrationOverTheLGSBeam"]], "RelatedTutorials",
 CellID->2117868343],

Cell["", "SectionFooterSpacer",
 Editable->False,
 Selectable->False,
 Deletable->False,
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Return Flux from a Pulsed Laser Guide Star - Wolfram \
Mathematica",
PrivateNotebookOptions->{"FileOutlineCache"->False},
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2017, 9, 14, 18, 2, 12.4142707}", "context" -> "LGSBloch`", 
    "keywords" -> {}, "index" -> True, "label" -> "L G S Bloch Tutorial", 
    "language" -> "en", "paclet" -> "LGSBloch", "status" -> "None", "summary" -> 
    "In this tutorial we calculate the return flux from a sodium LGS with a \
pulsed laser. Function to calculate time-dependent return flux. Load the \
package.", "synonyms" -> {}, "title" -> 
    "Return Flux from a Pulsed Laser Guide Star", "type" -> "Tutorial", "uri" -> 
    "LGSBloch/tutorial/Return Flux from a Pulsed Laser Guide Star"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]

