Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
       "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
         "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
         "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", 
        "**"}], "*", "\n", "\n", "    ", "This", " ", "file", " ", "is", " ", 
       "part", " ", "of", " ", "the", " ", "LGSBloch", " ", "package", " ", 
       "for", " ", "Mathematica", "\n", "    ", "Copyright", " ", 
       RowBox[{"(", "C", ")"}], " ", "2009"}], "-", 
      RowBox[{"2017", " ", "\n", "    ", "Simon", " ", 
       RowBox[{"M", ".", " ", "Rochester"}]}]}], " ", "<", 
     RowBox[{
      RowBox[{"simon", "@", "rochesterscientific"}], ".", "com"}], ">", "\n", 
     "    ", 
     RowBox[{"Ron", " ", "Holzl\[ODoubleDot]hner"}], " ", "<", 
     RowBox[{
      RowBox[{"rholzloe", "[", "at", "]"}], 
      RowBox[{"eso", ".", "org"}]}], ">", "\n", "\n", "    ", 
     RowBox[{"This", " ", "program", " ", "is", " ", "free", " ", 
      RowBox[{"software", ":", " ", 
       RowBox[{"you", " ", "can", " ", "redistribute", " ", "it", " ", 
        RowBox[{"and", "/", "or"}], " ", "modify", "\n", "    ", "it", " ", 
        "under", " ", "the", " ", "terms", " ", "of", " ", "the", " ", "GNU", 
        " ", "General", " ", "Public", " ", "License", " ", "as", " ", 
        "published", " ", "by", "\n", "    ", "the", " ", "Free", " ", 
        "Software", " ", "Foundation"}]}]}]}], ",", " ", 
    RowBox[{
    "either", " ", "version", " ", "3", " ", "of", " ", "the", " ", 
     "License"}], ",", " ", 
    RowBox[{"or", "\n", "    ", 
     RowBox[{"(", 
      RowBox[{"at", " ", "your", " ", "option"}], ")"}], " ", "any", " ", 
     "later", " ", 
     RowBox[{"version", ".", "\n", "\n", "    ", "This"}], " ", "program", 
     " ", "is", " ", "distributed", " ", "in", " ", "the", " ", "hope", " ", 
     "that", " ", "it", " ", "will", " ", "be", " ", "useful"}], ",", "\n", 
    "    ", 
    RowBox[{
     RowBox[{"but", " ", "WITHOUT", " ", "ANY", " ", "WARRANTY"}], ";", " ", 
     RowBox[{
     "without", " ", "even", " ", "the", " ", "implied", " ", "warranty", " ",
       "of", "\n", "    ", "MERCHANTABILITY", " ", "or", " ", "FITNESS", " ", 
      "FOR", " ", "A", " ", "PARTICULAR", " ", 
      RowBox[{"PURPOSE", ".", "  ", "See"}], " ", "the", "\n", "    ", "GNU", 
      " ", "General", " ", "Public", " ", "License", " ", "for", " ", "more", 
      " ", 
      RowBox[{"details", ".", "\n", "\n", "    ", "You"}], " ", "should", " ",
       "have", " ", "received", " ", "a", " ", "copy", " ", "of", " ", "the", 
      " ", "GNU", " ", "General", " ", "Public", " ", "License", "\n", "    ",
       "along", " ", "with", " ", "this", " ", 
      RowBox[{"program", ".", "  ", "If"}], " ", "not"}]}], ",", " ", 
    RowBox[{
     RowBox[{"see", " ", "<", 
      RowBox[{"http", ":"}]}], "//", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"www", ".", "gnu", ".", "org"}], "/", "licenses"}], "/"}], 
      ">", "."}]}]}], "\n", "\n", 
   "**************************************************************************)"}\
], "\n"}]], "Code"],

Cell[CellGroupData[{

Cell["LGSBloch", \
"Title"],

Cell[CellGroupData[{

Cell["Reference", \
"Section"],

Cell[CellGroupData[{

Cell["Title", \
"Subsection"],

Cell["LGSBloch.m", \
"Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Authors", \
"Subsection"],

Cell["\<\
Simon Rochester (simon[at]rochesterscientific.com) and Ron \
Holzl\[ODoubleDot]hner (rholzloe[at]eso.org)\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Summary", \
"Subsection"],

Cell["\<\
Bloch equation simulation code to model the return flux from sodium laser \
guide stars (LGS)\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Copyright", \
"Subsection"],

Cell["\<\
\[Copyright] Copyright 2009--2017, Simon Rochester, Ron \
Holzl\[ODoubleDot]hner
This software is under the GNU Public License, see \
http://www.gnu.org/licenses/gpl.html

DISCLAIMER:
No responsibility will be taken for the use of any information found in this \
software whatsoever. It is not fit for any particular purpose of any kind. In \
particular, the information found in this software is not to be construed as \
an official publication or opinion of the institutions that the authors work \
for or have been working for.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " version"
}], "Subsection"],

Cell["7.0+", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Keywords", \
"Subsection"],

Cell["\<\
Sodium laser guide stars, Bloch equations, fluorescence, Larmor precession\
\>", "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Interface", \
"Section"],

Cell[CellGroupData[{

Cell["Begin package context", \
"Subsection"],

Cell[BoxData[
 RowBox[{"BeginPackage", "[", 
  RowBox[{"\"\<LGSBloch`\>\"", ",", 
   RowBox[{"{", "\"\<AtomicDensityMatrix`\>\"", "}"}]}], "]"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{"Get", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{"Unprotect", "[", 
  RowBox[{"Evaluate", "[", 
   RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}]], "Input",
 InitializationCell->
  True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Usage messages", \
"Subsection"],

Cell[CellGroupData[{

Cell["Bloch", \
"Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"bendList", "::", "usage"}], "=", "\"\<\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"nWeightFunction", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SparseReplace", "::", "usage"}], "=", "\"\<SparseReplace[\!\(\*
StyleBox[\"expr\", \"TI\"]\),\!\(\*
StyleBox[\"rules\", \"TI\"]\)] generalizes ReplaceAll to apply to elements of \
a SparseArray.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SelfReplaceRepeated", "::", "usage"}], "=", 
   "\"\<SelfReplaceRepeated[\!\(\*
StyleBox[\"rules\", \"TI\"]\)] repeatedly performs replacement on itself, \
transforming the right-hand sides of the rules until they no longer change.\>\
\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GenerateLGSSystem", "::", "usage"}], "=", 
   "\"\<GenerateLGSSystem[\!\(\*
StyleBox[\"atom\", \"TI\"]\), \!\(\*
StyleBox[\"line\", \"TI\"]\)] returns a list of data describing the specified \
atomic system suitable for use as the first parameter of a ReturnFlux call. \
Generally useful elements of the list include the first element, which is the \
dimension of the Bloch matrix (algebraic system) describing a particular \
region and velocity group, and the last element, which is a list of rules \
giving numerical values for various atomic parameters. It may be convenient \
to save the result of this function using Export[] and then Get[] it at the \
beginning of each session.\nGenerateLGSSystem[] is equivalent to \
GenerateLGSSystem[\\\"Na\\\",\\\"D2\\\"].\n\n\!\(\*
StyleBox[\"atom\", \"TI\"]\) and \!\(\*
StyleBox[\"line\", \"TI\"]\) are strings; possible values for \!\(\*
StyleBox[\"atom\", \"TI\"]\) are \\\"Na\\\", \\\"K39\\\", \\\"Rb87\\\", \
\\\"Rb85\\\", and \\\"Cs\\\", and possible values for \!\(\*
StyleBox[\"line\", \"TI\"]\) are \\\"D1\\\" and \\\"D2\\\". \n\nOptions: \
PrintDiagnostics, NeglectHyperfineCoherences, \
NeglectExcitedStateMixing.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrintDiagnostics", "::", "usage"}], "=", 
   "\"\<PrintDiagnostics is an option for GenerateLGSSystem that specifies \
whether to print the results of various intermediate steps during \
execution.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NeglectHyperfineCoherences", "::", "usage"}], "=", 
   "\"\<NeglectHyperfineCoherences is an option for GenerateLGSSystem that \
specifies whether to set all ground- and excited- state hyperfine coherences \
to zero in order to reduce the size of the algebraic system.\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NeglectExcitedStateMixing", "::", "usage"}], "=", 
   "\"\<NeglectExcitedStateMixing is an option for GenerateLGSSystem that \
specifies whether to neglect magnetic-field-induced mixing of excited-state \
hyperfine sublevels.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UseBreitRabi", "::", "usage"}], "=", 
   "\"\<UseBreitRabi is an option for GenerateLGSSystem that specifies \
whether to use the BreitRabi formula to describe nonlinear Zeeman shifts in \
the ground state.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDither", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Number of regions to be used for the \
dithering simulation.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DitherRate", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Transit rate between dithering regions \
(\!\(\*SuperscriptBox[\(s\), \(-1\)]\)).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DitherDetuning", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: List specifying light detunings for each \
dithering region (rad/s).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LightPhase", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: List specifying light phase for each \
dithering region.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ModeDetuning", "::", "usage"}], "=", "\"\<\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LaserWidth", "::", "usage"}], "=", "\"\<\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DitherRateFraction", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DitherCoherenceTransfer", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Fraction of optical coherences to \
transfer when atoms travel between dithering regions.\>\""}], ";"}]], "Input",
 
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EllipticityA", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Polarization ellipticity angle for the A \
beam.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DetuningA", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Light detuning for the A beam \
(rad/s).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LightIntensityA", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Light intensity for the A beam (watt/\!\(\
\*SuperscriptBox[\(m\), \(2\)]\))\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RabiFrequencyA", "::", "usage"}], "=", 
   "\"\<Rabi frequency for the A beam (rad/s).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EllipticityB", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Polarization ellipticity angle for the B \
beam.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DetuningB", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Light detuning for the B beam \
(rad/s).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LightIntensityB", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Light intensity for the B beam (watt/\!\(\
\*SuperscriptBox[\(m\), \(2\)]\))\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RabiFrequencyB", "::", "usage"}], "=", 
   "\"\<Rabi frequency for the B beam (rad/s).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{"AtomicDensity", "::", "usage"}], "=", 
    "\"\<ReturnFlux input parameter: Atomic density \
(atoms/\!\(\*SuperscriptBox[\(m\), \(3\)]\)).\>\""}], ";"}], "*)"}]], "Input",
 
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BeamTransitRate", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Rate of transit of atoms through the \
light beam (\!\(\*SuperscriptBox[\(s\), \(-1\)]\)).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SDampingRate", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Overall S-damping rate \
(\!\(\*SuperscriptBox[\(s\), \(-1\)]\)).\>\""}], " ", ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VccRateFunction", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Cumulative distribution function of rate \
of velocity-changing collisions. VccRateFunction[\[CapitalDelta]1,\
\[CapitalDelta]2] gives the rate of transfer of atoms with Doppler shift \
\[CapitalDelta]1 into velocity groups with Doppler shifts less than \
\[CapitalDelta]2 (\!\(\*SuperscriptBox[\(s\), \(-1\)]\)).\>\""}], " ", 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RMSVelocity", "::", "usage"}], "=", 
   "\"\<Atomic rms velocity (m/s).\>\""}], " ", ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Temperature", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: System temperature in degrees \
Kelvin.\>\""}], " ", ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ResonanceFrequencies", "::", "usage"}], "=", 
   "\"\<List of possible optical resonance frequencies for the atomic system \
(rad/s).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DopplerWidth", "::", "usage"}], "=", 
   "\"\<Doppler width of the atomic thermal distribution (rad/s).\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LarmorFrequency", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Larmor frequency of the highest angular \
momentum hyperfine ground state (rad/s).\>\""}], " ", ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticZenith", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Zenith angle of the magnetic field in the \
local coordinate system, where the laser points at +z (angle between B and \
z). MagneticZenith = 0 corresponds to the B-field pointing along the laser \
propagation direction. CAUTION: The geomagnetic field points from \
geographicSouth to North! This means e.g. that MagneticZenith cannot become 0 \
in the northern magnetic hemisphere unless the laser is pointing towards the \
ground\>\""}], " ", ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticAzimuth", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Azimuthal angle of the magnetic field \
(angle between x and the projection of B on the x-y plane).\>\""}], " ", 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RecoilShift", "::", "usage"}], "=", 
   "\"\<ReturnFlux input parameter: Doppler shift corresponding to the atomic \
recoil velocity (rad/s).\>\""}], " ", ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DitherRegionFraction", "::", "usage"}], "=", 
   "\"\<DitherRegionFraction[\!\(\*
StyleBox[\"i\", \"TI\"]\)] represents the fraction of atoms present in \
dithering region \!\(\*
StyleBox[\"i\", \"TI\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ViewPhi", "::", "usage"}], "=", "\"\<\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ViewTheta", "::", "usage"}], "=", "\"\<\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VGDensity", "::", "usage"}], "=", "\"\<VGDensity[\!\(\*
StyleBox[\"i\", \"TI\"]\)] represents the fraction of atoms in the velocity \
group \!\(\*
StyleBox[\"i\", \"TI\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DopplerShift", "::", "usage"}], "=", "\"\<DopplerShift[\!\(\*
StyleBox[\"i\", \"TI\"]\)] represents the Doppler shift for atoms in the \
velocity group \!\(\*
StyleBox[\"i\", \"TI\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VelocityGroups1", "::", "usage"}], "=", 
   "\"\<VelocityGroups1 returns a list of velocity bins formed using one \
(small) bin size near a resonance frequency and another (larger) bin size \
away from any resonance frequencies.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VelocityGroups2", "::", "usage"}], "=", 
   "\"\<VelocityGroups2 returns a list of velocity bins found by dividing the \
integral of a supplied weighting function evenly into a specified number of \
bins.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VccRate", "::", "usage"}], "=", "\"\<\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{"ShowPlot", "::", "usage"}], "=", 
    "\"\<ShowPlot is an option for the VelocityGroups functions that \
specifies whether to generate a plot of the list of velocity groups returned \
by the function.\>\""}], ";"}], "*)"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ReturnFlux", "::", "usage"}], "=", "\"\<ReturnFlux[\!\(\*
StyleBox[\"system\", \"TI\"]\), \!\(\*
StyleBox[\"params\", \"TI\"]\)] returns the result of a calculation of \
observed fluorescence for the atomic and experimental system described by \
\!\(\*
StyleBox[\"system\", \"TI\"]\) (as given by the output of GenerateLGSSystem), \
using experimental paramters specified by \!\(\*
StyleBox[\"params\", \"TI\"]\). Additional output information can be \
requested using the FluxReport option. A list of velocity group bins is \
automatically created using the parameters specified with the option \
InitVGParams; if the option RefineResult is specified the calculation will be \
run multiple times, refining the velocity bins on successive runs.\n\
ReturnFlux[\!\(\*
StyleBox[\"system\", \"TI\"]\), \!\(\*
StyleBox[\"params\", \"TI\"]\), \!\(\*
StyleBox[\"bins\", \"TI\"]\)] does the first run of the calculation using the \
supplied list of velocity bins \!\(\*
StyleBox[\"bins\", \"TI\"]\).\n\nThe input \!\(\*
StyleBox[\"params\", \"TI\"]\) must contain the parameters NDither, \
DitherRate, DitherDetuning, LightPhase, DitherCoherenceTransfer, \
EllipticityA, DetuningA, LightIntensityA, EllipticityB, DetuningB, \
LightIntensityB, AtomicDensity, BeamTransitRate, SDampingRate, VccRate, \
Temperature, LarmorFrequency, MagneticZenith, MagneticAzimuth, RecoilShift.\n\
\nOptions: FluxReport, RefineResult, InitVGParams, ReturnAllSteps, \
PlotVelocityGroups\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FluxReport", "::", "usage"}], "=", 
   "\"\<FluxReport is an option for ReturnFlux that specifies addtional \
information to be returned as a list of replacement values.\nA list should be \
specified, contaning zero or more of the following elements:\n\
VelocitySpectrum: Returns a list giving the contribution to the flux from \
each velocity group.\nVelocityGroups: Returns the list of velocity bins used \
in the calculation.\nDMSolution: Returns the computed values of the density \
matrix elements for each velocity group and dithering region.\nBlochMatrix: \
Returns a list of the full matrix that was generated and solved, the RHS \
vector, and the vector that was dotted with the solution vector to find the \
total flux. \nRFParams: Return the parameter set of ReturnFlux[] (internal \
use)\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SkipLinearSolve", "::", "usage"}], " ", "=", "\n", 
   "\"\<SkipLinearSolve is an option for ReturnFlux that specifies if the \
linear Bloch equation system should be solved, or if the solution should be \
skipped, and only the Bloch matrices should be prepared for the FluxReport. \
For internal use.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RefineResult", "::", "usage"}], "=", 
   "\"\<RefineResult is an option for ReturnFlux that specifies whether the \
calculation should be repeated using the preliminary results to refine the \
list of velocity bins. If a list {\!\(\*SubscriptBox[
StyleBox[\"i\", \"TI\"], \"1\"]\),\!\(\*SubscriptBox[
StyleBox[\"i\", \"TI\"], \"2\"]\)...\!\(\*
StyleBox[SubscriptBox[\"i\", \"n\"], \"TI\"]\)} of integers \!\(\*
StyleBox[SubscriptBox[\"i\", \"j\"], \"TI\"]\) is specified, the calculation \
is run \!\(\*
StyleBox[\"n\", \"TI\"]\) times after the initial run, each time using the \
velocity spectrum obtained from the previous run to create a weighting \
function used to generate a list of \!\(\*
StyleBox[SubscriptBox[\"i\", \"j\"], \"TI\"]\) velocity bins. The option \
ReturnAllSteps can be used to specify whether the results of all calculations \
should be returned, or just the last.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InitVGParams", "::", "usage"}], "=", 
   "\"\<InitVGParams is an option for ReturnFlux that specifies the \
parameters used to generate the velocity group bins for the first run of the \
calculation. Velocities are specified in terms of their corresponding Doppler \
shift. The option is specified in the form {{\!\(\*
StyleBox[SubscriptBox[\"width\", \"res\"], \"TI\"]\),\!\(\*
StyleBox[SubscriptBox[\"n\", \"res\"], \"TI\"]\)},{\!\(\*
StyleBox[SubscriptBox[\"width\", \"nonres\"], \"TI\"]\),\!\(\*
StyleBox[SubscriptBox[\"range\", \"nonres\"], \"TI\"]\)}}, where \!\(\*
StyleBox[SubscriptBox[\"width\", \"res\"], \"TI\"]\) is the width of bins to \
be created near resonance frequencies (in units of the natural width), \!\(\*
StyleBox[SubscriptBox[\"n\", \"res\"], \"TI\"]\) specifies that 2\!\(\*
StyleBox[SubscriptBox[\"n\", \"res\"], \"TI\"]\)+1 bins should be created \
near each resonance frequency, \!\(\*
StyleBox[SubscriptBox[\"width\", \"nonres\"], \"TI\"]\) is the width of bins \
not near resonance frequencies (in units of the Doppler width), and \!\(\*
StyleBox[SubscriptBox[\"range\", \"nonres\"], \"TI\"]\) (units of the Doppler \
width) gives the half-range over which velocity bins should be \
generated.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ReturnAllSteps", "::", "usage"}], "=", 
   "\"\<ReturnAllSteps is an option for ReturnFlux that specifies whether the \
results of all iterations (specified using RefineResult) should be returned, \
or just the last.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PlotVelocityGroups", "::", "usage"}], "=", 
   "\"\<PlotVelocityGroups is an option for ReturnFlux that specifies whether \
diagnostic plots showing the generated velocity bins should be shown during \
execution.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VelocitySpectrum", "::", "usage"}], "=", 
   "\"\<VelocitySpectrum is a value that can be specified by the FluxReport \
option of ReturnFlux to request a list giving the contribution to the flux \
from each velocity group.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VelocityGroups", "::", "usage"}], "=", 
   "\"\<VelocityGroups is a value that can be specified by the FluxReport \
option of ReturnFlux to request the list of velocity bins used in the \
calculation.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DMSolution", "::", "usage"}], "=", 
   "\"\<DMSolution is a value that can be specified by the FluxReport option \
of ReturnFlux to request the computed values of the density matrix elements \
for each velocity group and dithering region.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BlochMatrix", "::", "usage"}], "=", 
   "\"\<BlochMatrix is a value that can be specified by the FluxReport option \
of ReturnFlux to request a list of the full matrix that was generated and \
solved, the RHS vector, and the vector that was dotted with the solution \
vector to find the total flux.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RFParams", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<RFParams is the parameter set of ReturnFlux[]. For internal use in \
StepPulseFlux[].\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{"InitVG", "::", "usage"}], "=", "\"\<\>\"", " "}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{"PulsedSetup", "::", "usage"}], "=", "\"\<\>\"", " "}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{"FlipDoppler", "::", "usage"}], "=", "\"\<\>\"", " "}]], "Input",
 InitializationCell->
  True]
}, Open  ]],

Cell[CellGroupData[{

Cell["LGS Constants and Default Parameters", \
"Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BGParanal", "::", "usage"}], "=", 
   "\"\<BGParanal is a constant giving the geomagnetic field in Paranal at \
altitude 90km in 2009 [G] from [MSIS90].\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BGSOR", "::", "usage"}], "=", 
   "\"\<BGSOR is a constant giving the geomagnetic field at SOR at altutude \
90km in 2009 [G] from [MSIS90].\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BGWendelstein", "::", "usage"}], "=", 
   "\"\<BGWendelstein is a constant giving the geomagnetic field over \
Wendelstein at altutude 90km in 2009 [G] from [MSIS90].\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BGMaunaKea", "::", "usage"}], "=", 
   "\"\<BGMaunaKea is a constant giving the geomagnetic field over Mauna Kea \
at altutude 90km in 2009 [G] from [MSIS90].\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalOmega]NaRecoil", "::", "usage"}], "=", 
   "\"\<\[CapitalOmega]NaRecoil is a constant giving the recoil frequency of \
sodium atoms at 589nm [Hz].\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fOffsetD2a", "::", "usage"}], "=", 
   "\"\<fOffsetD2a is a constant giving the offset of the Na D2a line from \
the D2 line center [Hz]. Do not alter this parameter when varying the laser \
central frequency, but use \[CapitalDelta]fLaser instead.\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fOffsetD2ab", "::", "usage"}], "=", 
   "\"\<fOffsetD2ab is a constant giving the optimal frequency offset between \
Na D2a and D2b in sodium [Hz]. Normally, this constant should not be altered. \
Use \[CapitalDelta]fLaserDabOff to vary to repumping frequency offset.\>\""}],
   ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"IMeso", "::", "usage"}], "=", 
   "\"\<IMeso represents mesospheric laser intensity \!\(\*FormBox[
RowBox[{
RowBox[{\"[\", 
RowBox[{
StyleBox[\"W\",
FontSlant->\"Plain\"], \"/\", SuperscriptBox[
StyleBox[\"m\",
FontSlant->\"Plain\"], \"2\"]}], \"]\"}], \".\"}],
TraditionalForm]\)\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RepumpFraction", "::", "usage"}], "=", 
   "\"\<RepumpFraction represents the repumping intensity fraction (fraction \
of total laser power in D2b line).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LightPolarization", "::", "usage"}], "=", 
   "\"\<LightPolarization represents the normalized light ellipticity angle (\
\[Epsilon]/(\[Pi]/4)).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LightWavelength", "::", "usage"}], "=", 
   "\"\<LightWavelength represents the laser center wavelength [m].\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Phase", "::", "usage"}], "=", 
   "\"\<Phase represents overall light phase [rad].\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FWHMbw", "::", "usage"}], "=", 
   "\"\<FWHMbw represents the Laser FWHM bandwidth, assuming a Lorentzian \
lineshape [Hz].\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalDelta]fLaser", "::", "usage"}], "=", 
   "\"\<\[CapitalDelta]fLaser represents the laser line detuning from optimum \
(both D2a and D2b) [Hz]. Use this parameter to vary the laser line frequency \
offset. Positive values shift to the blue (higher frequency).\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalDelta]fLaserDabOff", "::", "usage"}], "=", 
   "\"\<\[CapitalDelta]fLaserDabOff represents the offset of D2a--D2b \
frequency spacing from fOffsetD2ab [Hz]. Positive values shift to the blue \
(higher frequency).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BG", "::", "usage"}], "=", 
   "\"\<BG represents the mesospheric geomagnetic field strength \!\(\*FormBox[
RowBox[{\"[\", 
StyleBox[\"G\",
FontSlant->\"Plain\"], \"]\"}],
TraditionalForm]\).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ta", "::", "usage"}], "=", 
   "\"\<Ta represents the one-way atmospheric light transmission at \[Lambda] \
at zenith.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SDampingTime", "::", "usage"}], "=", 
   "\"\<SDampingTime represents the mean time between S-damping collisions \
[s].\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VccTime", "::", "usage"}], "=", 
   "\"\<VccTime represents the mean time between velocity-changing collisions \
[s].\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HNa", "::", "usage"}], "=", 
   "\"\<HNa represents the altitude of sodium centroid above sea level [m].\>\
\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"vrms\[Gamma]", "::", "usage"}], "=", 
   "\"\<vrms\[Gamma] represents the rms velocity of diffusion effects [m/s], \
\[Gamma] = vrms\[Gamma]/(DLT/\[Mu]LT).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PLaunch", "::", "usage"}], "=", 
   "\"\<PLaunch represents the launched power (output of launch telescope, \
not power on sky) [W].\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Zenith", "::", "usage"}], "=", 
   "\"\<Zenith represents the Zenith angle of the laser beam [rad].\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Htele", "::", "usage"}], "=", 
   "\"\<Htele represents the altitude of launch telescope above sea level \
[m].\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DLT", "::", "usage"}], "=", 
   "\"\<DLT represents the launch telescope aperture [m].\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[Mu]LT", "::", "usage"}], "=", 
   "\"\<\[Mu]LT represents the ratio of DLT to \
\!\(TraditionalForm\`1/\*SuperscriptBox[\(e\), \(2\)]\) launch beam intensity \
diameter (not radius!), see Yura, Eq.(2.7).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MsqrLT", "::", "usage"}], "=", 
   "\"\<MsqrLT represents the \!\(TraditionalForm\`\*SuperscriptBox[\(M\), \
\(2\)]\\\ beam\\\ quality\\\ factor\\\ out\\\ of\\\ the\\\ launch\\\ \
telescope\).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"IMesoMax", "::", "usage"}], "=", 
   "\"\<IMesoMax is an option for BeamRepository and related functions that \
specfies the maximum intensity in mesosphere [\!\(\*
StyleBox[\"W\",
FontSlant->\"Plain\"]\)/\!\(\*SuperscriptBox[
StyleBox[\"m\",
FontSlant->\"Plain\"], \"2\"]\)]. If set to zero it is determined \
automatically.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"IMesoInitial", "::", "usage"}], "=", 
   "\"\<IMesoInitial is an option for BeamRepository and related functions \
that specifies the starting mesospheric laser intensity \!\(\*FormBox[
RowBox[{
RowBox[{
StyleBox[\"[\",
FontSlant->\"Plain\"], 
RowBox[{
StyleBox[\"W\",
FontSlant->\"Plain\"], \"/\", SuperscriptBox[
StyleBox[\"m\",
FontSlant->\"Plain\"], \"2\"]}], \"]\"}], \".\"}],
TraditionalForm]\)\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaxStepRatio", "::", "usage"}], "=", 
   "\"\<MaxStepRatio is an option for BeamRepository and related functions \
that controls the intensity step size.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"IMesoFactor", "::", "usage"}], "=", 
   "\"\<IMesoFactor is an option for BeamRepository and related functions \
that specifies the factor by which to multiply peak intensity to compute \
maximum repository intensity.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NSamples", "::", "usage"}], "=", 
   "\"\<NSamples is an option for BeamRepository and related functions that \
specifies the number of samples in the repository.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LaserSpotMesoFWHM", "::", "usage"}], "=", 
   "\"\<LaserSpotMesoFWHM is an option for sce and interBeamMeso that equals \
the FWHM laser spot size in the mesosphere. This option is especially useful \
when computing sce for pulsed lasers, where the peak irradiance cannot be \
computed from the average power.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"$DefaultLGSParameters", "::", "usage"}], "=", 
   "\"\<$DefaultLGSParameters is a global variable that is the default for \
the DefaultParameters option for PsiMeso and related functions.\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NaLGSDefaults", "::", "usage"}], "=", 
   "\"\<NaLGSDefaults is a constant giving a list of default parameters for a \
Na D2 laser guide star.\>\""}], ";"}]], "Input",
 InitializationCell->
  True]
}, Open  ]],

Cell[CellGroupData[{

Cell["PsiMeso", \
"Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PsiMeso", "::", "usage"}], "=", "\"\<\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefaultParameters", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["End package context", \
"Subsection"],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Input",
 InitializationCell->
  True]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{808, 751},
WindowMargins->{{316, Automatic}, {Automatic, 50}},
PrivateNotebookOptions->{"FileOutlineCache"->False,
"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
FrontEndVersion -> "6.0",
StyleDefinitions->"Default.nb",
$CellContext`TrackCellChangeTimes -> False
]

