Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
       "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
         "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
         "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", 
        "**"}], "*", "\n", "\n", "    ", "This", " ", "file", " ", "is", " ", 
       "part", " ", "of", " ", "the", " ", "LGSBloch", " ", "package", " ", 
       "for", " ", "Mathematica", "\n", "    ", "Copyright", " ", 
       RowBox[{"(", "C", ")"}], " ", "2009"}], "-", 
      RowBox[{"2017", " ", "\n", "    ", "Simon", " ", 
       RowBox[{"M", ".", " ", "Rochester"}]}]}], " ", "<", 
     RowBox[{
      RowBox[{"simon", "@", "rochesterscientific"}], ".", "com"}], ">", "\n", 
     "    ", 
     RowBox[{"Ron", " ", "Holzl\[ODoubleDot]hner"}], " ", "<", 
     RowBox[{
      RowBox[{"rholzloe", "[", "at", "]"}], 
      RowBox[{"eso", ".", "org"}]}], ">", "\n", "\n", "    ", 
     RowBox[{"This", " ", "program", " ", "is", " ", "free", " ", 
      RowBox[{"software", ":", " ", 
       RowBox[{"you", " ", "can", " ", "redistribute", " ", "it", " ", 
        RowBox[{"and", "/", "or"}], " ", "modify", "\n", "    ", "it", " ", 
        "under", " ", "the", " ", "terms", " ", "of", " ", "the", " ", "GNU", 
        " ", "General", " ", "Public", " ", "License", " ", "as", " ", 
        "published", " ", "by", "\n", "    ", "the", " ", "Free", " ", 
        "Software", " ", "Foundation"}]}]}]}], ",", " ", 
    RowBox[{
    "either", " ", "version", " ", "3", " ", "of", " ", "the", " ", 
     "License"}], ",", " ", 
    RowBox[{"or", "\n", "    ", 
     RowBox[{"(", 
      RowBox[{"at", " ", "your", " ", "option"}], ")"}], " ", "any", " ", 
     "later", " ", 
     RowBox[{"version", ".", "\n", "\n", "    ", "This"}], " ", "program", 
     " ", "is", " ", "distributed", " ", "in", " ", "the", " ", "hope", " ", 
     "that", " ", "it", " ", "will", " ", "be", " ", "useful"}], ",", "\n", 
    "    ", 
    RowBox[{
     RowBox[{"but", " ", "WITHOUT", " ", "ANY", " ", "WARRANTY"}], ";", " ", 
     RowBox[{
     "without", " ", "even", " ", "the", " ", "implied", " ", "warranty", " ",
       "of", "\n", "    ", "MERCHANTABILITY", " ", "or", " ", "FITNESS", " ", 
      "FOR", " ", "A", " ", "PARTICULAR", " ", 
      RowBox[{"PURPOSE", ".", "  ", "See"}], " ", "the", "\n", "    ", "GNU", 
      " ", "General", " ", "Public", " ", "License", " ", "for", " ", "more", 
      " ", 
      RowBox[{"details", ".", "\n", "\n", "    ", "You"}], " ", "should", " ",
       "have", " ", "received", " ", "a", " ", "copy", " ", "of", " ", "the", 
      " ", "GNU", " ", "General", " ", "Public", " ", "License", "\n", "    ",
       "along", " ", "with", " ", "this", " ", 
      RowBox[{"program", ".", "  ", "If"}], " ", "not"}]}], ",", " ", 
    RowBox[{
     RowBox[{"see", " ", "<", 
      RowBox[{"http", ":"}]}], "//", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"www", ".", "gnu", ".", "org"}], "/", "licenses"}], "/"}], 
      ">", "."}]}]}], "\n", "\n", 
   "**************************************************************************)"}\
], "\n"}]], "Code"],

Cell[CellGroupData[{

Cell["StepwiseConstantSolver", \
"Title"],

Cell[CellGroupData[{

Cell["Reference", \
"Section"],

Cell[CellGroupData[{

Cell["Title", \
"Subsection"],

Cell["StepwiseConstantSolver.m", \
"Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Authors", \
"Subsection"],

Cell["\<\
Simon Rochester (simon[at]rochesterscientific.com) and Ron \
Holzl\[ODoubleDot]hner (rholzloe[at]eso.org)\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Summary", \
"Subsection"],

Cell["\<\
Time dependent solvers for laser guide star Bloch equation simulation\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Copyright", \
"Subsection"],

Cell["\<\
\[Copyright] Copyright 2009--2017, Simon Rochester, Ron \
Holzl\[ODoubleDot]hner
This software is under the GNU Public License, see \
http://www.gnu.org/licenses/gpl.html

DISCLAIMER:
No responsibility will be taken for the use of any information found in this \
software whatsoever. It is not fit for any particular purpose of any kind. In \
particular, the information found in this software is not to be construed as \
an official publication or opinion of the institutions that the authors work \
for or have been working for.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Notebook Version", \
"Subsection"],

Cell["Version 29Aug2017", \
"Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " version"
}], "Subsection"],

Cell["7.0+", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Keywords", \
"Subsection"],

Cell["\<\
Sodium laser guide stars, Bloch equations, fluorescence, Larmor precession\
\>", "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Interface", \
"Section"],

Cell["This part declares publicly visible symbols.", \
"Text"],

Cell[CellGroupData[{

Cell["Begin package context", \
"Subsection"],

Cell[BoxData[
 RowBox[{"BeginPackage", "[", 
  RowBox[{"\"\<LGSBloch`StepwiseConstantSolver`\>\"", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<AtomicDensityMatrix`\>\"", ",", " ", "\"\<LGSBloch`\>\""}], 
    "}"}]}], "]"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{"Get", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{"Unprotect", "[", 
  RowBox[{"Evaluate", "[", 
   RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}]], "Input",
 InitializationCell->
  True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Usage messages", \
"Subsection"],

Cell[CellGroupData[{

Cell["StepPulseFlux", \
"Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"phiv", "::", "usage"}], "=", 
  "\"\<[w, err] = phiv( t, A, u, v, tol, m )\n phiv computes an approximation \
of w = exp(t*A)*v + t*phi(t*A)*u\n for a general matrix A using Krylov \
subspace projection techniques.\n Here, phi(z) = (exp(z)-1)/z and w is the \
solution of the \n nonhomogeneous linear ODE problem w' = Aw + u, w(0) = v.\n \
It does not compute the matrix functions in isolation but instead,\n it \
computes directly the action of these functions on the \n operand vectors. \
This way of doing so allows for addressing large\n sparse problems. The \
matrix under consideration interacts only\n via matrix-vector products \
(matrix-free method).\>\"", " "}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{"VerbosityLevel", "::", "usage"}], "=", "\"\<\>\"", " "}]], "Input",
 
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StepPulseFlux", "::", "usage"}], "=", 
   "\"\<Solve the time-dependent problem for periodic irradiation pattern and \
integrate flux return over the last period. Uses phiv[] to solve the \
inhomogeneous problem (d/dt)\[Rho] = A\[Rho]+\!\(\*
StyleBox[\"b\",
FontSlant->\"Italic\"]\) for piecewise constant coefficients.\n\nInput:\n\n\!\
\(\*
StyleBox[\"syst\",
FontSlant->\"Italic\"]\): Bloch equation system\n\t\n\!\(\*
StyleBox[\"params\",
FontSlant->\"Italic\"]\): Physical simulation parameters for PsiMeso[]\n\n\
\!\(\*
StyleBox[\"nperiodsIn\",
FontSlant->\"Italic\"]\): maximum number of periods to simulate\n\t\n\!\(\*
StyleBox[\"complexE\",
FontSlant->\"Italic\"]\): Vector, subdividing the pulse into n subspans, \
scaling the irradiance in each subspan so that I\[LeftDoubleBracket]j\
\[RightDoubleBracket] == IMeso |complexE\[LeftDoubleBracket]j,2\
\[RightDoubleBracket]|^2, and Arg[complexE\[LeftDoubleBracket]j,2\
\[RightDoubleBracket]] is the optical phase at step j. The entries complexE\
\[LeftDoubleBracket]j,1\[RightDoubleBracket] contain the corresponding time \
steps relative to the beginning of the simulated period. Hence, complexE\
\[LeftDoubleBracket]-1,1\[RightDoubleBracket] equals the duration of the \
simulated period. The time steps do not have to be constant. Note that all \
time steps, including complexE\[LeftDoubleBracket]1,1\[RightDoubleBracket], \
must be larger than 0 and strictly increasing.\n\t\n\!\(\*
StyleBox[\"brightPeriodSkip\",
FontSlant->\"Italic\"]\): Concentrate the light to every BrightPeriodSkip'th \
period (e.g., if brightPeriodSkip = 2, run every other period at twice the \
irradiance as when setting brightPeriodSkip = 1). Set brightPeriodSkip = 1 to \
make every period the same.\n\t\n\!\(\*
StyleBox[\"\[CapitalDelta]fLaserFunction\",
FontSlant->\"Italic\"]\): \[CapitalDelta]fLaserFunction[] sets the laser \
central frequency offset as a function of time\n\t\n\!\(\*
StyleBox[\"fname\",
FontSlant->\"Italic\"]\): File name to save the results structure \\\"res\\\" \
in, using Export[fname,res]\n\t\n\!\(\*
StyleBox[\"opts\",
FontSlant->\"Italic\"]\): option set for PsiMeso[]\n\nOutput:\n\nGlobal`Res = \
{psiAvg, psiAvgTotal, psiSpanAll, psiAvgHist, Iavg, popgr8All, popex16All, \
{PhiVErrors \[Rule] errAll, PsiIavg \[Rule] psiIavg1, GroundPopulation \
\[Rule] popgr, ExcitedPopulation \[Rule] popex, FinalGroundPops \[Rule] \
groundPops, FinalExcitedPops \[Rule] excitedPops, ExcitedPops \[Rule] \
excitedPopsAll, LastDM \[Rule] {w, vg}, RFParamsOut \[Rule] {rfparams1, \
params1, opts}}}\n\n\!\(\*
StyleBox[\"psiAvg\",
FontSlant->\"Italic\"]\): Specific return flux averaged over the last period \
[ph/s/sr/atom/(W/m^2)]\n\n\!\(\*
StyleBox[\"psiAvgTotal\",
FontSlant->\"Italic\"]\): psiAvg summed over all periods \
[ph/s/sr/atom/(W/m^2)]\n\n\!\(\*
StyleBox[\"psiSpanAll\",
FontSlant->\"Italic\"]\): vector of pairs {tn, return flux(tn)}, return flux \
[ph/s/sr/atom/(W/m^2)]\n\n\!\(\*
StyleBox[\"psiAvgHist\",
FontSlant->\"Italic\"]\): vector of psiAvg values for each period\n\n\!\(\*
StyleBox[\"Iavg\",
FontSlant->\"Italic\"]\): Irradiance, averaged over a simulation period \
[W/m^2]\n\n\!\(\*
StyleBox[\"popgr8All\",
FontSlant->\"Italic\"]\): Array of dimension Nx8, where N equals the length \
of psiSpanAll and corresponds to the time steps given by psiSpanAll\
\[LeftDoubleBracket]All,1\[RightDoubleBracket]. The values of opgr8All yield \
the 8 ground state populations of the velocity class that is closest to +5 \
MHz, where in many systems a peak of the polarization is observed (\\\"busy \
velocity class\\\"), normalized by the total ground+excited state population \
in this velocity class. For darkness in equilibrium we thus have popgr8All\
\[LeftDoubleBracket]All,All\[RightDoubleBracket]==1/8. The states are ordered \
{(F=2,m=2), (F=2,m=1)..., (F=2,m=-2), (F=1,m=1), (F=1,m=0), (F=2,m=-1)} (with \
LightPolarization->+1, the (F=2,m=2) is pumped most strongly) popex16All: \
same as popgr8All, but for the 16 excited states. Sequence starts with \
(F=3,m=3).\n\n\!\(\*
StyleBox[\"PhiVErrors\",
FontSlant->\"Italic\"]\): vector of numerical errors returned by phiv[], \
corresponding to psiSpanAll psiIavg: value of psi for average irradiance\n\n\
\!\(\*
StyleBox[\"popgr\",
FontSlant->\"Italic\"]\): ground state population\n\n\!\(\*
StyleBox[\"popex\",
FontSlant->\"Italic\"]\): Excited state population\n\n\!\(\*
StyleBox[\"w\",
FontSlant->\"Italic\"]\): final solution vector (b)\n\nThe routine computes \
the average return flux psiAvg defined as\n\n   psiAvg = 1/(trep * Iavg) \!\(\
\*SubsuperscriptBox[\(\[Integral]\), \(t0\), \(t0\\\  + \\\ trep\)]\)Psi(t) \
dt, \n\n\twhere Psi(t) is the instantaneous non-normalized return flux in \
ph/s/sr/atom, t0 is the begin of the last period, and Iavg = Ipulse*duty, \
where Ipulse is the pulse irradiance.\n\nThe iteration starts from thermal \
equilibrium (InitialState \[Rule] LightOff) or from the steady-state solution \
at Ipulse (InitialState \[Rule] LightOn) and stops once the difference of \
psiAvg between two subsequent iterations drops below some threshold. In the \
verbose simulation output, \\\"peak cw psi\\\" is the steady-state result \
psi(I_peak), and \\\"flux from avg irradiance\\\" is similarly psi(I_avg). To \
achieve convergence, allow for a total simulation time of several times 16ns. \
At low irradiance, you may have to simulate several collision time \
scales.\>\""}], " ", ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KrylovDimension", "::", "usage"}], "=", 
   "\"\<KrylovDimension is an option for StepPulseFlux that specifies the \
dimension of the Krylov subspace to be used in the matrix exponential \
calculation.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Tolerance", "::", "usage"}], "=", 
   "\"\<Tolerance is an option for StepPulseFlux that specifies the tolerance \
to use in phiv[].\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TerminationThresh", "::", "usage"}], "=", 
   "\"\<TerminationThresh is an option for StepPulseFlux that specifies that \
the iteration shall be terminated once the absolute difference between two \
subsequent values of the averaged psi falls below TerminationThresh\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InitialState", "::", "usage"}], "=", 
   "\"\<InitialState is an option for StepPulseFlux that specifies the state \
of the system at the beginning of the time-dependent calculation.\n\n\
InitialState\[Rule]LightOn specifies the steady state with cw light.\n\
InitialState\[Rule]LightOff specifies the steady state with no light.\n\
InitialState\[Rule]{\!\(\*
StyleBox[\"sol\", \"TI\"]\),\!\(\*
StyleBox[\"vg\", \"TI\"]\)} specifies a state given by density-matrix \
solution vector \!\(\*
StyleBox[\"sol\", \"TI\"]\) corresponding to velocity group binning \!\(\*
StyleBox[\"vg\", \"TI\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LightOn", "::", "usage"}], "=", 
   "\"\<LightOn is a possible value for the InitialState option of \
StepPulseFlux that specifies that the initial state is the steady state with \
cw light.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LightOff", "::", "usage"}], "=", 
   "\"\<LightOff is a possible value for the InitialState option of \
StepPulseFlux that specifies that the initial state is the steady state with \
no light.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VGMethod", "::", "usage"}], "=", 
   "\"\<VGMethod is an option for StepPulseFlux that specifies the method \
used to account for the velocity group binning over multiple steps.\n\n\
VGMethod->FixVG specifies that the velocity group binning found for the first \
calculation (using the nominal laser parameters) should be reused for all \
subsequent steps.\nVGMethod->ConvertDM specifies that a new binning should be \
found for each step, and the density matrix solution vector found from the \
previous step should be rebinned to match the new velocity group \
binning.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FixVG", "::", "usage"}], "=", 
   "\"\<FixVG is a possible value for the VGMethod option for StepPulseFlux \
that specifies that the velocity group binning found for the first \
calculation (using the nominal laser parameters) should be reused for all \
subsequent steps.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConvertDM", "::", "usage"}], "=", 
   "\"\<ConvertDM is a possible value for the VGMethod option for \
StepPulseFlux that specifies that a new binning should be found for each \
step, and the density matrix solution vector found from the previous step \
should be rebinned to match the new velocity group binning.\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VGfreezePeriod", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<VGfreezePeriod is the period after starting at which the rebinning \
stops and the velocity bins remain constant. In particular when simulating \
pulse shapes with numerous samples, this option can significantly improve the \
computational speed.\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PhiVErrors", "::", "usage"}], "=", "\"\<\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PsiIavg", "::", "usage"}], "=", "\"\<\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GroundPopulation", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExcitedPopulation", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FinalGroundPops", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FinalExcitedPops", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExcitedPops", "::", "usage"}], "=", "\"\<\>\""}], ";"}]], "Input",
 
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LastDM", "::", "usage"}], "=", "\"\<\>\""}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RFParamsOut", "::", "usage"}], "=", "\"\<\>\""}], ";"}]], "Input",
 
 InitializationCell->
  True]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implementation", \
"Section"],

Cell[CellGroupData[{

Cell["Begin private context", \
"Subsection"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "Input",
 InitializationCell->
  True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Set up C compiler", \
"Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"$VersionNumber", "\[GreaterEqual]", "8."}], ",", 
    RowBox[{"Needs", "[", "\"\<CCompilerDriver`\>\"", "]"}]}], "]"}], 
  ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ccompiler", "=", 
   RowBox[{
    RowBox[{"$VersionNumber", "\[GreaterEqual]", "8."}], "&&", 
    RowBox[{
     RowBox[{"CCompilers", "[", "]"}], "\[NotEqual]", 
     RowBox[{"{", "}"}]}]}]}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{"compileropts", "=", 
  RowBox[{"If", "[", 
   RowBox[{"ccompiler", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"RuntimeOptions", "\[Rule]", "\"\<Speed\>\""}], ",", 
      RowBox[{"Parallelization", "\[Rule]", "True"}], ",", " ", 
      RowBox[{"CompilationTarget", "\[Rule]", "\"\<C\>\""}]}], " ", "}"}], 
    ",", 
    RowBox[{"{", "}"}]}], "]"}]}]], "Input",
 InitializationCell->
  True]
}, Open  ]],

Cell[CellGroupData[{

Cell["phiv", \
"Subsection"],

Cell["\<\
 [w, err] = phiv( t, A, u, v, tol, m )
 phiv computes an approximation of w = exp(t*A)*v + t*phi(t*A)*u
 for a general matrix A using Krylov subspace projection techniques.
 Here, phi(z) = (exp(z)-1)/z and w is the solution of the 
 nonhomogeneous linear ODE problem w' = Aw + u, w(0) = v.
 It does not compute the matrix functions in isolation but instead,
 it computes directly the action of these functions on the 
 operand vectors. This way of doing so allows for addressing large
 sparse problems. The matrix under consideration interacts only
 via matrix-vector products (matrix-free method).
 
 w = phiv( t, A, u, v ) 
 computes w = exp(t*A)*v + t*phi(t*A)*u using a default tol = 1.0e-7 
 and m = 30.
 
 [w, err] = phiv( t, A, u, v )
 renders an estimate of the error on the approximation.
 
 [w, err] = phiv( t, A, u, v, tol )
 overrides default tolerance.
 
 [w, err] = phiv( t, A, u, v, tol, m )
 overrides default tolerance and dimension of the Krylov subspace.
 
 Example 1:
 ----------
   n = 100;
   A = rand(n);
   u = zeros(n,1);
   v = eye(n,1);
   w = phiv(1,A,u,v);
 
 
 Example 2:
 ----------
   % generate a random sparse matrix
   n = 100;
   A = rand(n);
   for j = 1:n
       for i = 1:n
           if rand < 0.5, A(i,j) = 0; end;
       end;
   end;
   u = rand(n,1);
   v = eye(n,1);
   A = sparse(A); % invaluable for a large and sparse matrix.
 
   tic
   [w,err] = phiv(1,A,u,v);
   toc
 
   disp('w(1:10) ='); disp(w(1:10));
   disp('err =');     disp(err);
 
   tic
   x = A\\u;
   w_matlab = expm(full(A))*(v+x)-x;
   toc
 
   disp('w_matlab(1:10) ='); disp(w_matlab(1:10));
   gap = norm(w-w_matlab)/norm(w_matlab);
   disp('||w-w_matlab|| / ||w_matlab|| ='); disp(gap);
 
 In the above example, n could have been set to a larger value,
 but the computation of w_matlab will be too long (feel free to
 discard this computation).
 
 See also EXPV, MEXPV, EXPOKIT.
 
 Roger B. Sidje (rbs@maths.uq.edu.au)
 EXPOKIT: Software Package for Computing Matrix Exponentials. 
 ACM - Transactions On Mathematical Software, 24(1):130-156, 1998

Translated to Mathematica by Ronald Holzloehner, 20 March 2009
Function compared on 23Mar09 with MATLAB routine for 5x5 random complex A, u \
and v: results agree.

Further mucked with by S. Rochester, 12 August 2009\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "phiv", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"VerbosityLevel", "\[Rule]", "2"}], "}"}]}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"phiv", "[", 
     RowBox[{"t_", ",", "A_", ",", "u_", ",", "v_", ",", 
      RowBox[{"obsmat_:", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"tspanMax_:", "Infinity"}], ",", 
      RowBox[{"tol_:", 
       RowBox[{"10.0", "^", 
        RowBox[{"(", 
         RowBox[{"-", "7"}], ")"}]}]}], ",", 
      RowBox[{"mIn_:", "-", "1"}], ",", 
      RowBox[{"indVgMaxEx_:", "-", "1"}], ",", 
      RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "n", ",", "anorm", ",", "mxrej", ",", "btol", ",", "gamma", ",", 
        "delta", ",", "mb", ",", "tout", ",", "istep", ",", "tnew", ",", 
        "tnow", ",", "serror", ",", "rndoff", ",", "k1", ",", "xm", ",", 
        "beta", ",", "fact", ",", "s", ",", "sgn", ",", "w", ",", "tstep", 
        ",", "Vt", ",", "H", ",", "p", ",", "i", ",", "j", ",", "avnorm", ",",
         "ireject", ",", "mx", ",", "errloc", ",", "p1", ",", "p2", ",", 
        "err", ",", "m", ",", "h", ",", "obs", ",", "F", ",", "off1", ",", 
        "time", ",", "verb", ",", "popgr8", ",", "popex16", ",", "grStates", 
        ",", "exStates", ",", "wgr", ",", "wex", ",", "tot1", ",", 
        "popgr8Weighted", ",", "wgrAll", ",", "wexAllTotal", ",", 
        "popgr8WeightedLoc"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"function", " ", 
         RowBox[{"(", 
          RowBox[{"w", ",", "err", ",", "hump"}], ")"}]}], "=", 
        RowBox[{"expv", " ", 
         RowBox[{"(", 
          RowBox[{"t", ",", "A", ",", "v", ",", "tol", ",", "m"}], ")"}]}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{
         RowBox[{"Dimensions", "[", "A", "]"}], "\[LeftDoubleBracket]", "1", 
         "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", "n", "}"}], "\[NotEqual]", 
          RowBox[{"Dimensions", "[", "u", "]"}]}], ",", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<phiv[]: A must be conformable with v, Dimensions[A]\
\[LeftDoubleBracket]1\[RightDoubleBracket]: \>\"", ",", " ", 
            RowBox[{"{", "n", "}"}], ",", " ", "\"\<, Dimensions[u]: \>\"", 
            ",", " ", 
            RowBox[{"Dimensions", "[", "u", "]"}]}], "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}], ",", 
         RowBox[{
          RowBox[{"{", "}"}], ";"}], ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<u\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", "n", "}"}], "\[NotEqual]", 
          RowBox[{"Dimensions", "[", "v", "]"}]}], ",", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<phiv[]: A must be conformable with v, Dimensions[A]\
\[LeftDoubleBracket]1\[RightDoubleBracket]: \>\"", ",", " ", 
            RowBox[{"{", "n", "}"}], ",", " ", "\"\<, Dimensions[v]: \>\"", 
            ",", " ", 
            RowBox[{"Dimensions", "[", "v", "]"}]}], "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}], ",", 
         RowBox[{
          RowBox[{"{", "}"}], ";"}], ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<v\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixQ", "[", 
           RowBox[{"A", ",", "NumericQ"}], "]"}], "\[Equal]", "False"}], " ", 
         ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<phiv[]: A is nonnumeric\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}], ",", 
         RowBox[{
          RowBox[{"{", "}"}], ";"}], ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<A\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixQ", "[", 
           RowBox[{
            RowBox[{"{", "u", "}"}], ",", "NumericQ"}], "]"}], "\[Equal]", 
          "False"}], " ", ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<phiv[]: u is nonnumeric\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}], ",", 
         RowBox[{
          RowBox[{"{", "}"}], ";"}], ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<A\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixQ", "[", 
           RowBox[{
            RowBox[{"{", "v", "}"}], ",", "NumericQ"}], "]"}], "\[Equal]", 
          "False"}], " ", ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<phiv[]: v is nonnumeric\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}], ",", 
         RowBox[{
          RowBox[{"{", "}"}], ";"}], ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<A\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixQ", "[", 
           RowBox[{
            RowBox[{"{", "obsmat", "}"}], ",", "NumericQ"}], "]"}], 
          "\[Equal]", "False"}], " ", ",", 
         RowBox[{
          RowBox[{
          "Print", "[", "\"\<phiv[]: resultmat is nonnumeric\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}], ",", 
         RowBox[{
          RowBox[{"{", "}"}], ";"}], ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<A\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"verb", "=", 
        RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Positions", " ", "of", " ", "the", " ", "ground", " ", "state", " ", 
         "populations"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"grStates", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Position", "[", 
          RowBox[{"u", ",", 
           RowBox[{"x_", "/;", 
            RowBox[{"x", "!=", "0"}]}]}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Positions", " ", "of", " ", "the", " ", "excited", " ", "state", " ",
          "populations"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"exStates", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Position", "[", 
          RowBox[{"obsmat", ",", 
           RowBox[{"x_", "/;", 
            RowBox[{"x", ">", "0"}]}]}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"popgr8", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"popex16", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"popgr8Weighted", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"[", 
           RowBox[{"n", ",", "n"}], "]"}], "=", 
          RowBox[{"size", " ", 
           RowBox[{"(", "A", ")"}]}]}], ";"}], "*)"}], 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"if", " ", "nargin"}], "\[Equal]", "3"}], ",", 
         RowBox[{
          RowBox[{"tol", "=", 
           RowBox[{"1.0", "*", 
            RowBox[{"10", "^", 
             RowBox[{"(", 
              RowBox[{"-", "7"}], ")"}]}]}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"m", "=", 
           RowBox[{"min", " ", 
            RowBox[{"(", 
             RowBox[{"n", ",", "30"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
          "end", ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"if", " ", "nargin"}], "\[Equal]", "4"}]}], ",", 
         RowBox[{
          RowBox[{"m", "=", 
           RowBox[{"min", " ", 
            RowBox[{"(", 
             RowBox[{"n", ",", "30"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
          "end", ";"}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"mIn", "\[Equal]", 
          RowBox[{"-", "1"}]}], ",", 
         RowBox[{
          RowBox[{"m", "=", 
           RowBox[{"Min", "[", 
            RowBox[{"n", ",", "30"}], "]"}]}], ";"}], ",", 
         RowBox[{
          RowBox[{"m", "=", "mIn"}], ";"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"anorm", "=", 
        RowBox[{"Norm", "[", 
         RowBox[{"A", ",", "Infinity"}], "]"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"mxrej", "=", "10"}], ";", 
       RowBox[{"btol", "=", 
        RowBox[{"10.0", "^", 
         RowBox[{"(", 
          RowBox[{"-", "7"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"gamma", "=", "0.9"}], ";", 
       RowBox[{"delta", "=", "1.2"}], ";", "\[IndentingNewLine]", 
       RowBox[{"mb", "=", "m"}], ";", 
       RowBox[{"tout", "=", 
        RowBox[{"N", "[", 
         RowBox[{"Abs", "[", "t", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"istep", "=", "0"}], ";", 
       RowBox[{"tnew", "=", "0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"tnow", "=", "0"}], ";", 
       RowBox[{"serror", "=", "0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"rndoff", "=", 
        RowBox[{"anorm", "*", "$MachineEpsilon"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"sgn", "=", 
        RowBox[{"N", "[", 
         RowBox[{"Sign", "[", "t", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"k1", "=", "3"}], ";", "\[IndentingNewLine]", 
       RowBox[{"xm", "=", 
        RowBox[{"1.0", "/", "m"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"obs", "=", 
        RowBox[{"{", "}"}]}], ";", " ", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Used", " ", "to", " ", "accumulate", " ", "return", " ", "flux", " ",
          "samples"}], " ", "*)"}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"w", "=", "v"}], ";", "\[IndentingNewLine]", 
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{"tnow", "<", "tout"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"time", "=", 
           RowBox[{"Timing", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Vt", "=", 
              RowBox[{"ConstantArray", "[", 
               RowBox[{"0.0", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"m", "+", "1"}], ",", "n"}], "}"}]}], "]"}]}], ";", 
             
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"V", "=", 
                RowBox[{"zeros", " ", 
                 RowBox[{"(", 
                  RowBox[{"n", ",", 
                   RowBox[{"m", "+", "1"}]}], ")"}]}]}], ";"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"H", "=", 
              RowBox[{"ConstantArray", "[", 
               RowBox[{"0.0", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"m", "+", "3"}], ",", 
                  RowBox[{"m", "+", "3"}]}], "}"}]}], "]"}]}], ";", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"H", "=", 
                RowBox[{"zeros", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"m", "+", "3"}], ",", 
                   RowBox[{"m", "+", "3"}]}], ")"}]}]}], ";"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
              "Vt", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
              "=", 
              RowBox[{
               RowBox[{"A", " ", ".", " ", "w"}], "+", "u"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"beta", "=", 
              RowBox[{"Norm", "[", 
               RowBox[{
                RowBox[{
                "Vt", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
                ",", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
              "Vt", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], "*=", 
              RowBox[{"(", 
               RowBox[{"1.0", "/", "beta"}], ")"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"istep", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"fact", "=", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"m", "+", "1.0"}], ")"}], "/", "E"}], ")"}], "^", 
                    
                    RowBox[{"(", 
                    RowBox[{"m", "+", "1"}], ")"}]}], ")"}], "*", 
                  RowBox[{"Sqrt", "[", 
                   RowBox[{"2.0", "*", "Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"m", "+", "1"}], ")"}]}], "]"}]}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"tnew", "=", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"1.0", "/", "anorm"}], ")"}], "*", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"fact", "*", "tol"}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"4", "*", "beta", "*", "anorm"}], ")"}]}], ")"}], 
                   "^", "xm"}]}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"s", "=", 
                 RowBox[{"10.0", "^", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Floor", "[", 
                    RowBox[{"Log10", "[", "tnew", "]"}], "]"}], "-", "1"}], 
                   ")"}]}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"tnew", "=", 
                 RowBox[{
                  RowBox[{"Ceiling", "[", 
                   RowBox[{"tnew", "/", "s"}], "]"}], "*", "s"}]}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"istep", "++"}], ";", "\[IndentingNewLine]", 
             RowBox[{"tstep", "=", 
              RowBox[{"Min", "[", 
               RowBox[{
                RowBox[{"tout", "-", "tnow"}], ",", "tnew"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"tstep", "=", 
              RowBox[{"Min", "[", 
               RowBox[{"tstep", ",", "tspanMax"}], "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{
                RowBox[{"V", "\[LeftDoubleBracket]", 
                 RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "=", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1.0", "/", "beta"}], ")"}], "*", "w"}]}], ";", 
               "    ", 
               RowBox[{
                RowBox[{"V", " ", 
                 RowBox[{"(", 
                  RowBox[{":", 
                   RowBox[{",", "1"}]}], ")"}]}], "=", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", "/", "beta"}], ")"}], "*", "w"}]}], ";"}], 
              "*)"}], "\[IndentingNewLine]", 
             RowBox[{"For", "[", 
              RowBox[{
               RowBox[{"j", "=", "1"}], ",", 
               RowBox[{"j", "\[LessEqual]", "m"}], ",", 
               RowBox[{"j", "++"}], ",", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{"for", " ", "j"}], "=", 
                 RowBox[{"1", ":", "m"}]}], "*)"}], "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"p", "=", 
                 RowBox[{"A", ".", 
                  RowBox[{
                  "Vt", "\[LeftDoubleBracket]", "j", 
                   "\[RightDoubleBracket]"}]}]}], ";", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{"p", "=", 
                   RowBox[{"A", "*", "V", " ", 
                    RowBox[{"(", 
                    RowBox[{":", 
                    RowBox[{",", "j"}]}], ")"}]}]}], ";"}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"For", "[", 
                 RowBox[{
                  RowBox[{"i", "=", "1"}], ",", 
                  RowBox[{"i", "\[LessEqual]", "j"}], ",", 
                  RowBox[{"i", "++"}], ",", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"for", " ", "i"}], "=", 
                    RowBox[{"1", ":", "j"}]}], "*)"}], "\[IndentingNewLine]", 
                  
                  RowBox[{
                   RowBox[{
                    RowBox[{"H", "\[LeftDoubleBracket]", 
                    RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}], "=", 
                    RowBox[{
                    RowBox[{"Conjugate", "[", 
                    RowBox[{
                    "Vt", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}], "]"}], ".", "p"}]}], ";", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"H", " ", 
                    RowBox[{"(", 
                    RowBox[{"i", ",", "j"}], ")"}]}], "=", 
                    RowBox[{"V", " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{":", 
                    RowBox[{",", "i"}]}], ")"}], "'"}], "*", "p"}]}], ";"}], 
                    "*)"}], "\[IndentingNewLine]", 
                   RowBox[{"p", "-=", 
                    RowBox[{
                    RowBox[{"H", "\[LeftDoubleBracket]", 
                    RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}], " ", 
                    "*", " ", 
                    RowBox[{
                    "Vt", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}]}]}], ";"}]}], 
                 RowBox[{"(*", 
                  RowBox[{
                   RowBox[{"p", "=", 
                    RowBox[{"p", "-", 
                    RowBox[{"H", " ", 
                    RowBox[{"(", 
                    RowBox[{"i", ",", "j"}], ")"}], "*", "V", " ", 
                    RowBox[{"(", 
                    RowBox[{":", 
                    RowBox[{",", "i"}]}], ")"}]}]}]}], ";"}], "*)"}], 
                 "\[IndentingNewLine]", "]"}], ";", 
                RowBox[{"(*", 
                 RowBox[{"for", " ", "i"}], "*)"}], "\[IndentingNewLine]", 
                RowBox[{"s", "=", 
                 RowBox[{"Norm", "[", 
                  RowBox[{"p", ",", "2"}], "]"}]}], ";", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{"s", "=", 
                   RowBox[{"norm", " ", 
                    RowBox[{"(", "p", ")"}]}]}], ";"}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"s", "<", "btol"}], ",", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"if", " ", "s"}], "<", "btol"}], ","}], "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"k1", "=", "0"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"mb", "=", "j"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"tstep", "=", 
                    RowBox[{"tout", "-", "tnow"}]}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{"tstep", "=", 
                    RowBox[{"Min", "[", 
                    RowBox[{"tstep", ",", "tspanMax"}], "]"}]}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Break", "[", "]"}]}]}], 
                 RowBox[{"(*", 
                  RowBox[{"break", ";"}], "*)"}], "\[IndentingNewLine]", 
                 "]"}], ";", 
                RowBox[{"(*", " ", "if", " ", "*)"}], "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"H", "\[LeftDoubleBracket]", 
                  RowBox[{
                   RowBox[{"j", "+", "1"}], ",", "j"}], 
                  "\[RightDoubleBracket]"}], "=", "s"}], ";", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"H", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"j", "+", "1"}], ",", "j"}], ")"}]}], "=", "s"}], 
                  ";"}], "*)"}], "\[IndentingNewLine]", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"V", " ", 
                    RowBox[{"(", 
                    RowBox[{":", 
                    RowBox[{",", 
                    RowBox[{"j", "+", "1"}]}]}], ")"}]}], "=", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "/", "s"}], ")"}], "*", "p"}]}], ";"}], 
                 "*)"}], "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Vt", "\[LeftDoubleBracket]", 
                  RowBox[{"j", "+", "1"}], "\[RightDoubleBracket]"}], "=", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"1.0", "/", "s"}], ")"}], "*", "p"}]}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ";", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"for", " ", "j"}], ";"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"H", "\[LeftDoubleBracket]", 
               RowBox[{"1", ",", 
                RowBox[{"mb", "+", "1"}]}], "\[RightDoubleBracket]"}], "=", 
              "1"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"k1", "\[NotEqual]", "0"}], ",", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{"if", " ", 
                  RowBox[{"k1", "~", 
                   RowBox[{"=", "0"}]}]}], ","}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"H", "\[LeftDoubleBracket]", 
                  RowBox[{
                   RowBox[{"m", "+", "1"}], ",", 
                   RowBox[{"m", "+", "2"}]}], "\[RightDoubleBracket]"}], "=", 
                 "1.0"}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"H", "\[LeftDoubleBracket]", 
                  RowBox[{
                   RowBox[{"m", "+", "2"}], ",", 
                   RowBox[{"m", "+", "3"}]}], "\[RightDoubleBracket]"}], "=", 
                 "1.0"}], ";", "\[IndentingNewLine]", 
                RowBox[{"h", "=", 
                 RowBox[{"H", "\[LeftDoubleBracket]", 
                  RowBox[{
                   RowBox[{"m", "+", "1"}], ",", "m"}], 
                  "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"H", "\[LeftDoubleBracket]", 
                  RowBox[{
                   RowBox[{"m", "+", "1"}], ",", "m"}], 
                  "\[RightDoubleBracket]"}], "=", "0.0"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{"avnorm", "=", 
                   RowBox[{"norm", " ", 
                    RowBox[{"(", 
                    RowBox[{"A", "*", "V", " ", 
                    RowBox[{"(", 
                    RowBox[{":", 
                    RowBox[{",", 
                    RowBox[{"m", "+", "1"}]}]}], ")"}]}], ")"}]}]}], ";"}], 
                 "*)"}], "\[IndentingNewLine]", 
                RowBox[{"avnorm", "=", 
                 RowBox[{"Norm", "[", 
                  RowBox[{"A", ".", 
                   RowBox[{"Vt", "\[LeftDoubleBracket]", 
                    RowBox[{"m", "+", "1"}], "\[RightDoubleBracket]"}]}], " ",
                   "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
             RowBox[{"(*", "if", "*)"}], "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"ireject", "=", "0"}], ";", "\[IndentingNewLine]", 
             RowBox[{"While", "[", 
              RowBox[{
               RowBox[{"ireject", "\[LessEqual]", "mxrej"}], ",", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{
                  RowBox[{"while", " ", "ireject"}], "\[LessEqual]", 
                  "mxrej"}], ","}], "*)"}], "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"mx", "=", 
                 RowBox[{"mb", "+", 
                  RowBox[{"Max", "[", 
                   RowBox[{"1", ",", "k1"}], "]"}]}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"(*", " ", 
                 RowBox[{
                  RowBox[{"Re", "[", "]"}], " ", "added", " ", "on", " ", 
                  "09", "Sep11", " ", "since", " ", 
                  RowBox[{"MatrixExp", "[", "]"}], " ", "sometimes", " ", 
                  "returns", " ", "complex", " ", "numbers"}], " ", "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"F", "=", 
                 RowBox[{"Re", "[", 
                  RowBox[{"MatrixExp", "[", " ", 
                   RowBox[{"sgn", "*", "tstep", "*", " ", 
                    RowBox[{"H", "\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"1", ";;", "mx"}], ",", 
                    RowBox[{"1", ";;", "mx"}]}], "\[RightDoubleBracket]"}]}], 
                   " ", "]"}], "]"}]}], ";", 
                RowBox[{"(*", 
                 RowBox[{
                  RowBox[{"F", "=", 
                   RowBox[{"expm", " ", 
                    RowBox[{"(", 
                    RowBox[{"sgn", "*", "t_step", "*", "H", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"1", ":", "mx"}], ",", 
                    RowBox[{"1", ":", "mx"}]}], ")"}]}], ")"}]}]}], ";"}], 
                 "*)"}], "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"k1", "\[Equal]", "0"}], ",", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"if", " ", "k1"}], "\[Equal]", "0"}], ","}], 
                   "*)"}], "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"errloc", "=", "btol"}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Break", "[", "]"}], ";"}], ",", 
                  RowBox[{"(*", 
                   RowBox[{"break", ";"}], "*)"}], "\[IndentingNewLine]", 
                  RowBox[{"(*", " ", "Else", " ", "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"F", "\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"m", "+", "1"}], ",", 
                    RowBox[{"m", "+", "1"}]}], "\[RightDoubleBracket]"}], "=", 
                    RowBox[{"h", "*", 
                    RowBox[{"F", "\[LeftDoubleBracket]", 
                    RowBox[{"m", ",", 
                    RowBox[{"m", "+", "2"}]}], "\[RightDoubleBracket]"}]}]}], 
                   ";", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"F", "\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"m", "+", "2"}], ",", 
                    RowBox[{"m", "+", "1"}]}], "\[RightDoubleBracket]"}], "=", 
                    RowBox[{"h", "*", 
                    RowBox[{"F", "\[LeftDoubleBracket]", 
                    RowBox[{"m", ",", 
                    RowBox[{"m", "+", "3"}]}], "\[RightDoubleBracket]"}]}]}], 
                   ";", "\[IndentingNewLine]", 
                   RowBox[{"p1", "=", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"beta", "*", 
                    RowBox[{"F", "\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"m", "+", "1"}], ",", 
                    RowBox[{"m", "+", "1"}]}], "\[RightDoubleBracket]"}]}], 
                    "]"}]}], ";", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"abs", " ", 
                    RowBox[{"(", 
                    RowBox[{"beta", "*", "F", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"m", "+", "1"}], ",", 
                    RowBox[{"m", "+", "1"}]}], ")"}]}], ")"}]}], ";"}], 
                    "*)"}], "\[IndentingNewLine]", 
                   RowBox[{"p2", "=", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"beta", "*", 
                    RowBox[{"F", "\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"m", "+", "2"}], ",", 
                    RowBox[{"m", "+", "1"}]}], "\[RightDoubleBracket]"}], "*",
                     "avnorm"}], "]"}]}], ";", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"abs", " ", 
                    RowBox[{"(", 
                    RowBox[{"beta", "*", "F", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"m", "+", "2"}], ",", 
                    RowBox[{"m", "+", "1"}]}], ")"}], "*", "avnorm"}], 
                    ")"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"p1", ">", 
                    RowBox[{"10.0", "*", "p2"}]}], ",", 
                    RowBox[{"(*", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"if", " ", "phi1"}], ">", 
                    RowBox[{"10", "*", "phi2"}]}], ","}], "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"errloc", "=", "p2"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"xm", "=", 
                    RowBox[{"1.0", "/", "m"}]}], ";"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", "Else", " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"p1", ">", "p2"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"errloc", "=", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"p1", "*", "p2"}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"p1", "-", "p2"}], ")"}]}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"xm", "=", 
                    RowBox[{"1.0", "/", "m"}]}], ";"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", "Else", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"errloc", "=", "p1"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"xm", "=", 
                    RowBox[{"1.0", "/", 
                    RowBox[{"(", 
                    RowBox[{"m", "-", "1"}], ")"}]}]}], ";"}]}], 
                    "\[IndentingNewLine]", "]"}], ";"}]}], 
                    "\[IndentingNewLine]", "]"}], ";"}]}], " ", 
                 "\[IndentingNewLine]", "]"}], ";", 
                RowBox[{"(*", " ", 
                 RowBox[{
                  RowBox[{"If", " ", "k"}], "\[Equal]", "1"}], " ", "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"errloc", "\[LessEqual]", 
                   RowBox[{"delta", "*", "tstep", "*", "tol"}]}], ",", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"if", " ", "err_loc"}], "\[LessEqual]", 
                    RowBox[{"delta", "*", "t_step", "*", "tol"}]}], ","}], 
                   "*)"}], "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Break", "[", "]"}], ";"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"(*", "Else", "*)"}], "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"tstep", "=", 
                    RowBox[{"gamma", "*", "tstep", "*", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"tstep", "*", 
                    RowBox[{"tol", "/", "errloc"}]}], ")"}], "^", "xm"}]}]}], 
                   ";", "\[IndentingNewLine]", 
                   RowBox[{"tstep", "=", 
                    RowBox[{"Min", "[", 
                    RowBox[{"tstep", ",", "tspanMax"}], "]"}]}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{"s", "=", 
                    RowBox[{"10.0", "^", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Floor", "[", 
                    RowBox[{"Log10", "[", "tstep", "]"}], "]"}], "-", "1"}], 
                    ")"}]}]}], ";", "\[IndentingNewLine]", 
                   RowBox[{"tstep", "=", 
                    RowBox[{
                    RowBox[{"Ceiling", "[", 
                    RowBox[{"tstep", "/", "s"}], "]"}], "*", "s"}]}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ireject", "\[Equal]", "mxrej"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    "Print", "[", 
                    "\"\<phiv[]: The requested tolerance is too high!\>\"", 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Abort", "[", "]"}], ";"}]}], 
                    "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                   
                   RowBox[{"ireject", "++"}], ";"}]}], "\[IndentingNewLine]", 
                 "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
             RowBox[{"(*", " ", 
              RowBox[{"While", "[", 
               RowBox[{
                RowBox[{"ireject", "\[LessEqual]", "mxrej"}], ",", "..."}], 
               "]"}], " ", "*)"}], "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"mx", "=", 
              RowBox[{"mb", "+", 
               RowBox[{"Max", "[", 
                RowBox[{"0", ",", 
                 RowBox[{"k1", "-", "2"}]}], "]"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"w", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"Transpose", "[", 
                 RowBox[{"Vt", "\[LeftDoubleBracket]", 
                  RowBox[{"1", ";;", "mx"}], "\[RightDoubleBracket]"}], "]"}],
                 ".", 
                RowBox[{"(", 
                 RowBox[{"beta", "*", 
                  RowBox[{"F", "\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{"1", ";;", "mx"}], ",", 
                    RowBox[{"mb", "+", "1"}]}], "\[RightDoubleBracket]"}]}], 
                 ")"}]}], " ", "+", " ", "w"}]}], ";", "\[IndentingNewLine]", 
             
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"w", "=", 
                RowBox[{
                 RowBox[{"V", " ", 
                  RowBox[{"(", 
                   RowBox[{":", 
                    RowBox[{",", 
                    RowBox[{"1", ":", "mx"}]}]}], ")"}], "*", 
                  RowBox[{"(", 
                   RowBox[{"beta", "*", "F", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"1", ":", "mx"}], ",", 
                    RowBox[{"mb", "+", "1"}]}], ")"}]}], ")"}]}], " ", "+", 
                 " ", "w"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"tnow", "+=", "tstep"}], ";", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"t_now", "=", 
                RowBox[{"t_now", "+", "t_step"}]}], ";"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"tnew", "=", 
              RowBox[{"gamma", "*", "tstep", "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"tstep", "*", 
                  RowBox[{"tol", "/", "errloc"}]}], ")"}], "^", "xm"}]}]}], 
             ";", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"t_new", "=", 
                RowBox[{"gamma", "*", "t_step", "*", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"t_step", "*", 
                    RowBox[{"tol", "/", "err_loc"}]}], ")"}], "^", "xm"}]}]}],
                ";"}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{"s", "=", 
              RowBox[{"10.0", "^", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Floor", "[", 
                  RowBox[{"Log10", "[", "tnew", "]"}], "]"}], "-", "1"}], 
                ")"}]}]}], ";", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"s", "=", 
                RowBox[{"10", "^", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"floor", " ", 
                    RowBox[{"(", 
                    RowBox[{"log10", " ", 
                    RowBox[{"(", "t_new", ")"}]}], ")"}]}], "-", "1"}], 
                  ")"}]}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{"tnew", "=", 
              RowBox[{
               RowBox[{"Ceiling", "[", 
                RowBox[{"tnew", "/", "s"}], "]"}], "*", "s"}]}], ";", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"t_new", "=", 
                RowBox[{"ceil", " ", 
                 RowBox[{"(", 
                  RowBox[{"t_new", "/", "s"}], ")"}], "*", "s"}]}], ";"}], 
              "*)"}], "\[IndentingNewLine]", 
             RowBox[{"errloc", "=", 
              RowBox[{"Max", "[", 
               RowBox[{"errloc", ",", "rndoff"}], "]"}]}], ";", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"err_loc", "=", 
                RowBox[{"max", " ", 
                 RowBox[{"(", 
                  RowBox[{"err_loc", ",", "rndoff"}], ")"}]}]}], ";"}], 
              "*)"}], "\[IndentingNewLine]", 
             RowBox[{"serror", "+=", "errloc"}], ";"}], "\[IndentingNewLine]",
             "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"istep", "\[LessEqual]", "4"}], "&&", 
              RowBox[{"verb", ">", "3"}]}], "||", 
             RowBox[{"verb", ">", "5"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{
              "\"\<    Step \>\"", ",", "istep", ",", "\"\<: tstep = \>\"", 
               ",", " ", 
               RowBox[{
                RowBox[{"10.0", "^", "9"}], "*", "tstep"}], ",", " ", 
               "\"\< ns\>\"", ",", " ", "\"\<, tnow = \>\"", ",", " ", 
               RowBox[{
                RowBox[{"10.0", "^", "9"}], "*", "tnow"}], ",", " ", 
               "\"\< ns, (\>\"", ",", 
               RowBox[{
               "time", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}],
                ",", "\"\< s)\>\""}], "]"}], ";"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"Code", " ", "inserted", " ", "by", " ", "Ron", " ", 
            RowBox[{"Holzloehner", ":", " ", 
             RowBox[{
             "Compute", " ", "the", " ", "return", " ", "flux", " ", "at", 
              " ", "tnow"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"n", "==", 
             RowBox[{"Max", "[", 
              RowBox[{"Dimensions", "[", "obsmat", "]"}], "]"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"obs", ",", 
               RowBox[{"{", 
                RowBox[{"tnow", ",", 
                 RowBox[{"Re", "[", 
                  RowBox[{"obsmat", ".", "w"}], "]"}]}], "}"}]}], "]"}], 
             ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"indVgMaxEx", "\[GreaterEqual]", "1"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"off1", "=", 
              RowBox[{"8", "*", 
               RowBox[{"(", 
                RowBox[{"indVgMaxEx", "-", "1"}], ")"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"wgr", "=", 
              RowBox[{
               RowBox[{
               "w", "\[LeftDoubleBracket]", "grStates", 
                "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "+", "off1"}], ")"}], ";;", 
                RowBox[{"(", 
                 RowBox[{"8", "+", "off1"}], ")"}]}], 
               "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"off1", "=", 
              RowBox[{"16", "*", 
               RowBox[{"(", 
                RowBox[{"indVgMaxEx", "-", "1"}], ")"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"wex", "=", 
              RowBox[{
               RowBox[{
               "w", "\[LeftDoubleBracket]", "exStates", 
                "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "+", "off1"}], ")"}], ";;", 
                RowBox[{"(", 
                 RowBox[{"16", "+", "off1"}], ")"}]}], 
               "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
              "Normalize", " ", "by", " ", "number", " ", "of", " ", "atoms", 
               " ", "in", " ", "this", " ", "velocity", " ", "bin"}], " ", 
              "*)"}], "\[IndentingNewLine]", 
             RowBox[{"tot1", "=", 
              RowBox[{"N", "[", 
               RowBox[{
                RowBox[{"Total", "[", "wgr", "]"}], "+", 
                RowBox[{"Total", "[", "wex", "]"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"popgr8", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"popgr8", ",", 
                RowBox[{"{", 
                 RowBox[{"wgr", "/", "tot1"}], "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"popex16", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"popex16", ",", 
                RowBox[{"{", 
                 RowBox[{"wex", "/", "tot1"}], "}"}]}], "]"}]}], ";"}], 
            "\[IndentingNewLine]", ",", " ", 
            RowBox[{"(*", "else", "*)"}], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"popgr8", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"popgr8", ",", 
                RowBox[{"{", 
                 RowBox[{"ConstantArray", "[", 
                  RowBox[{
                   RowBox[{"-", "1.0"}], ",", "8"}], "]"}], "}"}]}], "]"}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"popex16", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"popex16", ",", 
                RowBox[{"{", 
                 RowBox[{"ConstantArray", "[", 
                  RowBox[{
                   RowBox[{"-", "1.0"}], ",", "16"}], "]"}], "}"}]}], "]"}]}],
              ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{"Nx8", " ", "array"}], ",", " ", 
            RowBox[{
            "where", " ", "N", " ", "is", " ", "the", " ", "number", " ", 
             "of", " ", "velocity", " ", "classes"}]}], "  ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"wgrAll", "=", 
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{
             "w", "\[LeftDoubleBracket]", "grStates", 
              "\[RightDoubleBracket]"}], ",", "8"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
           "Vector", " ", "of", " ", "length", " ", "N", " ", "with", " ", 
            "the", " ", "total", " ", "excited", " ", "populations", " ", 
            RowBox[{"(", 
             RowBox[{
             "total", " ", "of", " ", "all", " ", "16", " ", "states"}], 
             ")"}], " ", "in", " ", "each", " ", "velocity", " ", "class"}], 
           " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"wexAllTotal", "=", 
           RowBox[{"Total", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{
               "w", "\[LeftDoubleBracket]", "exStates", 
                "\[RightDoubleBracket]"}], ",", "16"}], "]"}], ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"tot1", "=", 
           RowBox[{"Total", "[", "wexAllTotal", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"tot1", ">", "0"}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
             "Vector", " ", "of", " ", "length", " ", "8", " ", "containing", 
              " ", "the", " ", "ground", " ", "state", " ", "populations", 
              " ", "weighted", " ", "by", " ", "the", " ", "excited", " ", 
              "state", " ", "populations"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"popgr8WeightedLoc", "=", 
              RowBox[{
               RowBox[{"Total", "[", 
                RowBox[{
                 RowBox[{"wgrAll", "*", "wexAllTotal"}], ",", 
                 RowBox[{"{", "1", "}"}]}], "]"}], "/", "tot1"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"Normalize", " ", "to", " ", "total", " ", "1"}], " ", 
              "*)"}], "\[IndentingNewLine]", 
             RowBox[{"popgr8WeightedLoc", "/=", 
              RowBox[{"Total", "[", "popgr8WeightedLoc", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"popgr8Weighted", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"popgr8Weighted", ",", 
                RowBox[{"{", "popgr8WeightedLoc", "}"}]}], "]"}]}], ";"}], 
            "\[IndentingNewLine]", ",", " ", 
            RowBox[{"(*", " ", "ELSE", " ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"popgr8Weighted", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"popgr8Weighted", ",", 
                RowBox[{"{", 
                 RowBox[{"ConstantArray", "[", 
                  RowBox[{
                   RowBox[{"-", "1.0"}], ",", "8"}], "]"}], "}"}]}], "]"}]}], 
             ";"}]}], "\[IndentingNewLine]", "]"}], ";"}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";", " ", 
       RowBox[{"(*", " ", 
        RowBox[{"end", " ", "of", " ", 
         RowBox[{"While", "[", "]"}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"err", "=", "serror"}], ";", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
        "w", ",", "err", ",", "obs", ",", "popgr8", ",", "popex16", ",", 
         "popgr8Weighted"}], "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}],
   " ", 
  RowBox[{"(*", 
   RowBox[{"End", " ", "of", " ", 
    RowBox[{"Module", "[", "]"}], " ", 
    RowBox[{"phiv", "[", "]"}]}], " ", "*)"}]}]], "Input",
 InitializationCell->
  True],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 2}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 4}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Modified", " ", "version", " ", "of", " ", 
   RowBox[{"phiv", "[", "]"}], " ", "with", " ", "a", " ", "compiled", " ", 
   "inner", " ", "loop"}], " ", "*)"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Options", "[", "phivCompiled", "]"}], "=", 
    RowBox[{"{", 
     RowBox[{"VerbosityLevel", "\[Rule]", "2"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "The", " ", "sparse", " ", "matrix", " ", "A", " ", "is", " ", "passed", 
    " ", "to", " ", 
    RowBox[{"multiplyByA", "[", "]"}], " ", "via", " ", "the", " ", "global", 
    " ", "variable", " ", "Global`fullAmatG"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"phivCompiled", "[", 
     RowBox[{"t_", ",", "u_", ",", "v_", ",", 
      RowBox[{"obsmat_:", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"tspanMax_:", "1.0*^200"}], ",", 
      RowBox[{"tol_:", "1.0*^-7"}], ",", 
      RowBox[{"mIn_:", "-", "1"}], ",", 
      RowBox[{"indVgMaxEx_:", "-", "1"}], ",", 
      RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "n", ",", "anorm", ",", "tout", ",", "istep", ",", "tnew", ",", "tnow",
         ",", "serror", ",", "rndoff", ",", "sgn", ",", "w", ",", "err", ",", 
        "m", ",", "obs", ",", "off1", ",", "time", ",", "verb", ",", "popgr8",
         ",", "popex16", ",", "grStates", ",", "exStates", ",", "wgr", ",", 
        "wex", ",", "tot1", ",", "popgr8Weighted", ",", "wgrAll", ",", 
        "wexAllTotal", ",", "popgr8WeightedLoc", ",", "tstep", ",", "xm", ",",
         "k1", ",", "mb", ",", "out1", ",", "errloc", ",", "s"}], "}"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"function", " ", 
         RowBox[{"(", 
          RowBox[{"w", ",", "err", ",", "hump"}], ")"}]}], "=", 
        RowBox[{"expv", " ", 
         RowBox[{"(", 
          RowBox[{"t", ",", "A", ",", "v", ",", "tol", ",", "m"}], ")"}]}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{
         RowBox[{"Dimensions", "[", "Global`fullAmatG", "]"}], 
         "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", "n", "}"}], "\[NotEqual]", 
          RowBox[{"Dimensions", "[", "u", "]"}]}], ",", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<phivCompiled[]: A must be conformable with v, Dimensions[A]\
\[LeftDoubleBracket]1\[RightDoubleBracket]: \>\"", ",", " ", 
            RowBox[{"{", "n", "}"}], ",", " ", "\"\<, Dimensions[u]: \>\"", 
            ",", " ", 
            RowBox[{"Dimensions", "[", "u", "]"}]}], "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}], ",", 
         RowBox[{
          RowBox[{"{", "}"}], ";"}], ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<u\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", "n", "}"}], "\[NotEqual]", 
          RowBox[{"Dimensions", "[", "v", "]"}]}], ",", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<phivCompiled[]: A must be conformable with v, Dimensions[A]\
\[LeftDoubleBracket]1\[RightDoubleBracket]: \>\"", ",", " ", 
            RowBox[{"{", "n", "}"}], ",", " ", "\"\<, Dimensions[v]: \>\"", 
            ",", " ", 
            RowBox[{"Dimensions", "[", "v", "]"}]}], "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}], ",", 
         RowBox[{
          RowBox[{"{", "}"}], ";"}], ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<v\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"Since", " ", "the", " ", "matrix", " ", "A", " ", 
          RowBox[{"doesn", "'"}], "t", " ", "have", " ", "to", " ", "be", " ",
           "passed"}], ",", " ", 
         RowBox[{
         "check", " ", "here", " ", "if", " ", "the", " ", "2", "nd", " ", 
          "argument", " ", "u", " ", "is", " ", "a", " ", "matrix", " ", 
          "instead", " ", "of", " ", "a", " ", "vector"}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixQ", "[", 
           RowBox[{"u", ",", "NumericQ"}], "]"}], "\[Equal]", "True"}], " ", 
         ",", 
         RowBox[{
          RowBox[{
          "Print", "[", 
           "\"\<phivCompiled[]: Second argument should be the vector u, not a \
matrix (different argument list than phiv[])!\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}], ",", 
         RowBox[{
          RowBox[{"{", "}"}], ";"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixQ", "[", 
           RowBox[{"Global`fullAmatG", ",", "NumericQ"}], "]"}], "\[Equal]", 
          "False"}], " ", ",", 
         RowBox[{
          RowBox[{
          "Print", "[", "\"\<phivCompiled[]: A is nonnumeric\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}]}], ",", 
         RowBox[{
          RowBox[{"{", "}"}], ";"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixQ", "[", 
           RowBox[{
            RowBox[{"{", "u", "}"}], ",", "NumericQ"}], "]"}], "\[Equal]", 
          "False"}], " ", ",", 
         RowBox[{
          RowBox[{
          "Print", "[", "\"\<phivCompiled[]: u is nonnumeric\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}], ";"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixQ", "[", 
           RowBox[{
            RowBox[{"{", "v", "}"}], ",", "NumericQ"}], "]"}], "\[Equal]", 
          "False"}], " ", ",", 
         RowBox[{
          RowBox[{
          "Print", "[", "\"\<phivCompiled[]: v is nonnumeric\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}], ";"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"MatrixQ", "[", 
            RowBox[{
             RowBox[{"{", "obsmat", "}"}], ",", "NumericQ"}], "]"}], 
           "\[Equal]", "False"}], " ", "&&", 
          RowBox[{"obsmat", "\[NotEqual]", 
           RowBox[{"{", "}"}]}]}], ",", 
         RowBox[{
          RowBox[{
          "Print", "[", "\"\<phivCompiled[]: resultmat is nonnumeric\>\"", 
           "]"}], ";", 
          RowBox[{"Abort", "[", "]"}], ";"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"verb", "=", 
        RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Positions", " ", "of", " ", "the", " ", "ground", " ", "state", " ", 
         "populations"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"grStates", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Position", "[", 
          RowBox[{"u", ",", 
           RowBox[{"x_", "/;", 
            RowBox[{"x", "!=", "0"}]}]}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Positions", " ", "of", " ", "the", " ", "excited", " ", "state", " ",
          "populations"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"exStates", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Position", "[", 
          RowBox[{"obsmat", ",", 
           RowBox[{"x_", "/;", 
            RowBox[{"x", ">", "0"}]}]}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"popgr8", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"popex16", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"popgr8Weighted", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"[", 
           RowBox[{"n", ",", "n"}], "]"}], "=", 
          RowBox[{"size", " ", 
           RowBox[{"(", "A", ")"}]}]}], ";"}], "*)"}], 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"if", " ", "nargin"}], "\[Equal]", "3"}], ",", 
         RowBox[{
          RowBox[{"tol", "=", 
           RowBox[{"1.0", "*", 
            RowBox[{"10", "^", 
             RowBox[{"(", 
              RowBox[{"-", "7"}], ")"}]}]}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"m", "=", 
           RowBox[{"min", " ", 
            RowBox[{"(", 
             RowBox[{"n", ",", "30"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
          "end", ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"if", " ", "nargin"}], "\[Equal]", "4"}]}], ",", 
         RowBox[{
          RowBox[{"m", "=", 
           RowBox[{"min", " ", 
            RowBox[{"(", 
             RowBox[{"n", ",", "30"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
          "end", ";"}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"m", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"mIn", "\[Equal]", 
           RowBox[{"-", "1"}]}], ",", 
          RowBox[{"Min", "[", 
           RowBox[{"n", ",", "30"}], "]"}], ",", "mIn"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"anorm", "=", 
        RowBox[{"Norm", "[", 
         RowBox[{"Global`fullAmatG", ",", "Infinity"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tout", "=", 
        RowBox[{"N", "[", 
         RowBox[{"Abs", "[", "t", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"istep", "=", "0"}], ";", 
       RowBox[{"tnew", "=", "0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"tnow", "=", "0"}], ";", 
       RowBox[{"serror", "=", "0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"rndoff", "=", 
        RowBox[{"anorm", "*", "$MachineEpsilon"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"sgn", "=", 
        RowBox[{"N", "[", 
         RowBox[{"Sign", "[", "t", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"xm", "=", 
        RowBox[{"1.0", "/", "m"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"mb", "=", "m"}], ";", "\[IndentingNewLine]", 
       RowBox[{"k1", "=", "3"}], ";", "\[IndentingNewLine]", 
       RowBox[{"obs", "=", 
        RowBox[{"{", "}"}]}], ";", " ", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Used", " ", "to", " ", "accumulate", " ", "return", " ", "flux", " ",
          "samples"}], " ", "*)"}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"w", "=", "v"}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", "  ", 
        RowBox[{
         RowBox[{"===", "===", "===", "===", "===", " ", 
          RowBox[{"Main", " ", "Loop"}], " ", "===", "===", "===", "===", "===",
           "==="}], "="}], "  ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{"tnow", "<", "tout"}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"time", "=", 
           RowBox[{"Timing", "[", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"Due", " ", "to", " ", "restrictions", " ", "of", " ", 
               RowBox[{"Compile", "[", "]"}]}], ",", " ", 
              RowBox[{
              "the", " ", "output", " ", "is", " ", "a", " ", "single", " ", 
               "vector", " ", "with", " ", "the", " ", "following", " ", 
               RowBox[{"elements", ":", " ", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                  "w", ",", "istep", ",", "tstep", ",", "tnew", ",", "tnow", 
                   ",", "errloc", ",", "s", ",", "xm", ",", "mb"}], "}"}], 
                 "\[IndentingNewLine]", "All", " ", "floating", " ", "point", 
                 " ", "variables", " ", "are", " ", "real"}]}]}], ",", " ", 
              RowBox[{"not", " ", "complex"}]}], "  ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"out1", "=", 
              RowBox[{"phivLoopCompiled", "[", 
               RowBox[{
               "m", ",", "n", ",", "w", ",", "u", ",", "istep", ",", "tout", 
                ",", "tnow", ",", "tnew", ",", "tspanMax", ",", "sgn", ",", 
                "tol", ",", "rndoff", ",", "anorm", ",", "xm", ",", "mb", ",",
                 "k1"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"w", "=", 
              RowBox[{"out1", "\[LeftDoubleBracket]", 
               RowBox[{"1", ";;", 
                RowBox[{"Length", "[", "v", "]"}]}], 
               "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"istep", "=", 
              RowBox[{"Round", "[", 
               RowBox[{"out1", "\[LeftDoubleBracket]", 
                RowBox[{"-", "8"}], "\[RightDoubleBracket]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"tstep", "=", 
              RowBox[{"out1", "\[LeftDoubleBracket]", 
               RowBox[{"-", "7"}], "\[RightDoubleBracket]"}]}], ";", 
             RowBox[{"tnew", "=", 
              RowBox[{"out1", "\[LeftDoubleBracket]", 
               RowBox[{"-", "6"}], "\[RightDoubleBracket]"}]}], ";", " ", 
             RowBox[{"tnow", "=", 
              RowBox[{"out1", "\[LeftDoubleBracket]", 
               RowBox[{"-", "5"}], "\[RightDoubleBracket]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"errloc", "=", 
              RowBox[{"out1", "\[LeftDoubleBracket]", 
               RowBox[{"-", "4"}], "\[RightDoubleBracket]"}]}], ";", 
             RowBox[{"s", "=", 
              RowBox[{"out1", "\[LeftDoubleBracket]", 
               RowBox[{"-", "3"}], "\[RightDoubleBracket]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"xm", "=", 
              RowBox[{"out1", "\[LeftDoubleBracket]", 
               RowBox[{"-", "2"}], "\[RightDoubleBracket]"}]}], ";", 
             RowBox[{"mb", "=", 
              RowBox[{"Round", "[", 
               RowBox[{"out1", "\[LeftDoubleBracket]", 
                RowBox[{"-", "1"}], "\[RightDoubleBracket]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"serror", "+=", "errloc"}], ";"}], "\[IndentingNewLine]",
             "]"}]}], ";", " ", 
          RowBox[{"(*", " ", 
           RowBox[{"End", " ", "of", " ", 
            RowBox[{"Timing", "[", "]"}]}], " ", "*)"}], 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"istep", "\[LessEqual]", "4"}], "&&", 
              RowBox[{"verb", ">", "3"}]}], "||", 
             RowBox[{"verb", ">", "5"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{
              "\"\<    Step \>\"", ",", "istep", ",", "\"\<: tstep = \>\"", 
               ",", " ", 
               RowBox[{
                RowBox[{"10.0", "^", "9"}], "*", "tstep"}], ",", " ", 
               "\"\< ns\>\"", ",", " ", "\"\<, tnow = \>\"", ",", " ", 
               RowBox[{
                RowBox[{"10.0", "^", "9"}], "*", "tnow"}], ",", " ", 
               "\"\< ns, (\>\"", ",", 
               RowBox[{
               "time", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}],
                ",", "\"\< s)\>\""}], "]"}], ";"}]}], "]"}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"Code", " ", "inserted", " ", "by", " ", "Ron", " ", 
            RowBox[{"Holzloehner", ":", " ", 
             RowBox[{
             "Compute", " ", "the", " ", "return", " ", "flux", " ", "at", 
              " ", "tnow"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"n", "==", 
             RowBox[{"Max", "[", 
              RowBox[{"Dimensions", "[", "obsmat", "]"}], "]"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"obs", ",", 
               RowBox[{"{", 
                RowBox[{"tnow", ",", 
                 RowBox[{"Re", "[", 
                  RowBox[{"obsmat", ".", "w"}], "]"}]}], "}"}]}], "]"}], 
             ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"indVgMaxEx", "\[GreaterEqual]", "1"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"off1", "=", 
              RowBox[{"8", "*", 
               RowBox[{"(", 
                RowBox[{"indVgMaxEx", "-", "1"}], ")"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"wgr", "=", 
              RowBox[{
               RowBox[{
               "w", "\[LeftDoubleBracket]", "grStates", 
                "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "+", "off1"}], ")"}], ";;", 
                RowBox[{"(", 
                 RowBox[{"8", "+", "off1"}], ")"}]}], 
               "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"off1", "=", 
              RowBox[{"16", "*", 
               RowBox[{"(", 
                RowBox[{"indVgMaxEx", "-", "1"}], ")"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"wex", "=", 
              RowBox[{
               RowBox[{
               "w", "\[LeftDoubleBracket]", "exStates", 
                "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "+", "off1"}], ")"}], ";;", 
                RowBox[{"(", 
                 RowBox[{"16", "+", "off1"}], ")"}]}], 
               "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
              "Normalize", " ", "by", " ", "number", " ", "of", " ", "atoms", 
               " ", "in", " ", "this", " ", "velocity", " ", "bin"}], " ", 
              "*)"}], "\[IndentingNewLine]", 
             RowBox[{"tot1", "=", 
              RowBox[{"N", "[", 
               RowBox[{
                RowBox[{"Total", "[", "wgr", "]"}], "+", 
                RowBox[{"Total", "[", "wex", "]"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"popgr8", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"popgr8", ",", 
                RowBox[{"{", 
                 RowBox[{"wgr", "/", "tot1"}], "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"popex16", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"popex16", ",", 
                RowBox[{"{", 
                 RowBox[{"wex", "/", "tot1"}], "}"}]}], "]"}]}], ";"}], 
            "\[IndentingNewLine]", ",", " ", 
            RowBox[{"(*", "else", "*)"}], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"popgr8", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"popgr8", ",", 
                RowBox[{"{", 
                 RowBox[{"ConstantArray", "[", 
                  RowBox[{
                   RowBox[{"-", "1.0"}], ",", "8"}], "]"}], "}"}]}], "]"}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"popex16", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"popex16", ",", 
                RowBox[{"{", 
                 RowBox[{"ConstantArray", "[", 
                  RowBox[{
                   RowBox[{"-", "1.0"}], ",", "16"}], "]"}], "}"}]}], "]"}]}],
              ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{"Nx8", " ", "array"}], ",", " ", 
            RowBox[{
            "where", " ", "N", " ", "is", " ", "the", " ", "number", " ", 
             "of", " ", "velocity", " ", "classes"}]}], "  ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"wgrAll", "=", 
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{
             "w", "\[LeftDoubleBracket]", "grStates", 
              "\[RightDoubleBracket]"}], ",", "8"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
           "Vector", " ", "of", " ", "length", " ", "N", " ", "with", " ", 
            "the", " ", "total", " ", "excited", " ", "populations", " ", 
            RowBox[{"(", 
             RowBox[{
             "total", " ", "of", " ", "all", " ", "16", " ", "states"}], 
             ")"}], " ", "in", " ", "each", " ", "velocity", " ", "class"}], 
           " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"wexAllTotal", "=", 
           RowBox[{"Total", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{
               "w", "\[LeftDoubleBracket]", "exStates", 
                "\[RightDoubleBracket]"}], ",", "16"}], "]"}], ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"tot1", "=", 
           RowBox[{"Total", "[", "wexAllTotal", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"tot1", ">", "0"}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
             "Vector", " ", "of", " ", "length", " ", "8", " ", "containing", 
              " ", "the", " ", "ground", " ", "state", " ", "populations", 
              " ", "weighted", " ", "by", " ", "the", " ", "excited", " ", 
              "state", " ", "populations"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"popgr8WeightedLoc", "=", 
              RowBox[{
               RowBox[{"Total", "[", 
                RowBox[{
                 RowBox[{"wgrAll", "*", "wexAllTotal"}], ",", 
                 RowBox[{"{", "1", "}"}]}], "]"}], "/", "tot1"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"Normalize", " ", "to", " ", "total", " ", "1"}], " ", 
              "*)"}], "\[IndentingNewLine]", 
             RowBox[{"popgr8WeightedLoc", "/=", 
              RowBox[{"Total", "[", "popgr8WeightedLoc", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"popgr8Weighted", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"popgr8Weighted", ",", 
                RowBox[{"{", "popgr8WeightedLoc", "}"}]}], "]"}]}], ";"}], 
            "\[IndentingNewLine]", ",", " ", 
            RowBox[{"(*", " ", "ELSE", " ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"popgr8Weighted", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"popgr8Weighted", ",", 
                RowBox[{"{", 
                 RowBox[{"ConstantArray", "[", 
                  RowBox[{
                   RowBox[{"-", "1.0"}], ",", "8"}], "]"}], "}"}]}], "]"}]}], 
             ";"}]}], "\[IndentingNewLine]", "]"}], ";"}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";", " ", 
       RowBox[{"(*", " ", 
        RowBox[{"end", " ", "of", " ", 
         RowBox[{"While", "[", "]"}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"err", "=", "serror"}], ";", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
        "w", ",", "err", ",", "obs", ",", "popgr8", ",", "popex16", ",", 
         "popgr8Weighted"}], "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}],
   " ", 
  RowBox[{"(*", 
   RowBox[{"End", " ", "of", " ", 
    RowBox[{"Module", "[", "]"}]}], "*)"}]}]}], "Input",
 InitializationCell->
  True],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 0.5}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 3}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Inner", " ", "loop", " ", "of", " ", 
    RowBox[{"Expokit", "'"}], "s", " ", "phiv", " ", "routine"}], ",", " ", 
   RowBox[{"sped", " ", "up", " ", "with", " ", 
    RowBox[{
     RowBox[{"Compile", "[", "]"}], ".", " ", "All"}], " ", "floating", " ", 
    "point", " ", "variables", " ", "are", " ", "of", " ", "type", " ", 
    "real"}], ",", " ", 
   RowBox[{"not", " ", 
    RowBox[{"complex", ".", "\[IndentingNewLine]", "Ron"}], " ", 
    "Holzloehner"}], ",", " ", 
   RowBox[{"12", "Sep2011"}]}], "\[IndentingNewLine]", " ", "*)"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"phivLoopCompiled", "=", 
    RowBox[{"Compile", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"m", ",", "_Integer"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", "_Integer"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"wIn", ",", "_Real", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"u", ",", "_Real", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"istepIn", ",", "_Integer"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"tout", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"tnowIn", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"tnewIn", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"tspanMax", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"sgn", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"tol", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"rndoff", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"anorm", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"xmIn", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"mbIn", ",", "_Integer"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"k1In", ",", "_Integer"}], "}"}]}], "}"}], ",", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"mxrej", "=", "10"}], ",", 
          RowBox[{"btol", "=", "1.0*^-7"}], ",", 
          RowBox[{"gamma", "=", "0.9"}], ",", 
          RowBox[{"delta", "=", "1.2"}], ",", 
          RowBox[{"mb", "=", "mbIn"}], ",", 
          RowBox[{"k1", "=", "k1In"}], ",", 
          RowBox[{"xm", "=", "xmIn"}], ",", 
          RowBox[{"beta", "=", "0.0"}], ",", 
          RowBox[{"fact", "=", "0.0"}], ",", 
          RowBox[{"s", "=", "0.0"}], ",", 
          RowBox[{"tstep", "=", "0.0"}], ",", 
          RowBox[{"Vt", "=", 
           RowBox[{"ConstantArray", "[", 
            RowBox[{"0.0", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"m", "+", "1"}], ",", "n"}], "}"}]}], "]"}]}], ",", 
          RowBox[{"Vt1", "=", 
           RowBox[{
            RowBox[{"multiplyByA", "[", " ", "wIn", "]"}], "+", "u"}]}], ",", 
          
          RowBox[{"H", "=", 
           RowBox[{"ConstantArray", "[", 
            RowBox[{"0.0", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"m", "+", "3"}], ",", 
               RowBox[{"m", "+", "3"}]}], "}"}]}], "]"}]}], ",", 
          RowBox[{"p", "=", "u"}], ",", "i", ",", "j", ",", 
          RowBox[{"avnorm", "=", "0.0"}], ",", 
          RowBox[{"ireject", "=", "0"}], ",", 
          RowBox[{"mx", "=", "0"}], ",", 
          RowBox[{"errloc", "=", "0.0"}], ",", 
          RowBox[{"p1", "=", "0.0"}], ",", 
          RowBox[{"p2", "=", "0.0"}], ",", 
          RowBox[{"h", "=", "0.0"}], ",", 
          RowBox[{"F", "=", 
           RowBox[{"ConstantArray", "[", 
            RowBox[{"0.0", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "2"}], "}"}]}], "]"}]}], ",", 
          RowBox[{"tnow", "=", "tnowIn"}], ",", 
          RowBox[{"tnew", "=", "tnewIn"}], ",", 
          RowBox[{"istep", "=", "istepIn"}], ",", 
          RowBox[{"w", "=", "wIn"}], ",", 
          RowBox[{"Hij", "=", "0.0"}], ",", 
          RowBox[{"Vti", "=", "u"}]}], "}"}], ",", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Vt", "=", 
           RowBox[{"ConstantArray", "[", 
            RowBox[{"0.0", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"m", "+", "1"}], ",", "n"}], "}"}]}], "]"}]}], ";", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"V", "=", 
             RowBox[{"zeros", " ", 
              RowBox[{"(", 
               RowBox[{"n", ",", 
                RowBox[{"m", "+", "1"}]}], ")"}]}]}], ";"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"H", "=", 
           RowBox[{"ConstantArray", "[", 
            RowBox[{"0.0", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"m", "+", "3"}], ",", 
               RowBox[{"m", "+", "3"}]}], "}"}]}], "]"}]}], ";"}], 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"H", "=", 
            RowBox[{"zeros", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"m", "+", "3"}], ",", 
               RowBox[{"m", "+", "3"}]}], ")"}]}]}], ";"}], "*)"}], 
         "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"A", " ", "has", " ", "dimensions", "  ", 
          RowBox[{"{", 
           RowBox[{"n", ",", 
            RowBox[{"Length", "[", "w", "]"}]}], "}"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"Vt1", " ", "=", " ", 
            RowBox[{
             RowBox[{"A", ".", "w"}], "+", "u"}]}], ";"}], "   ", "<", 
          RowBox[{
           RowBox[{"--", " ", "Now"}], " ", "in", " ", "parameter", " ", 
           "initialization"}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"beta", "=", 
          RowBox[{"Norm", "[", 
           RowBox[{"Vt1", ",", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"V", "\[LeftDoubleBracket]", 
             RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "=", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1.0", "/", "beta"}], ")"}], "*", "w"}]}], ";", "    ", 
           
           RowBox[{
            RowBox[{"V", " ", 
             RowBox[{"(", 
              RowBox[{":", 
               RowBox[{",", "1"}]}], ")"}]}], "=", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "/", "beta"}], ")"}], "*", "w"}]}], ";"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"Vt1", "*=", 
          RowBox[{"(", 
           RowBox[{"1.0", "/", "beta"}], ")"}]}], ";", "\[IndentingNewLine]", 
         
         RowBox[{
          RowBox[{
          "Vt", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], "=", 
          "Vt1"}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"istep", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"fact", "=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"m", "+", "1.0"}], ")"}], "/", "E"}], ")"}], "^", 
                RowBox[{"(", 
                 RowBox[{"m", "+", "1"}], ")"}]}], ")"}], "*", 
              RowBox[{"Sqrt", "[", 
               RowBox[{"2.0", "*", "Pi", "*", 
                RowBox[{"(", 
                 RowBox[{"m", "+", "1"}], ")"}]}], "]"}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"tnew", "=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1.0", "/", "anorm"}], ")"}], "*", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"fact", "*", "tol"}], ")"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"4", "*", "beta", "*", "anorm"}], ")"}]}], ")"}], 
               "^", "xm"}]}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"s", "=", 
             RowBox[{"10.0", "^", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Floor", "[", 
                 RowBox[{"Log10", "[", "tnew", "]"}], "]"}], "-", "1"}], 
               ")"}]}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"tnew", "=", 
             RowBox[{
              RowBox[{"Ceiling", "[", 
               RowBox[{"tnew", "/", "s"}], "]"}], "*", "s"}]}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"istep", "++"}], ";", "\[IndentingNewLine]", 
         RowBox[{"tstep", "=", 
          RowBox[{"Min", "[", 
           RowBox[{
            RowBox[{"tout", "-", "tnow"}], ",", "tnew"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"tstep", "=", 
          RowBox[{"Min", "[", 
           RowBox[{"tstep", ",", "tspanMax"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"j", "=", "1"}], ",", 
           RowBox[{"j", "\[LessEqual]", "m"}], ",", 
           RowBox[{"j", "++"}], ",", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"for", " ", "j"}], "=", 
             RowBox[{"1", ":", "m"}]}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"p", "=", 
             RowBox[{"multiplyByA", "[", 
              RowBox[{
              "Vt", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
              "]"}]}], ";", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{"p", "=", 
               RowBox[{"A", "*", "V", " ", 
                RowBox[{"(", 
                 RowBox[{":", 
                  RowBox[{",", "j"}]}], ")"}]}]}], ";"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
             "The", " ", "following", " ", "loop", " ", "eats", " ", "up", 
              " ", "80", "%", " ", "or", " ", "so", " ", "of", " ", "the", 
              " ", "total", " ", "CPU", " ", "time"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"For", "[", 
             RowBox[{
              RowBox[{"i", "=", "1"}], ",", 
              RowBox[{"i", "\[LessEqual]", "j"}], ",", 
              RowBox[{"i", "++"}], ",", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"for", " ", "i"}], "=", 
                RowBox[{"1", ":", "j"}]}], "*)"}], "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{"WARNING", ":", " ", 
                RowBox[{
                "The", " ", "following", " ", "line", " ", "should", " ", 
                 "use", " ", "the", " ", 
                 RowBox[{"Conjugate", "[", "]"}], " ", 
                 RowBox[{"function", ".", " ", "We"}], " ", "omit", " ", "it",
                  " ", "to", " ", "speed", " ", "up", " ", "the", " ", "code",
                  " ", "for", " ", "type", " ", "real", " ", 
                 RowBox[{
                  RowBox[{"only", "!!"}], "!"}]}]}], " ", "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"H", "\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}], "=", 
                 RowBox[{
                  RowBox[{"Conjugate", "[", 
                   RowBox[{
                   "Vt", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}], "]"}], ".", "p"}]}], ";"}], 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{
                  RowBox[{"H", " ", 
                   RowBox[{"(", 
                    RowBox[{"i", ",", "j"}], ")"}]}], "=", 
                  RowBox[{"V", " ", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{":", 
                    RowBox[{",", "i"}]}], ")"}], "'"}], "*", "p"}]}], ";"}], 
                "*)"}], "*)"}], "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Vti", "=", 
                RowBox[{
                "Vt", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]}]
                , ";", "\[IndentingNewLine]", 
               RowBox[{"(*", " ", 
                RowBox[{
                 RowBox[{
                  RowBox[{"H", "\[LeftDoubleBracket]", 
                   RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}], "=", 
                  RowBox[{"Vti", ".", "p"}]}], ";"}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{"Hij", "=", 
                RowBox[{"Vti", ".", "p"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"p", "-=", 
                RowBox[{"Hij", " ", "*", " ", "Vti"}]}], ";", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{"p", "=", 
                  RowBox[{"p", "-", 
                   RowBox[{"H", " ", 
                    RowBox[{"(", 
                    RowBox[{"i", ",", "j"}], ")"}], "*", "V", " ", 
                    RowBox[{"(", 
                    RowBox[{":", 
                    RowBox[{",", "i"}]}], ")"}]}]}]}], ";"}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"H", "\[LeftDoubleBracket]", 
                 RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}], "=", 
                "Hij"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
            RowBox[{"(*", 
             RowBox[{"for", " ", "i"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"s", "=", 
             RowBox[{"Norm", "[", 
              RowBox[{"p", ",", "2"}], "]"}]}], ";", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{"s", "=", 
               RowBox[{"norm", " ", 
                RowBox[{"(", "p", ")"}]}]}], ";"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"s", "<", "btol"}], ",", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{"if", " ", "s"}], "<", "btol"}], ","}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"k1", "=", "0"}], ";", "\[IndentingNewLine]", 
               RowBox[{"mb", "=", "j"}], ";", "\[IndentingNewLine]", 
               RowBox[{"tstep", "=", 
                RowBox[{"tout", "-", "tnow"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"tstep", "=", 
                RowBox[{"Min", "[", 
                 RowBox[{"tstep", ",", "tspanMax"}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Break", "[", "]"}]}]}], 
             RowBox[{"(*", 
              RowBox[{"break", ";"}], "*)"}], "\[IndentingNewLine]", "]"}], 
            ";", 
            RowBox[{"(*", " ", "if", " ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"H", "\[LeftDoubleBracket]", 
              RowBox[{
               RowBox[{"j", "+", "1"}], ",", "j"}], "\[RightDoubleBracket]"}],
              "=", "s"}], ";", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
               RowBox[{"H", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"j", "+", "1"}], ",", "j"}], ")"}]}], "=", "s"}], 
              ";"}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
               RowBox[{"V", " ", 
                RowBox[{"(", 
                 RowBox[{":", 
                  RowBox[{",", 
                   RowBox[{"j", "+", "1"}]}]}], ")"}]}], "=", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "/", "s"}], ")"}], "*", "p"}]}], ";"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Vt", "\[LeftDoubleBracket]", 
              RowBox[{"j", "+", "1"}], "\[RightDoubleBracket]"}], "=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1.0", "/", "s"}], ")"}], "*", "p"}]}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"for", " ", "j"}], ";"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"H", "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", 
            RowBox[{"mb", "+", "1"}]}], "\[RightDoubleBracket]"}], "=", "1"}],
          ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"k1", "\[NotEqual]", "0"}], ",", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"if", " ", 
              RowBox[{"k1", "~", 
               RowBox[{"=", "0"}]}]}], ","}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"H", "\[LeftDoubleBracket]", 
              RowBox[{
               RowBox[{"m", "+", "1"}], ",", 
               RowBox[{"m", "+", "2"}]}], "\[RightDoubleBracket]"}], "=", 
             "1.0"}], ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"H", "\[LeftDoubleBracket]", 
              RowBox[{
               RowBox[{"m", "+", "2"}], ",", 
               RowBox[{"m", "+", "3"}]}], "\[RightDoubleBracket]"}], "=", 
             "1.0"}], ";", "\[IndentingNewLine]", 
            RowBox[{"h", "=", 
             RowBox[{"H", "\[LeftDoubleBracket]", 
              RowBox[{
               RowBox[{"m", "+", "1"}], ",", "m"}], 
              "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"H", "\[LeftDoubleBracket]", 
              RowBox[{
               RowBox[{"m", "+", "1"}], ",", "m"}], "\[RightDoubleBracket]"}],
              "=", "0.0"}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{"avnorm", "=", 
               RowBox[{"norm", " ", 
                RowBox[{"(", 
                 RowBox[{"A", "*", "V", " ", 
                  RowBox[{"(", 
                   RowBox[{":", 
                    RowBox[{",", 
                    RowBox[{"m", "+", "1"}]}]}], ")"}]}], ")"}]}]}], ";"}], 
             "*)"}], "\[IndentingNewLine]", 
            RowBox[{"avnorm", "=", 
             RowBox[{"Norm", "[", 
              RowBox[{"multiplyByA", "[", 
               RowBox[{"Vt", "\[LeftDoubleBracket]", 
                RowBox[{"m", "+", "1"}], "\[RightDoubleBracket]"}], "]"}], 
              " ", "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
         RowBox[{"(*", "if", "*)"}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"ireject", "=", "0"}], ";", "\[IndentingNewLine]", 
         RowBox[{"While", "[", 
          RowBox[{
           RowBox[{"ireject", "\[LessEqual]", "mxrej"}], ",", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"while", " ", "ireject"}], "\[LessEqual]", "mxrej"}], 
             ","}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"mx", "=", 
             RowBox[{"mb", "+", 
              RowBox[{"Max", "[", 
               RowBox[{"1", ",", "k1"}], "]"}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{
               RowBox[{"If", " ", 
                RowBox[{"Range", "[", 
                 RowBox[{"1", ",", "mx"}], "]"}], " ", "is", " ", "replaced", 
                " ", "by", " ", "1"}], ";;", "mx"}], ",", " ", 
              RowBox[{
              "we", " ", "get", " ", "a", " ", "compilation", " ", 
               "error"}]}], " ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"Re", "[", "]"}], " ", "added", " ", "on", " ", "09", 
              "Sep11", " ", "since", " ", 
              RowBox[{"MatrixExp", "[", "]"}], " ", "sometimes", " ", 
              "returns", " ", "complex", " ", "numbers"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{"Runtime", " ", "of", " ", 
              RowBox[{"MatrixExp", "[", "]"}], " ", "was", " ", "checked", 
              " ", "with", " ", 
              RowBox[{"Timing", "[", "]"}], " ", "and", " ", "was", " ", 
              "negligible"}], " ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{"F", "=", 
             RowBox[{"Re", "[", 
              RowBox[{"MatrixExp", "[", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"sgn", "*", "tstep"}], ")"}], "*", " ", 
                RowBox[{"H", "\[LeftDoubleBracket]", 
                 RowBox[{
                  RowBox[{"Range", "[", 
                   RowBox[{"1", ",", "mx"}], "]"}], ",", 
                  RowBox[{"1", ";;", "mx"}]}], "\[RightDoubleBracket]"}]}], 
               " ", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{"F", "=", 
               RowBox[{"expm", " ", 
                RowBox[{"(", 
                 RowBox[{"sgn", "*", "t_step", "*", "H", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"1", ":", "mx"}], ",", 
                    RowBox[{"1", ":", "mx"}]}], ")"}]}], ")"}]}]}], ";"}], 
             "*)"}], "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"k1", "\[Equal]", "0"}], ",", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{"if", " ", "k1"}], "\[Equal]", "0"}], ","}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"errloc", "=", "btol"}], ";", "\[IndentingNewLine]", 
               RowBox[{"Break", "[", "]"}], ";"}], ",", 
              RowBox[{"(*", 
               RowBox[{"break", ";"}], "*)"}], "\[IndentingNewLine]", 
              RowBox[{"(*", " ", "Else", " ", "*)"}], "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"F", "\[LeftDoubleBracket]", 
                 RowBox[{
                  RowBox[{"m", "+", "1"}], ",", 
                  RowBox[{"m", "+", "1"}]}], "\[RightDoubleBracket]"}], "=", 
                RowBox[{"h", "*", 
                 RowBox[{"F", "\[LeftDoubleBracket]", 
                  RowBox[{"m", ",", 
                   RowBox[{"m", "+", "2"}]}], "\[RightDoubleBracket]"}]}]}], 
               ";", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"F", "\[LeftDoubleBracket]", 
                 RowBox[{
                  RowBox[{"m", "+", "2"}], ",", 
                  RowBox[{"m", "+", "1"}]}], "\[RightDoubleBracket]"}], "=", 
                RowBox[{"h", "*", 
                 RowBox[{"F", "\[LeftDoubleBracket]", 
                  RowBox[{"m", ",", 
                   RowBox[{"m", "+", "3"}]}], "\[RightDoubleBracket]"}]}]}], 
               ";", "\[IndentingNewLine]", 
               RowBox[{"p1", "=", 
                RowBox[{"Abs", "[", 
                 RowBox[{"beta", "*", 
                  RowBox[{"F", "\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{"m", "+", "1"}], ",", 
                    RowBox[{"m", "+", "1"}]}], "\[RightDoubleBracket]"}]}], 
                 "]"}]}], ";", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{"abs", " ", 
                  RowBox[{"(", 
                   RowBox[{"beta", "*", "F", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"m", "+", "1"}], ",", 
                    RowBox[{"m", "+", "1"}]}], ")"}]}], ")"}]}], ";"}], 
                "*)"}], "\[IndentingNewLine]", 
               RowBox[{"p2", "=", 
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"beta", "*", "avnorm"}], ")"}], "*", 
                  RowBox[{"F", "\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{"m", "+", "2"}], ",", 
                    RowBox[{"m", "+", "1"}]}], "\[RightDoubleBracket]"}]}], 
                 "]"}]}], ";", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{"abs", " ", 
                  RowBox[{"(", 
                   RowBox[{"beta", "*", "F", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"m", "+", "2"}], ",", 
                    RowBox[{"m", "+", "1"}]}], ")"}], "*", "avnorm"}], 
                   ")"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"p1", ">", 
                  RowBox[{"10.0", "*", "p2"}]}], ",", 
                 RowBox[{"(*", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"if", " ", "phi1"}], ">", 
                    RowBox[{"10", "*", "phi2"}]}], ","}], "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"errloc", "=", "p2"}], ";", "\[IndentingNewLine]", 
                  RowBox[{"xm", "=", 
                   RowBox[{"1.0", "/", "m"}]}], ";"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"(*", " ", "Else", " ", "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"p1", ">", "p2"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"errloc", "=", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"p1", "*", "p2"}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"p1", "-", "p2"}], ")"}]}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"xm", "=", 
                    RowBox[{"1.0", "/", "m"}]}], ";"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", "Else", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"errloc", "=", "p1"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"xm", "=", 
                    RowBox[{"1.0", "/", 
                    RowBox[{"(", 
                    RowBox[{"m", "-", "1"}], ")"}]}]}], ";"}]}], 
                   "\[IndentingNewLine]", "]"}], ";"}]}], 
                "\[IndentingNewLine]", "]"}], ";"}]}], " ", 
             "\[IndentingNewLine]", "]"}], ";", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"If", " ", "k"}], "\[Equal]", "1"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"errloc", "\[LessEqual]", 
               RowBox[{"delta", "*", "tstep", "*", "tol"}]}], ",", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{"if", " ", "err_loc"}], "\[LessEqual]", 
                 RowBox[{"delta", "*", "t_step", "*", "tol"}]}], ","}], 
               "*)"}], "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Break", "[", "]"}], ";"}], ",", "\[IndentingNewLine]", 
              RowBox[{"(*", "Else", "*)"}], "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"tstep", "=", 
                RowBox[{"gamma", "*", "tstep", "*", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"tstep", "*", 
                    RowBox[{"tol", "/", "errloc"}]}], ")"}], "^", "xm"}]}]}], 
               ";", "\[IndentingNewLine]", 
               RowBox[{"tstep", "=", 
                RowBox[{"Min", "[", 
                 RowBox[{"tstep", ",", "tspanMax"}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"s", "=", 
                RowBox[{"10.0", "^", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Floor", "[", 
                    RowBox[{"Log10", "[", "tstep", "]"}], "]"}], "-", "1"}], 
                  ")"}]}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"tstep", "=", 
                RowBox[{
                 RowBox[{"Ceiling", "[", 
                  RowBox[{"tstep", "/", "s"}], "]"}], "*", "s"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"ireject", "\[Equal]", "mxrej"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                  "Print", "[", 
                   "\"\<phivLoopCompiled[]: The requested tolerance is too \
high!\>\"", "]"}], ";", "\[IndentingNewLine]", 
                  RowBox[{"Abort", "[", "]"}], ";"}]}], "\[IndentingNewLine]",
                 "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"ireject", "++"}], ";"}]}], "\[IndentingNewLine]", 
             "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
         RowBox[{"(*", " ", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{"ireject", "\[LessEqual]", "mxrej"}], ",", "..."}], "]"}],
           " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"mx", "=", 
          RowBox[{"mb", "+", 
           RowBox[{"Max", "[", 
            RowBox[{"0", ",", 
             RowBox[{"k1", "-", "2"}]}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"w", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"Vt", "\[LeftDoubleBracket]", 
              RowBox[{"1", ";;", "mx"}], "\[RightDoubleBracket]"}], "]"}], 
            ".", 
            RowBox[{"(", 
             RowBox[{"beta", "*", 
              RowBox[{"F", "\[LeftDoubleBracket]", 
               RowBox[{
                RowBox[{"1", ";;", "mx"}], ",", 
                RowBox[{"mb", "+", "1"}]}], "\[RightDoubleBracket]"}]}], 
             ")"}]}], " ", "+", " ", "w"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"w", "=", 
            RowBox[{
             RowBox[{"V", " ", 
              RowBox[{"(", 
               RowBox[{":", 
                RowBox[{",", 
                 RowBox[{"1", ":", "mx"}]}]}], ")"}], "*", 
              RowBox[{"(", 
               RowBox[{"beta", "*", "F", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"1", ":", "mx"}], ",", 
                  RowBox[{"mb", "+", "1"}]}], ")"}]}], ")"}]}], " ", "+", " ",
              "w"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"tnow", "+=", "tstep"}], ";", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"t_now", "=", 
            RowBox[{"t_now", "+", "t_step"}]}], ";"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"tnew", "=", 
          RowBox[{"gamma", "*", "tstep", "*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"tstep", "*", 
              RowBox[{"tol", "/", "errloc"}]}], ")"}], "^", "xm"}]}]}], ";", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"t_new", "=", 
            RowBox[{"gamma", "*", "t_step", "*", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"t_step", "*", 
                RowBox[{"tol", "/", "err_loc"}]}], ")"}], "^", "xm"}]}]}], 
           ";"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"s", "=", 
          RowBox[{"10.0", "^", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Floor", "[", 
              RowBox[{"Log10", "[", "tnew", "]"}], "]"}], "-", "1"}], 
            ")"}]}]}], ";", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"s", "=", 
            RowBox[{"10", "^", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"floor", " ", 
                RowBox[{"(", 
                 RowBox[{"log10", " ", 
                  RowBox[{"(", "t_new", ")"}]}], ")"}]}], "-", "1"}], 
              ")"}]}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"tnew", "=", 
          RowBox[{
           RowBox[{"Ceiling", "[", 
            RowBox[{"tnew", "/", "s"}], "]"}], "*", "s"}]}], ";", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"t_new", "=", 
            RowBox[{"ceil", " ", 
             RowBox[{"(", 
              RowBox[{"t_new", "/", "s"}], ")"}], "*", "s"}]}], ";"}], "*)"}],
          "\[IndentingNewLine]", 
         RowBox[{"errloc", "=", 
          RowBox[{"Max", "[", 
           RowBox[{"errloc", ",", "rndoff"}], "]"}]}], ";", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"err_loc", "=", 
            RowBox[{"max", " ", 
             RowBox[{"(", 
              RowBox[{"err_loc", ",", "rndoff"}], ")"}]}]}], ";"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"(*", "  ", 
          RowBox[{
           RowBox[{
            RowBox[{
            "This", " ", "command", " ", "has", " ", "been", " ", "moved", 
             " ", "up", " ", "to", " ", "the", " ", "calling", " ", "routine",
              "\[IndentingNewLine]", "serror"}], "+=", "errloc"}], ";"}], 
          "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "Combine", " ", "everything", " ", "in", " ", "one", " ", "vector", 
           " ", "since", " ", 
           RowBox[{"Compile", "[", "]"}], " ", "cannot", " ", "return", " ", 
           "irregular", " ", "arrays"}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Join", "[", 
          RowBox[{"w", ",", 
           RowBox[{"N", "[", 
            RowBox[{"{", 
             RowBox[{
             "istep", ",", "tstep", ",", "tnew", ",", "tnow", ",", "errloc", 
              ",", "s", ",", "xm", ",", "mb"}], "}"}], "]"}]}], "]"}]}]}], 
       "\[IndentingNewLine]", "]"}], " ", 
      RowBox[{"(*", " ", 
       RowBox[{"End", " ", "of", " ", "Module"}], " ", "*)"}], 
      "\[IndentingNewLine]", ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{"Sequence", "@@", "compileropts"}], "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], 
  RowBox[{"(*", " ", 
   RowBox[{"End", " ", "of", " ", "Compile"}], " ", "*)"}]}]], "Input",
 InitializationCell->
  True],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 0.5}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 3}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Multiply", " ", "a", " ", "vector", " ", "v", " ", "by", " ", "the", " ", 
    "global", " ", "matrix", " ", "variable", " ", "Global`fullAmatG", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
      "which", " ", "may", " ", "be", " ", "a", " ", "sparse", " ", 
       "matrix"}], ",", " ", 
      RowBox[{"in", " ", "which", " ", "case", " ", 
       RowBox[{"Compile", "[", "]"}], " ", 
       RowBox[{"couldn", "'"}], "t", " ", "handle", " ", "the", " ", 
       "multiplication"}]}], ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"multiplyByA", "[", "v_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{"Global`fullAmatG", ".", "v"}], ")"}]}]}]], "Input",
 InitializationCell->
  True],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 0.5}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 3}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Stripped", " ", "version", " ", "of", " ", 
   RowBox[{"phiv", "[", "]"}], " ", "to", " ", "work", " ", "with", " ", 
   "with", " ", 
   RowBox[{"Mathematica", "'"}], "s", " ", 
   RowBox[{"MatrixExp", "[", "]"}], " ", "function", " ", 
   RowBox[{"(", 
    RowBox[{"see", " ", 
     RowBox[{"StepPulseFlux", "[", "]"}]}], ")"}]}], " ", "*)"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "phivMatrixExp", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"VerbosityLevel", "\[Rule]", "2"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"phivMatrixExp", "[", 
     RowBox[{
     "t_", ",", "w_", ",", "grStates_", ",", "exStates_", ",", "obsmat_", ",", 
      RowBox[{"indVgMaxEx_:", "-", "1"}], ",", 
      RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "verb", ",", "popgr8", ",", "popex16", ",", "wgr", ",", "wex", ",", 
        "tot1", ",", "popgr8Weighted", ",", "wgrAll", ",", "wexAllTotal", ",",
         "err", ",", "off1", ",", "obs", ",", "popgr8WeightedLoc"}], "}"}], 
      ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixQ", "[", 
           RowBox[{
            RowBox[{"{", "w", "}"}], ",", "NumericQ"}], "]"}], "\[Equal]", 
          "False"}], " ", ",", 
         RowBox[{
          RowBox[{
          "Print", "[", "\"\<phivMatrixExp[]: w is nonnumeric\>\"", "]"}], 
          ";", 
          RowBox[{"Abort", "[", "]"}], ";"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"MatrixQ", "[", 
            RowBox[{
             RowBox[{"{", "obsmat", "}"}], ",", "NumericQ"}], "]"}], 
           "\[Equal]", "False"}], " ", "&&", 
          RowBox[{"obsmat", "\[NotEqual]", 
           RowBox[{"{", "}"}]}]}], ",", 
         RowBox[{
          RowBox[{
          "Print", "[", "\"\<phivCompiled[]: resultmat is nonnumeric\>\"", 
           "]"}], ";", 
          RowBox[{"Abort", "[", "]"}], ";"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"verb", "=", 
        RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"popgr8", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"popex16", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"popgr8Weighted", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"obs", "=", 
        RowBox[{"{", "}"}]}], ";", " ", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Used", " ", "to", " ", "accumulate", " ", "return", " ", "flux", " ",
          "samples"}], " ", "*)"}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Code", " ", "inserted", " ", "by", " ", "Ron", " ", 
         RowBox[{"Holzloehner", ":", " ", 
          RowBox[{
          "Compute", " ", "the", " ", "return", " ", "flux", " ", "at", " ", 
           "tnow"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"obs", ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", 
           RowBox[{"Re", "[", 
            RowBox[{"obsmat", ".", "w"}], "]"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"indVgMaxEx", "\[GreaterEqual]", "1"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"off1", "=", 
           RowBox[{"8", "*", 
            RowBox[{"(", 
             RowBox[{"indVgMaxEx", "-", "1"}], ")"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"wgr", "=", 
           RowBox[{
            RowBox[{
            "w", "\[LeftDoubleBracket]", "grStates", 
             "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", "off1"}], ")"}], ";;", 
             RowBox[{"(", 
              RowBox[{"8", "+", "off1"}], ")"}]}], 
            "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"off1", "=", 
           RowBox[{"16", "*", 
            RowBox[{"(", 
             RowBox[{"indVgMaxEx", "-", "1"}], ")"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"wex", "=", 
           RowBox[{
            RowBox[{
            "w", "\[LeftDoubleBracket]", "exStates", 
             "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", "off1"}], ")"}], ";;", 
             RowBox[{"(", 
              RowBox[{"16", "+", "off1"}], ")"}]}], 
            "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
           "Normalize", " ", "by", " ", "number", " ", "of", " ", "atoms", 
            " ", "in", " ", "this", " ", "velocity", " ", "bin"}], " ", 
           "*)"}], "\[IndentingNewLine]", 
          RowBox[{"tot1", "=", 
           RowBox[{"N", "[", 
            RowBox[{
             RowBox[{"Total", "[", "wgr", "]"}], "+", 
             RowBox[{"Total", "[", "wex", "]"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"popgr8", "=", 
           RowBox[{"Join", "[", 
            RowBox[{"popgr8", ",", 
             RowBox[{"{", 
              RowBox[{"wgr", "/", "tot1"}], "}"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"popex16", "=", 
           RowBox[{"Join", "[", 
            RowBox[{"popex16", ",", 
             RowBox[{"{", 
              RowBox[{"wex", "/", "tot1"}], "}"}]}], "]"}]}], ";"}], 
         "\[IndentingNewLine]", ",", " ", 
         RowBox[{"(*", "else", "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"popgr8", "=", 
           RowBox[{"Join", "[", 
            RowBox[{"popgr8", ",", 
             RowBox[{"{", 
              RowBox[{"ConstantArray", "[", 
               RowBox[{
                RowBox[{"-", "1.0"}], ",", "8"}], "]"}], "}"}]}], "]"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"popex16", "=", 
           RowBox[{"Join", "[", 
            RowBox[{"popex16", ",", 
             RowBox[{"{", 
              RowBox[{"ConstantArray", "[", 
               RowBox[{
                RowBox[{"-", "1.0"}], ",", "16"}], "]"}], "}"}]}], "]"}]}], 
          ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"Nx8", " ", "array"}], ",", " ", 
         RowBox[{
         "where", " ", "N", " ", "is", " ", "the", " ", "number", " ", "of", 
          " ", "velocity", " ", "classes"}]}], "  ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"wgrAll", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{
          "w", "\[LeftDoubleBracket]", "grStates", "\[RightDoubleBracket]"}], 
          ",", "8"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Vector", " ", "of", " ", "length", " ", "N", " ", "with", " ", "the",
          " ", "total", " ", "excited", " ", "populations", " ", 
         RowBox[{"(", 
          RowBox[{"total", " ", "of", " ", "all", " ", "16", " ", "states"}], 
          ")"}], " ", "in", " ", "each", " ", "velocity", " ", "class"}], " ",
         "*)"}], "\[IndentingNewLine]", 
       RowBox[{"wexAllTotal", "=", 
        RowBox[{"Total", "[", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{
            "w", "\[LeftDoubleBracket]", "exStates", 
             "\[RightDoubleBracket]"}], ",", "16"}], "]"}], ",", 
          RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"tot1", "=", 
        RowBox[{"Total", "[", "wexAllTotal", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"tot1", ">", "0"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "Vector", " ", "of", " ", "length", " ", "8", " ", "containing", 
           " ", "the", " ", "ground", " ", "state", " ", "populations", " ", 
           "weighted", " ", "by", " ", "the", " ", "excited", " ", "state", 
           " ", "populations"}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"popgr8WeightedLoc", "=", 
           RowBox[{
            RowBox[{"Total", "[", 
             RowBox[{
              RowBox[{"wgrAll", "*", "wexAllTotal"}], ",", 
              RowBox[{"{", "1", "}"}]}], "]"}], "/", "tot1"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"Normalize", " ", "to", " ", "total", " ", "1"}], " ", 
           "*)"}], "\[IndentingNewLine]", 
          RowBox[{"popgr8WeightedLoc", "/=", 
           RowBox[{"Total", "[", "popgr8WeightedLoc", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"popgr8Weighted", "=", 
           RowBox[{"Join", "[", 
            RowBox[{"popgr8Weighted", ",", 
             RowBox[{"{", "popgr8WeightedLoc", "}"}]}], "]"}]}], ";"}], 
         "\[IndentingNewLine]", ",", " ", 
         RowBox[{"(*", " ", "ELSE", " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"popgr8Weighted", "=", 
           RowBox[{"Join", "[", 
            RowBox[{"popgr8Weighted", ",", 
             RowBox[{"{", 
              RowBox[{"ConstantArray", "[", 
               RowBox[{
                RowBox[{"-", "1.0"}], ",", "8"}], "]"}], "}"}]}], "]"}]}], 
          ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"err", "=", "0.0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
        "err", ",", "obs", ",", "popgr8", ",", "popex16", ",", 
         "popgr8Weighted"}], "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}],
   " ", 
  RowBox[{"(*", 
   RowBox[{"End", " ", "of", " ", 
    RowBox[{"Module", "[", "]"}], " ", "phivMatrixExp"}], " ", 
   "*)"}]}]}], "Input",
 InitializationCell->
  True],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 2}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 4}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
StepPulseFlux -- Time-dependent solution with piecewise constant coefficients\
\
\>", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"convertDM", "[", 
   RowBox[{"olddm_", ",", "oldvg_", ",", "newvg_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "oldbins", ",", "newbins", ",", "dm", ",", "convertlist", ",", "leftpos",
       ",", "leftfrac", ",", "middlepos", ",", "middlefrac", ",", "rightpos", 
      ",", "rightfrac", ",", "containedpos", ",", "containedfrac", ",", "inf",
       ",", "leftovers"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"oldbins", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"oldvg", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}], "/.", 
        RowBox[{
         RowBox[{"-", "\[Infinity]"}], "\[Rule]", 
         RowBox[{"-", "inf"}]}]}], "/.", 
       RowBox[{"\[Infinity]", "\[Rule]", "inf"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"newbins", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"newvg", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}], "/.", 
        RowBox[{
         RowBox[{"-", "\[Infinity]"}], "\[Rule]", 
         RowBox[{"-", "inf"}]}]}], "/.", 
       RowBox[{"\[Infinity]", "\[Rule]", "inf"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"dm", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{"olddm", ",", 
        RowBox[{
         RowBox[{"Length", "[", "olddm", "]"}], "/", 
         RowBox[{"Length", "[", "oldbins", "]"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"convertlist", "=", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"leftpos", "=", 
          RowBox[{"Position", "[", 
           RowBox[{"oldbins", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"x1_", ",", "x2_"}], "}"}], "/;", 
             RowBox[{"x1", "<", 
              RowBox[{
              "bin", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
              "<", "x2", "<", 
              RowBox[{
              "bin", "\[LeftDoubleBracket]", "2", 
               "\[RightDoubleBracket]"}]}]}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"leftfrac", "=", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
               "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
               "-", 
               RowBox[{
               "bin", "\[LeftDoubleBracket]", "1", 
                "\[RightDoubleBracket]"}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
               "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
               "-", 
               RowBox[{
               "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
              ")"}]}], "&"}], "/@", 
           RowBox[{"Extract", "[", 
            RowBox[{"oldbins", ",", "leftpos"}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"middlepos", "=", 
          RowBox[{"Position", "[", 
           RowBox[{"oldbins", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"x1_", ",", "x2_"}], "}"}], "/;", 
             RowBox[{
              RowBox[{
              "bin", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
              "\[LessEqual]", " ", "x1", "\[LessEqual]", "x2", "\[LessEqual]", 
              RowBox[{
              "bin", "\[LeftDoubleBracket]", "2", 
               "\[RightDoubleBracket]"}]}]}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"middlefrac", "=", 
          RowBox[{
           RowBox[{"1", "&"}], "/@", 
           RowBox[{"Extract", "[", 
            RowBox[{"oldbins", ",", "middlepos"}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"rightpos", "=", 
          RowBox[{"Position", "[", 
           RowBox[{"oldbins", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"x1_", ",", "x2_"}], "}"}], "/;", 
             RowBox[{
              RowBox[{
              "bin", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
              "<", "x1", "<", 
              RowBox[{
              "bin", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
              "<", "x2"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"rightfrac", "=", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
               "bin", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
               "-", 
               RowBox[{
               "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
              ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
               "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
               "-", 
               RowBox[{
               "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
              ")"}]}], "&"}], "/@", 
           RowBox[{"Extract", "[", 
            RowBox[{"oldbins", ",", "rightpos"}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"containedpos", "=", 
          RowBox[{"Position", "[", 
           RowBox[{"oldbins", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"x1_", ",", "x2_"}], "}"}], "/;", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"x1", "\[LessEqual]", 
                RowBox[{
                "bin", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}],
                 "\[LessEqual]", 
                RowBox[{
                "bin", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
                 "<", "x2"}], ")"}], "||", 
              RowBox[{"(", 
               RowBox[{"x1", "<", 
                RowBox[{
                "bin", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}],
                 "\[LessEqual]", 
                RowBox[{
                "bin", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
                 "\[LessEqual]", "x2"}], ")"}]}]}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"containedfrac", "=", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
               "bin", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
               "-", 
               RowBox[{
               "bin", "\[LeftDoubleBracket]", "1", 
                "\[RightDoubleBracket]"}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
               "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
               "-", 
               RowBox[{
               "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
              ")"}]}], "&"}], "/@", 
           RowBox[{"Extract", "[", 
            RowBox[{"oldbins", ",", "containedpos"}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Transpose", "@", 
              RowBox[{"{", 
               RowBox[{"leftfrac", ",", "leftpos"}], "}"}]}], ",", 
             RowBox[{"Transpose", "@", 
              RowBox[{"{", 
               RowBox[{"middlefrac", ",", "middlepos"}], "}"}]}], ",", 
             RowBox[{"Transpose", "@", 
              RowBox[{"{", 
               RowBox[{"rightfrac", ",", "rightpos"}], "}"}]}], ",", 
             RowBox[{"Transpose", "@", 
              RowBox[{"{", 
               RowBox[{"containedfrac", ",", "containedpos"}], "}"}]}]}], 
            "}"}], ",", "1"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"bin", ",", "newbins"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"leftovers", "=", 
      RowBox[{"Chop", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"1", "-", 
             RowBox[{"Total", "@", 
              RowBox[{"Cases", "[", 
               RowBox[{
                RowBox[{"Flatten", "[", 
                 RowBox[{"convertlist", ",", "1"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"x_", ",", 
                   RowBox[{"{", "i", "}"}]}], "}"}], "\[Rule]", "x"}]}], 
               "]"}]}]}], ",", 
            RowBox[{"{", "i", "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"Length", "[", "oldbins", "]"}]}], "}"}]}], "]"}], ",", 
        RowBox[{"2", "$MachineEpsilon"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "convertlist", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      "=", 
      RowBox[{"DeleteCases", "[", 
       RowBox[{
        RowBox[{"Take", "[", 
         RowBox[{"leftovers", ",", 
          RowBox[{"Floor", "[", 
           RowBox[{
            RowBox[{"Length", "[", "oldbins", "]"}], "/", "2"}], "]"}]}], 
         "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "_"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"convertlist", "\[LeftDoubleBracket]", 
       RowBox[{"-", "1"}], "\[RightDoubleBracket]"}], "=", 
      RowBox[{"DeleteCases", "[", 
       RowBox[{
        RowBox[{"Drop", "[", 
         RowBox[{"leftovers", ",", 
          RowBox[{"Floor", "[", 
           RowBox[{
            RowBox[{"Length", "[", "oldbins", "]"}], "/", "2"}], "]"}]}], 
         "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "_"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
           "conv", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
           RowBox[{"Extract", "[", 
            RowBox[{"dm", ",", 
             RowBox[{
             "conv", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}],
             "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"conv", ",", "#"}], "}"}]}], "]"}], "&"}], "/@", 
       "convertlist"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->
  True],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 0.5}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 3}],

Cell[BoxData[
 RowBox[{"(*", "  ", 
  RowBox[{
  "Convert", " ", "velocity", " ", "groups", " ", "for", " ", "use", " ", 
   "within", " ", 
   RowBox[{"StepPulseFlux", "[", "]"}]}], " ", "*)"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "makeVg", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "DefaultParameters", "\[RuleDelayed]", "$DefaultLGSParameters"}], "}"}],
      ",", 
     RowBox[{"Options", "[", "ReturnFlux", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"SetOptions", "[", 
  RowBox[{"makeVg", ",", 
   RowBox[{"RefineResult", "\[Rule]", 
    RowBox[{"{", "100", "}"}]}]}], "]"}]}], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{"makeVg", "[", 
   RowBox[{"speclist_", ",", "atdata1_", ",", "params_", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "dw", ",", "nog", ",", "allfreqs", ",", "vg", ",", "freqs", ",", "spec", 
      ",", "bendfunc", ",", "wf", ",", "nb"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"nb", "=", 
      RowBox[{"NDither", "/.", "params"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"dw", "=", 
      RowBox[{"DopplerWidth", "/.", "params"}]}], ";", "\[IndentingNewLine]", 
     
     RowBox[{"nog", "=", 
      RowBox[{
       RowBox[{"OptionValue", "[", "RefineResult", "]"}], "/.", 
       RowBox[{
        RowBox[{"False", "|", "None"}], "\[Rule]", 
        RowBox[{"{", "}"}]}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"freqs", "=", 
      RowBox[{"ResonanceFrequencies", "/.", "atdata1"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"allfreqs", "=", 
      RowBox[{"Union", "@", 
       RowBox[{"Flatten", "@", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"freqs", "-", 
              RowBox[{"DetuningA", "[", "i", "]"}]}], "/.", "params"}], ",", 
            RowBox[{
             RowBox[{"freqs", "-", 
              RowBox[{"DetuningB", "[", "i", "]"}]}], "/.", "params"}]}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nb"}], "}"}]}], "]"}]}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"spec", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{"speclist", ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"bendfunc", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"bendList", "[", "speclist", "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"wf", "=", 
      RowBox[{"nWeightFunction", "[", 
       RowBox[{"spec", ",", "bendfunc", ",", 
        RowBox[{"{", 
         RowBox[{"5", ",", "5", ",", "5"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", 
          RowBox[{
           RowBox[{"-", "3"}], "dw"}], ",", 
          RowBox[{"3", "dw"}]}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"vg", "=", 
      RowBox[{"VelocityGroups2", "[", 
       RowBox[{"wf", ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", 
          RowBox[{
           RowBox[{"-", "3"}], "dw"}], ",", 
          RowBox[{"3", "dw"}]}], "}"}], ",", 
        RowBox[{"nog", "\[LeftDoubleBracket]", 
         RowBox[{"-", "1"}], "\[RightDoubleBracket]"}], ",", "dw", ",", 
        RowBox[{
         RowBox[{"5", " ", "RecoilShift"}], "/.", "params"}], ",", "allfreqs",
         ",", 
        RowBox[{"ShowPlot", "\[Rule]", 
         RowBox[{"OptionValue", "[", "PlotVelocityGroups", "]"}]}]}], 
       "]"}]}]}]}], "\[IndentingNewLine]", 
   RowBox[{"(*", "*)"}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->
  True],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 0.5}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 3}],

Cell["\<\
filterPops[] first extracts the populations specified by vec from the sol \
input. It then partitions that list into sublists that correspond to each \
velocity group, and scales the sublists by the width of each bin. That's \
necessary because the wider bins will have more population just because \
they're wider; we want to remove this effect. It then totals the populations \
for each velocity group and forms a two-column table with the positions of \
the bins as the first column and the scaled populations as the second column. \
If one removes the Total command you can get the scaled populations for each \
sublevel, rather than the sum of all sublevels. \
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"filterPops", "[", 
    RowBox[{"sol_", ",", "vec_", ",", "vg_", ",", 
     RowBox[{"returnSublevels_:", "False"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "pops", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"pops", "=", 
       RowBox[{"getPops", "[", 
        RowBox[{"sol", ",", "vec"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "pops", "]"}], "/", 
             RowBox[{"Length", "[", "vg", "]"}]}], ",", "1"}], "]"}], 
          "\[NotEqual]", "0"}], "||", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "pops", "]"}], "/", 
           RowBox[{"Length", "[", "vg", "]"}]}], "<", "1"}]}], ",", 
        RowBox[{
         RowBox[{
         "Print", "[", 
          
          "\"\<filterPops[]: Length[pops] is not a multiple of Length[vg], \
Aborting!\>\"", "]"}], ";", 
         RowBox[{"Abort", "[", "]"}], ";"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Transpose", "@", 
       RowBox[{"If", "[", 
        RowBox[{"returnSublevels", ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"vg", "\[LeftDoubleBracket]", 
             RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "/", 
            RowBox[{"(", 
             RowBox[{"2.0", "\[Pi]", " ", 
              RowBox[{"10", "^", "9"}]}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"(", 
              RowBox[{"2.0", "\[Pi]", " ", 
               RowBox[{"10", "^", "9"}]}], ")"}]}], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Partition", "[", 
               RowBox[{"pops", ",", 
                RowBox[{
                 RowBox[{"Length", "[", "pops", "]"}], "/", 
                 RowBox[{"Length", "[", "vg", "]"}]}]}], "]"}], ")"}], "/", 
             RowBox[{"Subtract", "@@@", 
              RowBox[{"vg", "\[LeftDoubleBracket]", 
               RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}]}]}]}]}], 
          "}"}], "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"vg", "\[LeftDoubleBracket]", 
             RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "/", 
            RowBox[{"(", 
             RowBox[{"2.0", "\[Pi]", " ", 
              RowBox[{"10", "^", "9"}]}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"(", 
              RowBox[{"2.0", "\[Pi]", " ", 
               RowBox[{"10", "^", "9"}]}], ")"}]}], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Total", "/@", 
               RowBox[{"Partition", "[", 
                RowBox[{"pops", ",", 
                 RowBox[{
                  RowBox[{"Length", "[", "pops", "]"}], "/", 
                  RowBox[{"Length", "[", "vg", "]"}]}]}], "]"}]}], ")"}], "/", 
             RowBox[{"Subtract", "@@@", 
              RowBox[{"vg", "\[LeftDoubleBracket]", 
               RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}]}]}]}]}], 
          "}"}]}], "\[IndentingNewLine]", "]"}]}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 0.5}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 3}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"getPops", "[", 
    RowBox[{"sol_", ",", "vec_"}], "]"}], ":=", 
   RowBox[{"sol", "\[LeftDoubleBracket]", 
    RowBox[{"Flatten", "[", 
     RowBox[{"Position", "[", 
      RowBox[{"vec", ",", 
       RowBox[{"x_", "/;", 
        RowBox[{"x", "\[NotEqual]", "0"}]}]}], "]"}], "]"}], 
    "\[RightDoubleBracket]"}]}], ";"}]], "Input",
 InitializationCell->
  True],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 0.5}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 3}],

Cell[TextData[{
 "Solve the time-dependent problem for periodic irradiation pattern and \
integrate flux return over the last period. Uses phiv[] to\nsolve the \
inhomogeneous problem (d/dt)\[Rho] = A\[Rho]+",
 StyleBox["b",
  FontSlant->"Italic"],
 " for piecewise constant coefficients.\nInput:\n\tsyst: Bloch equation \
system\n\tparams: Physical simulation parameters for PsiMeso[]\n\tnperiodsIn: \
maximum number of periods to simulate\n\tcomplexE: Vector, subdividing the \
pulse into n subspans, scaling the \n\t\tirradiance in each subspan so that I\
\[LeftDoubleBracket]j\[RightDoubleBracket] == IMeso |complexE\
\[LeftDoubleBracket]j,2\[RightDoubleBracket]|^2, \n\t\tand Arg[complexE\
\[LeftDoubleBracket]j,2\[RightDoubleBracket]] is the optical phase at step j. \
The entries complexE\[LeftDoubleBracket]j,1\[RightDoubleBracket] contain the \
corresponding \ttime steps relative to the beginning of the simulated period. \
Hence, complexE\[LeftDoubleBracket]-1,1\[RightDoubleBracket] equals the \
duration of the simulated period. The time steps do not have to be constant. \
Note that all time steps, including complexE\[LeftDoubleBracket]1,1\
\[RightDoubleBracket], must be larger than 0 and strictly increasing.\n\t\
brightPeriodSkip: Concentrate the light to every BrightPeriodSkip\
\[CloseCurlyQuote]th period (e.g., if brightPeriodSkip=2, run every other \
period at twice the irradiance as when setting brightPeriodSkip=1). Set ",
 "brightPeriodSkip",
 "=1 to make every period the same.\n\t\[CapitalDelta]fLaserFunction: \
\[CapitalDelta]fLaserFunction[] sets the laser central frequency offset as a \
function of time\n\tfname: File name to save the results structure \"res\" \
in, using Export[fname,res]\n\topts: option set for PsiMeso[]\nOutput:\n\
Global`Res={psiAvg, psiAvgTotal, psiSpanAll, psiAvgHist, Iavg, popgr8All, \
popex16All, {PhiVErrors \[Rule] errAll, PsiIavg \[Rule] psiIavg1, \
GroundPopulation \[Rule] popgr, ExcitedPopulation \[Rule] popex, \
FinalGroundPops \[Rule] groundPops, FinalExcitedPops \[Rule] excitedPops, \
ExcitedPops \[Rule] excitedPopsAll, LastDM \[Rule] {w, vg}, RFParamsOut \
\[Rule] {rfparams1, params1, opts}}}\n\n\tpsiAvg: Specific return flux \
averaged over the last period [ph/s/sr/atom/(W/m^2)]\n\tpsiAvgTotal: psiAvg \
summed over all periods [ph/s/sr/atom/(W/m^2)]\n\tpsiSpanAll: vector of pairs \
{tn, return flux(tn)}, return flux [ph/s/sr/atom/(W/m^2)]\n\tpsiAvgHist: \
vector of psiAvg values for each period\n\tIavg: Irradiance, averaged over a \
simulation period [W/m^2]\n\tpopgr8All: Array of dimension Nx8, where N \
equals the length of psiSpanAll and corresponds to the time steps given by \
psiSpanAll\[LeftDoubleBracket]All,1\[RightDoubleBracket]. The values of \
popgr8All yield the 8 ground state populations of the velocity class that is \
closest to +5 MHz, where in many systems a peak of the polarization is \
observed (\"busy velocity class\"), normalized by the total ground+excited \
state population in this velocity class. For darkness in equilibrium we thus \
have popgr8All\[LeftDoubleBracket]All,All\[RightDoubleBracket]==1/8. The \
states are ordered {(F=2,m=2), (F=2,m=1)..., (F=2,m=-2), (F=1,m=1), \
(F=1,m=0), (F=2,m=-1)} (with LightPolarization->+1, the (F=2,m=2) is pumped \
most strongly)\n\tpopex16All: same as popgr8All, but for the 16 excited \
states. Sequence starts with (F=3,m=3).\n\tPhiVErrors: vector of numerical \
errors returned by phiv[], corresponding to psiSpanAll\n\tpsiIavg: value of \
psi for average irradiance\n\tpopgr: ground state population\n\tpopex: \
Excited state population\n\tw: final solution vector (b)\nThe routine \
computes the average return flux psiAvg defined as\n\n   psiAvg = 1/(trep * \
Iavg)  \\int_{t0}^{t0+trep} Psi(t) dt,\n\nwhere Psi(t) is the instantaneous \
non-normalized return flux in ph/s/sr/atom, t0 is the begin of the last \
period, and Iavg = Ipulse*duty, where Ipulse is the pulse irradiance.\n\nThe \
iteration starts from thermal equilibrium (InitialState \[Rule] LightOff) or \
from the steady-state solution at Ipulse (InitialState \[Rule] LightOn) and \
stops once the difference of psiAvg between two subsequent iterations drops \
below some threshold. In the verbose simulation output, \"peak cw psi\" is \
the steady-state result psi(I_peak), and \"flux from avg irradiance\" is \
similarly psi(I_avg).\nTo achieve convergence, allow for a total simulation \
time of several times 16ns. At low irradiance, you may have to simulate \
several collision time scales."
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "StepPulseFlux", "]"}], "=", 
   RowBox[{"FilterRules", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Options", "[", "PsiMeso", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"VGMethod", "\[Rule]", "ConvertDM"}], ",", 
         RowBox[{"InitialState", "\[Rule]", "LightOff"}], ",", 
         RowBox[{"KrylovDimension", "\[Rule]", "Automatic"}], ",", 
         RowBox[{"VerbosityLevel", "\[Rule]", "2"}], ",", 
         RowBox[{"Tolerance", "\[Rule]", 
          RowBox[{"10.0", "^", 
           RowBox[{"(", 
            RowBox[{"-", "7"}], ")"}]}]}], ",", 
         RowBox[{"TerminationThresh", "\[Rule]", 
          RowBox[{"0.25", "*", 
           RowBox[{"10", "^", 
            RowBox[{"(", 
             RowBox[{"-", "2"}], ")"}]}]}]}], ",", 
         RowBox[{"VGfreezePeriod", "\[Rule]", "12"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"Except", "[", 
      RowBox[{"{", 
       RowBox[{"FluxReport", ",", "ReturnAllSteps"}], "}"}], "]"}]}], "]"}]}],
   ";"}]], "Input",
 InitializationCell->
  True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StepPulseFlux", "[", 
    RowBox[{
    "syst_", ",", "params_", ",", "nperiodsIn_", ",", "complexE_", ",", 
     "brightPeriodSkip_", ",", "\[CapitalDelta]fLaserFunction_", ",", 
     "fname_", ",", 
     RowBox[{"opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "trep", ",", "tNow", ",", "i", ",", "fullAmat", ",", "w", ",", "err", 
       ",", "errAll", ",", "psiSpan", ",", "psiSpanAll", ",", "tend", ",", 
       "fns", ",", "hh", ",", "psiAvg", ",", "psiAvgTotal", ",", "tns", ",", 
       "tspanMaxFactor", ",", "tol", ",", "m", ",", "Iavg", ",", "psiIavg1", 
       ",", "popgr", ",", "popex", ",", "fullbvecOn", ",", "psiAvgLast", ",", 
       "psiAvgHist", ",", "j", ",", "errLoc", ",", "psiSpanLoc", ",", 
       "IMesoNow", ",", "relativeI", ",", "phase", ",", "tDiffs", ",", "psi", 
       ",", "inst", ",", "lastvg", ",", "vg", ",", "nfopts", ",", "params1", 
       ",", "sol", ",", "fullfluorvecOn", ",", "fullbvecOff", ",", 
       "fullfluorvecOff", ",", "bvec", ",", "fvec", ",", "groundPops", ",", 
       "excitedPops", ",", "excitedPopsAll", ",", "excitedPopsHelp", ",", 
       "speclist", ",", "NDitherLoc", ",", "rfparams1", ",", "indVgMaxEx", 
       ",", "popgr8", ",", "popex16", ",", "popgr8All", ",", "popex16All", 
       ",", "\[CapitalDelta]fLaserNow", ",", "tu1", ",", "tu2", ",", "tu12", 
       ",", "tu13", ",", "tuLast", ",", "terminationCriterion", ",", 
       "fwriteCriterion", ",", "help1", ",", "tu11", ",", "tPrep", ",", 
       "popgr8Weighted", ",", "popgr8WeightedAll", ",", "iVGfreezeLoc", ",", 
       "fullAmatLI", ",", "A110L", ",", "grStates", ",", "exStates", ",", 
       "nperiodsFile", ",", "nperiods", ",", "factorEnhance"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"Argument", " ", "checking"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"complexE", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "\[LessEqual]", 
         "0"}], ",", 
        RowBox[{
         RowBox[{
         "Print", "[", 
          "\"\<First time step must be larger than zero. Aborting.\>\"", 
          "]"}], ";", 
         RowBox[{"Abort", "[", "]"}], ";"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "Period", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"trep", "=", 
       RowBox[{"complexE", "\[LeftDoubleBracket]", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1"}], "\[RightDoubleBracket]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"trep", "\[LessEqual]", "0.0"}], "||", 
         RowBox[{"trep", ">", "0.1"}]}], ",", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{
          "\"\<trep: \>\"", ",", " ", "trep", ",", 
           "\"\<s, which may not be what you want. Aborting.\>\""}], "]"}], 
         ";", 
         RowBox[{"Abort", "[", "]"}], ";"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Massage", " ", "options"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"inst", "=", 
       RowBox[{"OptionValue", "[", "InitialState", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Tolerance", " ", "for", " ", 
        RowBox[{"phiv", "[", "]"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"tol", "=", 
       RowBox[{"OptionValue", "[", "Tolerance", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Krylov", " ", "subspace", " ", "dimension", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], " ", "means", " ", 
          RowBox[{"default", ":", "30"}]}], ")"}]}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"m", "=", 
       RowBox[{
        RowBox[{"OptionValue", "[", "KrylovDimension", "]"}], "/.", 
        RowBox[{"Automatic", "\[Rule]", 
         RowBox[{"-", "1"}]}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Solver", " ", "parameters"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"nfopts", "=", 
       RowBox[{"FilterRules", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ReturnAllSteps", "\[Rule]", "False"}], ",", "opts", ",", 
           RowBox[{"Options", "[", "StepPulseFlux", "]"}]}], "}"}], ",", 
         RowBox[{"Options", "[", "PsiMeso", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"LGS", " ", "Parameters", " ", "for", " ", 
        RowBox[{"PsiMeso", "[", "]"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"params1", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"params", ",", 
         RowBox[{"OptionValue", "[", "DefaultParameters", "]"}]}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Normalize", " ", "the", " ", "relative", " ", "irradiances", " ", 
        "by", " ", "the", " ", "peak", " ", "irradiance", " ", "in", " ", 
        "time", " ", "domain"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"relativeI", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Abs", "[", 
          RowBox[{"complexE", "\[LeftDoubleBracket]", 
           RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "]"}], "^", 
         "2"}], "/", 
        RowBox[{"Max", "[", 
         RowBox[{
          RowBox[{"Abs", "[", 
           RowBox[{"complexE", "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "]"}], "^", 
          "2"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"phase", "=", 
       RowBox[{"Arg", "[", 
        RowBox[{"complexE", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Factor", " ", "from", " ", "seconds", " ", "to", " ", "nanoseconds"}],
        "*)"}], "\[IndentingNewLine]", 
      RowBox[{"fns", "=", 
       RowBox[{"1.0", "*", 
        RowBox[{"10", "^", "9"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Minimum", " ", "number", " ", "of", " ", "time", " ", "steps", " ", 
        "per", " ", "constant", " ", "intensity", " ", "span"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"tspanMaxFactor", "=", "11.0"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Speed", "-", 
        RowBox[{
        "up", " ", "computation", " ", "of", " ", "fullAmat", " ", "starting",
          " ", "with", " ", "this", " ", "period"}]}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"iVGfreezeLoc", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"OptionValue", "[", "VGMethod", "]"}], "===", "FixVG"}], 
         ",", "1", ",", 
         RowBox[{"OptionValue", "[", "VGfreezePeriod", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"time", " ", "sample", " ", "steps"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"tDiffs", "=", 
       RowBox[{"Differences", "[", 
        RowBox[{"complexE", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"PrependTo", "[", 
       RowBox[{"tDiffs", ",", 
        RowBox[{"complexE", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Average", " ", "irradiance", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
          "use", " ", "piecewise", " ", "constant", " ", "irradiance"}], ",", 
          " ", 
          RowBox[{"exactly", " ", "like", " ", "input", " ", "irradiance"}]}],
          ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Iavg", "=", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"relativeI", ".", "tDiffs"}], ")"}], "/", "trep"}], "*", 
         "IMeso"}], "/.", "params1"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Run", " ", "steady", " ", "state", " ", "calculation", " ", "at", " ",
         "unperturbed", " ", "intensity", " ", "and", " ", "frequency"}], " ",
        "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"w", ",", "vg"}], "}"}], "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Head", "[", "inst", "]"}], "===", "List"}], ",", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "inst", "]"}], "\[NotEqual]", "2"}], ",", 
            
            RowBox[{
             RowBox[{
             "Print", "[", 
              "\"\<StepPulseFlux[]: Option InitialState must either be a \
keyword or a list of length 2! Aborting...\>\"", "]"}], ";", 
             RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", "inst"}], ",", 
         RowBox[{"{", 
          RowBox[{"Indeterminate", ",", "Automatic"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[CapitalDelta]fLaserNow", "=", 
       RowBox[{"\[CapitalDelta]fLaserFunction", "[", 
        RowBox[{"0.5", "*", 
         RowBox[{
         "tDiffs", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"psi", "=", 
       RowBox[{"PsiMeso", "[", 
        RowBox[{"syst", ",", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\[CapitalDelta]fLaser", "\[Rule]", "\[CapitalDelta]fLaserNow"}], 
            "}"}], ",", "params"}], "]"}], ",", 
         RowBox[{"FluxReport", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "BlochMatrix", ",", "DMSolution", ",", "VelocityGroups", ",", 
            "RFParams"}], "}"}]}], ",", 
         RowBox[{"InitVG", "\[Rule]", "vg"}], ",", "nfopts"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Head", "[", "w", "]"}], "===", "List"}], "&&", 
         RowBox[{
          RowBox[{"Length", "[", "w", "]"}], ">", "0"}]}], ",", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Both", " ", "w", " ", "and", " ", "vg", " ", "have", " ", "been", 
          " ", "supplied"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"fullAmat", ",", "fullbvecOn", ",", "fullfluorvecOn"}], 
             "}"}], ",", "rfparams1"}], "}"}], "=", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"BlochMatrix", ",", "RFParams"}], "}"}], "/.", 
           RowBox[{
           "psi", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}]}], 
         ";"}], "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Head", "[", "vg", "]"}], "===", "List"}], "&&", 
            RowBox[{
             RowBox[{"Length", "[", "vg", "]"}], ">", "0"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"inst", "=", 
             RowBox[{
             "inst", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}],
             ";", " ", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{
              "w", " ", "was", " ", "not", " ", "initialized", " ", "to", " ",
                "a", " ", 
               RowBox[{"constant", ":", " ", 
                RowBox[{"in", " ", "this", " ", "case"}]}]}], ",", " ", 
              RowBox[{
              "expect", " ", "LightOn", " ", "or", " ", "LightOff", " ", "in",
                " ", 
               RowBox[{
               "inst", "\[LeftDoubleBracket]", "1", 
                "\[RightDoubleBracket]"}]}]}], "  ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "fullAmat", ",", "fullbvecOn", ",", "fullfluorvecOn"}], "}"}],
                ",", "w", ",", "rfparams1"}], "}"}], "=", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"BlochMatrix", ",", "DMSolution", ",", "RFParams"}], 
               "}"}], "/.", 
              RowBox[{
              "psi", "\[LeftDoubleBracket]", "2", 
               "\[RightDoubleBracket]"}]}]}], ";"}], "\[IndentingNewLine]", 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "fullAmat", ",", "fullbvecOn", ",", "fullfluorvecOn"}], "}"}],
                ",", "w", ",", "vg", ",", "rfparams1"}], "}"}], "=", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
               "BlochMatrix", ",", "DMSolution", ",", "VelocityGroups", ",", 
                "RFParams"}], "}"}], "/.", 
              RowBox[{
              "psi", "\[LeftDoubleBracket]", "2", 
               "\[RightDoubleBracket]"}]}]}], ";"}]}], "\[IndentingNewLine]", 
          "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
         RowBox[{
         "indVgMaxEx", " ", "is", " ", "the", " ", "index", " ", "of", " ", 
          "the", " ", "velocity", " ", "group", " ", "nearest", " ", "to"}], 
         " ", "+", 
         RowBox[{"5", "MHz"}]}], ",", " ", 
        RowBox[{
        "where", " ", "we", " ", "usually", " ", "find", " ", "a", " ", 
         "peak", " ", "in", " ", "the", " ", 
         RowBox[{"spectrum", ".", " ", "We"}], " ", "pass", " ", "this", " ", 
         "index", " ", "to", " ", 
         RowBox[{"phiv", "[", "]"}], " ", "to", " ", "extract", " ", 
         "population", " ", "information", " ", "of", " ", "this", " ", 
         "\"\<busy\>\"", " ", "velocity", " ", 
         RowBox[{"group", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"help1", "=", 
         RowBox[{"Abs", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"vg", "\[LeftDoubleBracket]", 
             RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "-", 
            RowBox[{"0.5", "*", 
             RowBox[{"NaturalWidth", "[", "2", "]"}]}]}], "/.", 
           RowBox[{"Last", "[", "syst", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"indVgMaxEx", "=", 
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"help1", ",", 
            RowBox[{"Min", "[", "help1", "]"}]}], "]"}], 
          "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], ";"}], "*)"}],
       "\[IndentingNewLine]", 
      RowBox[{"help1", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"getPops", "[", 
            RowBox[{"w", ",", "fullfluorvecOn"}], "]"}], ",", "16"}], "]"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"-", "1"}], "}"}]}], "]"}]}], ";", " ", 
      RowBox[{"(*", " ", 
       RowBox[{
       "List", " ", "of", " ", "total", " ", "exitation", " ", "per", " ", 
        "velocity", " ", "bin"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"indVgMaxEx", "=", 
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{"help1", ",", 
          RowBox[{"Max", "[", "help1", "]"}]}], "]"}], "\[LeftDoubleBracket]", 
        RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}], ">", "3"}], ",", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{
          "\"\<   Bin with max excitation: \>\"", ",", "indVgMaxEx", ",", 
           " ", "\"\<, memory size of fullAmat: \>\"", ",", 
           RowBox[{
            RowBox[{"ByteCount", "[", "fullAmat", "]"}], "/", 
            RowBox[{"1024.0", "^", "2"}]}], ",", "\"\< MB\>\""}], "]"}], 
         ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"Initialize", " ", "with", " ", "steady"}], "-", 
         RowBox[{"state", " ", "vector", " ", "for", " ", "I"}]}], "\[Equal]", 
        RowBox[{"IMeso", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"the", " ", "system", " ", "Aw"}], "\[Equal]", 
           RowBox[{
            RowBox[{"-", "b"}], " ", "was", " ", "solved", " ", "and", " ", 
            "use", " ", "the", " ", "formula", " ", "fullbvec"}], "\[Equal]", 
           
           RowBox[{"-", "\[Gamma]b"}]}], ")"}]}]}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"inst", "===", "LightOn"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"bvec", "=", "fullbvecOn"}], ";", 
         RowBox[{"fvec", "=", "fullfluorvecOn"}], ";"}], 
        "\[IndentingNewLine]", ",", " ", 
        RowBox[{"(*", " ", "ELSE", " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"inst", "===", "LightOff"}], ",", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Run", " ", "steady"}], "-", 
             RowBox[{
             "state", " ", "calculation", " ", "at", " ", "close", " ", "to", 
              " ", "zero", " ", "intensity"}]}], "*)"}], 
           RowBox[{
            RowBox[{"psi", "=", 
             RowBox[{"PsiMeso", "[", 
              RowBox[{"syst", ",", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"IMeso", "\[Rule]", "$MachineEpsilon"}], ",", 
                   RowBox[{
                   "\[CapitalDelta]fLaser", "\[Rule]", 
                    "\[CapitalDelta]fLaserNow"}]}], "}"}], ",", "params"}], 
                "]"}], ",", 
               RowBox[{"RefineResult", "\[Rule]", 
                RowBox[{"{", "}"}]}], ",", 
               RowBox[{"FluxReport", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"BlochMatrix", ",", "DMSolution"}], "}"}]}], ",", 
               RowBox[{"InitVG", "\[Rule]", "vg"}], ",", "nfopts"}], "]"}]}], 
            ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "fullAmat", ",", "fullbvecOff", ",", "fullfluorvecOff"}], 
                "}"}], ",", "w"}], "}"}], "=", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"BlochMatrix", ",", "DMSolution"}], "}"}], "/.", 
              RowBox[{
              "psi", "\[LeftDoubleBracket]", "2", 
               "\[RightDoubleBracket]"}]}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"bvec", "=", "fullbvecOff"}], ";", 
            RowBox[{"fvec", "=", "fullfluorvecOff"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Dimensions", "[", "fullbvecOn", "]"}], "!=", " ", 
               RowBox[{"Dimensions", "[", "fullbvecOff", "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\<StepPulseFlux[]: Dimensions[fullbvecOn]: \>\"", ",", " ", 
                 RowBox[{"Dimensions", "[", "fullbvecOn", "]"}], ",", " ", 
                 "\"\< != Dimensions[fullbvecOff]: \>\"", ",", " ", 
                 RowBox[{"Dimensions", "[", "fullbvecOff", "]"}], ",", 
                 "\"\<, aborting\>\""}], "]"}], ";", 
               RowBox[{"Abort", "[", "]"}], ";"}]}], "]"}], ";"}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"(*", " ", "ELSE", " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Print", "[", 
             RowBox[{
             "\"\<StepPulseFlux[]: Found inst = \>\"", ",", "inst", ",", 
              "\"\< but should equal one of LightOn or LightOff, \
aborting...\>\""}], "]"}], ";", 
            RowBox[{"Abort", "[", "]"}], ";"}]}], "\[IndentingNewLine]", 
          "]"}], ";"}]}], 
       RowBox[{"(*", "  ", 
        RowBox[{"If", "[", 
         RowBox[{"inst", "===", "LightOff"}], "]"}], " ", "*)"}], 
       "\[IndentingNewLine]", "]"}], ";", 
      RowBox[{"(*", "  ", 
       RowBox[{"If", "[", 
        RowBox[{"inst", "===", "LightOn"}], "]"}], " ", "*)"}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Dimensions", "[", "w", "]"}], "!=", " ", 
         RowBox[{"Dimensions", "[", "fullbvecOn", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{"\"\<StepReturnFlux[]: Dimensions[w]: \>\"", ",", " ", 
           RowBox[{"Dimensions", "[", "w", "]"}], ",", " ", 
           "\"\< != Dimensions[fullbvecOn]: \>\"", ",", " ", 
           RowBox[{"Dimensions", "[", "fullbvecOn", "]"}], ",", 
           "\"\<, aborting\>\""}], "]"}], ";", 
         RowBox[{"Abort", "[", "]"}], ";"}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Compute", " ", "return", " ", "flux", " ", "from", " ", "*", 
        "average", "*", " ", "irradiance"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"psiIavg1", "=", 
       RowBox[{"PsiMeso", "[", 
        RowBox[{"syst", ",", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"IMeso", "\[Rule]", "Iavg"}], ",", 
             RowBox[{
             "\[CapitalDelta]fLaser", "\[Rule]", 
              "\[CapitalDelta]fLaserNow"}]}], "}"}], ",", "params"}], "]"}], 
         ",", 
         RowBox[{"RefineResult", "\[Rule]", 
          RowBox[{"{", "}"}]}], ",", 
         RowBox[{"FluxReport", "\[Rule]", 
          RowBox[{"{", "}"}]}], ",", 
         RowBox[{"InitVG", "\[Rule]", "vg"}], ",", "nfopts"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}], ">", "0"}], ",",
         "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{"\"\<I: \>\"", ",", 
           RowBox[{"IMeso", "/.", "params1"}], ",", "\"\< W/m^2, Iavg: \>\"", 
           ",", "Iavg", ",", "\"\<, frep: \>\"", ",", 
           RowBox[{
            RowBox[{
             RowBox[{"10", "^", 
              RowBox[{"-", "6"}]}], "/", "trep"}], " ", 
            "\"\< MHz, peak cw psi: \>\""}], ",", 
           RowBox[{
           "psi", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
           ",", "\"\< ph/s/sr/atom/(W/m^2), psi from Iavg (cw): \>\"", ",", 
           "psiIavg1", ",", "\"\<, total excited state population at I: \>\"",
            ",", 
           RowBox[{"Total", "[", 
            RowBox[{"getPops", "[", 
             RowBox[{"w", ",", "fullfluorvecOn"}], "]"}], "]"}]}], "]"}], 
         ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"psiSpanAll", "=", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.0", ",", 
          RowBox[{
          "psi", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
         "}"}], "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"errAll", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"tend", "=", "0.0"}], ";", 
      RowBox[{"psiAvgLast", "=", "0.0"}], ";", 
      RowBox[{"psiAvgTotal", "=", "0.0"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "Ground", " ", "and", " ", "excited", " ", "state", " ", 
        "populations"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"popgr", "=", 
       RowBox[{"{", 
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"getPops", "[", 
           RowBox[{"w", ",", "fullbvecOn"}], "]"}], ",", "8"}], "]"}], 
        "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"popex", "=", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.0", ",", 
          RowBox[{"Total", "[", 
           RowBox[{"getPops", "[", 
            RowBox[{"w", ",", "fvec"}], "]"}], "]"}]}], "}"}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "Here", " ", "we", " ", "assume", " ", "the", " ", "\"\<Off\>\"", " ", 
        "inital", " ", 
        RowBox[{"state", ".", "Worth"}], " ", 
        RowBox[{"generalizing", "?"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"popgr8All", "=", 
       RowBox[{"{", 
        RowBox[{"ConstantArray", "[", 
         RowBox[{
          RowBox[{"1.0", "/", "8"}], ",", "8"}], "]"}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"popex16All", "=", 
       RowBox[{"{", 
        RowBox[{"ConstantArray", "[", 
         RowBox[{"0.0", ",", "16"}], "]"}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"popgr8WeightedAll", "=", 
       RowBox[{"{", 
        RowBox[{"ConstantArray", "[", 
         RowBox[{
          RowBox[{"1.0", "/", "8"}], ",", "8"}], "]"}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"psiAvgHist", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"excitedPopsAll", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"tuLast", "=", 
       RowBox[{"TimeUsed", "[", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"lastvg", "=", "vg"}], ";", "\[IndentingNewLine]", 
      RowBox[{"tPrep", "=", "0.0"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Positions", " ", "of", " ", "the", " ", "ground", " ", "state", " ", 
        "populations"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"grStates", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"Position", "[", 
         RowBox[{"fullbvecOn", ",", 
          RowBox[{"x_", "/;", 
           RowBox[{"x", "\[NotEqual]", "0"}]}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Positions", " ", "of", " ", "the", " ", "excited", " ", "state", " ", 
        "populations"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"exStates", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"Position", "[", 
         RowBox[{"fullfluorvecOn", ",", 
          RowBox[{"x_", "/;", 
           RowBox[{"x", ">", "0"}]}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"OptionValue", "@", "VerbosityLevel"}], " ", ">", "0"}], ",", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<Dimensions[grStates]: \>\"", ",", 
          RowBox[{"Dimensions", "[", "grStates", "]"}], ",", 
          "\"\<, Dimensions[exStates]: \>\"", ",", 
          RowBox[{"Dimensions", "[", "exStates", "]"}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
        " ", 
        RowBox[{"MAIN", " ", "LOOP", " ", "BEGIN"}], " ", "===", "===", "===",
         "===", "===", "===", "===", "=="}], "  ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"nperiods", "=", "nperiodsIn"}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", "1"}], ",", 
        RowBox[{"i", "\[LessEqual]", "nperiods"}], ",", 
        RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "CPU", " ", "time", " ", "spent", " ", "in", " ", "this", " ", 
          "session", " ", "so", " ", "far"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"tu1", "=", 
          RowBox[{"TimeUsed", "[", "]"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"FileExistsQ", "[", "\"\<NPERIODS.dat\>\"", "]"}], ",", 
           " ", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"Check", " ", "to", " ", "see", " ", "if", " ", 
              RowBox[{"there", "'"}], "s", " ", "a", " ", "file", " ", 
              RowBox[{"NPERIODS", ".", "dat"}], " ", "and", " ", "if", " ", 
              "it", " ", "contains", " ", "a", " ", "single", " ", "integer", 
              " ", "larger", " ", "tan", " ", "zero"}], ",", " ", 
             RowBox[{"if", " ", "so"}], ",", " ", 
             RowBox[{
             "terminate", " ", "iteration", " ", "at", " ", "the", " ", 
              "latest", " ", "after", " ", "that", " ", "pulse"}]}], " ", 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"nperiodsFile", "=", 
             RowBox[{"ToExpression", "[", 
              RowBox[{"Import", "[", 
               RowBox[{"\"\<NPERIODS.dat\>\"", ",", "\"\<Text\>\""}], "]"}], 
              "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"IntegerQ", "[", "nperiodsFile", "]"}], "&&", 
               RowBox[{"nperiodsFile", "\[GreaterEqual]", "1"}], "&&", 
               RowBox[{"nperiodsFile", "\[NotEqual]", "nperiods"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"nperiods", "=", 
                RowBox[{"Max", "[", 
                 RowBox[{"i", ",", "nperiodsFile"}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\<\\n********** StepPulseFlux[]: Read file NPERIODS.dat, \
will terminate after pulse \>\"", ",", "nperiods"}], "]"}], ";"}]}], 
             "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}], ">", "2"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{
             "Current", " ", "central", " ", "frequency", " ", "offset"}], 
             ",", " ", 
             RowBox[{
             "possibly", " ", "changed", " ", "due", " ", "to", " ", 
              "chirping"}]}], " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"\[CapitalDelta]fLaserNow", "=", 
             RowBox[{"\[CapitalDelta]fLaserFunction", "[", 
              RowBox[{"tend", "+", 
               RowBox[{"0.5", "*", 
                RowBox[{
                "tDiffs", "\[LeftDoubleBracket]", "1", 
                 "\[RightDoubleBracket]"}]}]}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Print", "[", 
             RowBox[{
             "\"\<  Laser period \>\"", ",", "i", ",", "\"\</\>\"", ",", 
              "nperiods", ",", "\"\< of duration \>\"", ",", 
              RowBox[{"fns", "*", "trep"}], ",", 
              "\"\< ns, DeltafLaserNow: \>\"", ",", 
              RowBox[{
               SuperscriptBox["10.0", 
                RowBox[{"-", "6"}]], "*", "\[CapitalDelta]fLaserNow"}], ",", 
              "\"\< MHz\>\""}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"err", "=", 
          RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"psiSpan", "=", 
          RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"i", "\[Equal]", "iVGfreezeLoc"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"Added", " ", "by", " ", 
                RowBox[{"S", ".", "R", "."}]}], ":", " ", 
               RowBox[{
                RowBox[{"create", " ", "light"}], "-", 
                RowBox[{
                "independent", " ", "part", " ", "of", " ", "Bloch", " ", 
                 "matrix"}]}]}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"psi", "=", 
               RowBox[{"PsiMeso", "[", 
                RowBox[{
                 RowBox[{"SparseReplace", "[", 
                  RowBox[{"syst", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"RabiFrequencyA", "[", "1", "]"}], "\[Rule]", 
                    "0"}], ",", 
                    RowBox[{
                    RowBox[{"RabiFrequencyB", "[", "1", "]"}], "\[Rule]", 
                    "0"}], ",", 
                    RowBox[{
                    RowBox[{"DetuningA", "[", "1", "]"}], "\[Rule]", "0"}], 
                    ",", 
                    RowBox[{
                    RowBox[{"DetuningB", "[", "1", "]"}], "\[Rule]", "0"}], 
                    ",", 
                    RowBox[{
                    RowBox[{"LightPhase", "[", "1", "]"}], "\[Rule]", "0"}]}],
                     "}"}]}], "]"}], ",", "params", ",", 
                 RowBox[{"RefineResult", "\[Rule]", 
                  RowBox[{"{", "}"}]}], ",", 
                 RowBox[{"FluxReport", "\[Rule]", 
                  RowBox[{"{", "BlochMatrix", "}"}]}], ",", 
                 RowBox[{"InitVG", "\[Rule]", "vg"}], ",", 
                 RowBox[{"SkipLinearSolve", "\[Rule]", "True"}], ",", 
                 "nfopts"}], "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "fullAmatLI", ",", "fullbvecOn", ",", "fullfluorvecOn"}], "}"}
                ], " ", "=", " ", 
               RowBox[{"BlochMatrix", "/.", 
                RowBox[{
                "psi", "\[LeftDoubleBracket]", "2", 
                 "\[RightDoubleBracket]"}]}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"Added", " ", "by", " ", 
                 RowBox[{"S", ".", "R", "."}]}], ":", " ", 
                RowBox[{
                 RowBox[{"create", " ", "light"}], "-", 
                 RowBox[{
                 "only", " ", "part", " ", "of", " ", "one", " ", "block", 
                  " ", "of", " ", "Bloch", " ", "matrix"}]}]}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"A110L", "=", 
               RowBox[{"SparseArray", "@@", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Expand", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ArrayRules", "[", 
                    RowBox[{
                    RowBox[{
                    "syst", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], "-", 
                    RowBox[{"SparseReplace", "[", 
                    RowBox[{
                    RowBox[{
                    "syst", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"RabiFrequencyA", "[", "1", "]"}], "\[Rule]", 
                    "0"}], ",", 
                    RowBox[{
                    RowBox[{"RabiFrequencyB", "[", "1", "]"}], "\[Rule]", 
                    "0"}], ",", 
                    RowBox[{
                    RowBox[{"DetuningA", "[", "1", "]"}], "\[Rule]", "0"}], 
                    ",", 
                    RowBox[{
                    RowBox[{"DetuningB", "[", "1", "]"}], "\[Rule]", "0"}], 
                    ",", 
                    RowBox[{
                    RowBox[{"LightPhase", "[", "1", "]"}], "\[Rule]", "0"}]}],
                     "}"}]}], "]"}]}], "]"}], ",", 
                    RowBox[{"Dimensions", "[", 
                    RowBox[{
                    "syst", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], "]"}]}], "}"}], "]"}], "/.", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"x_Integer", ",", "y_Integer"}], "}"}], "\[Rule]",
                     "0"}], ")"}], "\[Rule]", 
                   RowBox[{"Sequence", "[", "]"}]}]}], ")"}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}], ">", 
                  "2"}], "&&", 
                 RowBox[{"i", ">", "1"}]}], ",", 
                RowBox[{
                 RowBox[{
                 "Print", "[", 
                  "\"\<  --> Freezing velocity groups (rebinning \
stopped)\>\"", "]"}], ";"}]}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], 
           ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"(*", "  ", 
          RowBox[{"Bright", " ", 
           RowBox[{"period", ":", " ", 
            RowBox[{
            "Integrate", " ", "over", " ", "sub", " ", "time", " ", 
             "spans"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"j", "=", "1"}], ",", 
           RowBox[{"j", "\[LessEqual]", 
            RowBox[{"Length", "[", "relativeI", "]"}]}], ",", 
           RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
            "time", " ", "since", " ", "beginning", " ", "of", " ", "current",
              " ", "period"}], " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"tNow", "=", 
             RowBox[{"complexE", "\[LeftDoubleBracket]", 
              RowBox[{"j", ",", "1"}], "\[RightDoubleBracket]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
              "*", " ", "Concentrate", " ", "the", " ", "irradiance", " ", 
               "to", " ", "every", " ", 
               RowBox[{"BrightPeriodSkip", "'"}], "th", " ", "period", " ", 
               "Set", " ", "brightPeriodSkip"}], "=", 
              RowBox[{
              "1", " ", "to", " ", "make", " ", "all", " ", "periods", " ", 
               "even"}]}], " ", "**)"}], "\[IndentingNewLine]", 
            RowBox[{"factorEnhance", "=", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Mod", "[", 
                 RowBox[{
                  RowBox[{"i", "-", "1"}], ",", "brightPeriodSkip"}], "]"}], 
                "\[Equal]", "0"}], ",", "brightPeriodSkip", ",", "0"}], 
              "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{"Current", " ", 
              RowBox[{"irradiance", ".", " ", "A"}], " ", "value", " ", "of", 
              " ", "zero", " ", "leads", " ", "to", " ", "a", " ", 
              RowBox[{"1", "/", "0"}], " ", "division"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"IMesoNow", "=", 
             RowBox[{"Max", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"factorEnhance", "*", "IMeso", "*", 
                 RowBox[{
                 "relativeI", "\[LeftDoubleBracket]", "j", 
                  "\[RightDoubleBracket]"}]}], "/.", "params1"}], ",", 
               "$MachineEpsilon"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{
              "Current", " ", "central", " ", "frequency", " ", "offset"}], 
              ",", " ", 
              RowBox[{
              "possibly", " ", "changed", " ", "due", " ", "to", " ", 
               "chirping"}]}], " ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"\[CapitalDelta]fLaserNow", "=", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"tend", "+", 
                    RowBox[{"0.5", "*", 
                    RowBox[{
                    "tDiffs", "\[LeftDoubleBracket]", "j", 
                    "\[RightDoubleBracket]"}]}]}], ")"}], "*", "chirpRate"}], 
                 "+", "\[CapitalDelta]fLaser"}], "/.", "params1"}]}], ";"}], 
             "*)"}], "\[IndentingNewLine]", 
            RowBox[{"\[CapitalDelta]fLaserNow", "=", 
             RowBox[{"\[CapitalDelta]fLaserFunction", "[", 
              RowBox[{"tend", "+", 
               RowBox[{"0.5", "*", 
                RowBox[{
                "tDiffs", "\[LeftDoubleBracket]", "j", 
                 "\[RightDoubleBracket]"}]}]}], "]"}]}], ";", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{
              "Just", " ", "assemble", " ", "the", " ", "Bloch", " ", 
               "matrices"}], ";", " ", 
              RowBox[{
               RowBox[{"don", "'"}], "t", " ", "actually", " ", "solve", " ", 
               "the", " ", "equations"}]}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"tu11", "=", 
             RowBox[{"TimeUsed", "[", "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
               RowBox[{"Added", " ", "by", " ", 
                RowBox[{"S", ".", "R", "."}]}], ":", " ", 
               RowBox[{
               "for", " ", "fixed", " ", "velocity", " ", "groups"}]}], ",", 
              " ", 
              RowBox[{
               RowBox[{"just", " ", "add", " ", "light"}], "-", 
               RowBox[{
               "dependent", " ", "part", " ", "to", " ", "precalculated", " ",
                 "light"}], "-", 
               RowBox[{"independent", " ", 
                RowBox[{"part", ".", "\[IndentingNewLine]", "Commented"}], 
                " ", "out", " ", "by", " ", 
                RowBox[{"R", ".", "H", ".", " ", "on"}], " ", "17", "Nov11", 
                " ", "in", " ", "order", " ", "to", " ", "accommodate", " ", 
                RowBox[{"MatrixExp", "[", "]"}]}]}], ",", " ", 
              RowBox[{"see", " ", 
               RowBox[{"below", "."}]}]}], "\[IndentingNewLine]", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"(*", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"i", "\[GreaterEqual]", "iVGfreezeLoc"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Global`fullAmatG", "=", 
                 RowBox[{"fullAmatLI", "+", 
                  RowBox[{"BuildLightDependentPart", "[", 
                   RowBox[{
                    RowBox[{
                    "syst", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], ",", "A110L", ",", 
                    RowBox[{"syst", "\[LeftDoubleBracket]", 
                    RowBox[{"-", "1"}], "\[RightDoubleBracket]"}], ",", 
                    RowBox[{"Join", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"IMeso", "\[Rule]", "IMesoNow"}], ",", 
                    RowBox[{"Phase", "\[Rule]", 
                    RowBox[{
                    "phase", "\[LeftDoubleBracket]", "j", 
                    "\[RightDoubleBracket]"}]}], ",", 
                    RowBox[{
                    "\[CapitalDelta]fLaser", "\[Rule]", 
                    "\[CapitalDelta]fLaserNow"}]}], "}"}], ",", "params"}], 
                    "]"}], ",", "vg"}], "]"}]}]}], "\[IndentingNewLine]", ",",
                 " ", 
                RowBox[{"(*", " ", 
                 RowBox[{"Otherwise", ",", " ", 
                  RowBox[{"create", " ", "entire", " ", "matrix"}]}], " ", 
                 "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"psi", "=", 
                  RowBox[{"PsiMeso", "[", 
                   RowBox[{"syst", ",", 
                    RowBox[{"Join", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"IMeso", "\[Rule]", "IMesoNow"}], ",", 
                    RowBox[{"Phase", "\[Rule]", 
                    RowBox[{
                    "phase", "\[LeftDoubleBracket]", "j", 
                    "\[RightDoubleBracket]"}]}], ",", 
                    RowBox[{
                    "\[CapitalDelta]fLaser", "\[Rule]", 
                    "\[CapitalDelta]fLaserNow"}]}], "}"}], ",", "params"}], 
                    "]"}], ",", 
                    RowBox[{"RefineResult", "\[Rule]", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"FluxReport", "\[Rule]", 
                    RowBox[{"{", "BlochMatrix", "}"}]}], ",", 
                    RowBox[{"InitVG", "\[Rule]", "vg"}], ",", 
                    RowBox[{"SkipLinearSolve", "\[Rule]", "True"}], ",", 
                    "nfopts"}], "]"}]}], ";", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                   "Global`fullAmatG", ",", "fullbvecOn", ",", 
                    "fullfluorvecOn"}], "}"}], " ", "=", " ", 
                  RowBox[{"BlochMatrix", "/.", 
                   RowBox[{
                   "psi", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}]}], ";"}]}], 
               "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
             "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{
              "We", " ", "do", " ", "solve", " ", "the", " ", "full", " ", 
               "system", " ", "here", " ", "to", " ", "update", " ", "the", 
               " ", "variable", " ", "\"\<sol\>\"", " ", 
               RowBox[{"(", 
                RowBox[{"option", " ", "DMSolution"}], ")"}]}], ",", " ", 
              RowBox[{"used", " ", "in", " ", 
               RowBox[{"MatrixExp", "[", "]"}], " ", "below"}]}], "  ", 
             "*)"}], "\[IndentingNewLine]", 
            RowBox[{"psi", "=", 
             RowBox[{"PsiMeso", "[", 
              RowBox[{"syst", ",", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"IMeso", "\[Rule]", "IMesoNow"}], ",", 
                   RowBox[{"Phase", "\[Rule]", 
                    RowBox[{
                    "phase", "\[LeftDoubleBracket]", "j", 
                    "\[RightDoubleBracket]"}]}], ",", 
                   RowBox[{
                   "\[CapitalDelta]fLaser", "\[Rule]", 
                    "\[CapitalDelta]fLaserNow"}]}], "}"}], ",", "params"}], 
                "]"}], ",", 
               RowBox[{"RefineResult", "\[Rule]", 
                RowBox[{"{", "}"}]}], ",", 
               RowBox[{"FluxReport", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"BlochMatrix", ",", "DMSolution"}], "}"}]}], ",", 
               RowBox[{"InitVG", "\[Rule]", "vg"}], ",", 
               RowBox[{"SkipLinearSolve", "\[Rule]", "False"}], ",", 
               "nfopts"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "fullAmat", ",", "fullbvecOn", ",", "fullfluorvecOn"}], "}"}],
                ",", "sol"}], "}"}], " ", "=", " ", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"BlochMatrix", ",", "DMSolution"}], "}"}], "/.", 
              RowBox[{
              "psi", "\[LeftDoubleBracket]", "2", 
               "\[RightDoubleBracket]"}]}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"tu12", "=", 
             RowBox[{"TimeUsed", "[", "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"tPrep", "+=", 
             RowBox[{"tu12", "-", "tu11"}]}], ";", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Export", "[", 
               RowBox[{
                RowBox[{"\"\<vg_speclist_\>\"", "<>", 
                 RowBox[{"ToString", "[", 
                  RowBox[{"Round", "[", "IMesoNow", "]"}], "]"}], "<>", 
                 "\"\<Wm2_\>\"", "<>", 
                 RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<_\>\"", "<>", 
                 RowBox[{"ToString", "[", "j", "]"}], "<>", "\"\<.wdx\>\""}], 
                ",", 
                RowBox[{"{", 
                 RowBox[{
                 "vg", ",", "speclist", ",", "syst", ",", "rfparams1", ",", 
                  "nfopts"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
             "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
               RowBox[{"[", 
                RowBox[{"w", ",", "err", ",", "..."}], "]"}], "=", 
               RowBox[{
                RowBox[{
                 RowBox[{"phivCompiled", "[", 
                  RowBox[{"t_", ",", "u_", ",", "v_", ",", 
                   RowBox[{"obsmat_:", 
                    RowBox[{"{", "}"}]}], ",", 
                   RowBox[{"tspanMax_:", "1.0*^200"}], ",", 
                   RowBox[{"tol_:", "1.0*^-7"}], ",", 
                   RowBox[{"mIn_:", "-", "1"}], ",", 
                   RowBox[{"indVgMaxEx_:", "-", "1"}], ",", 
                   RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], " ", 
                 "solves", " ", "the", " ", "ODE", " ", 
                 RowBox[{"w", "'"}]}], " ", "=", " ", 
                RowBox[{"Aw", "+", "b"}]}]}], ",", " ", 
              RowBox[{
               RowBox[{"w", 
                RowBox[{"(", "0", ")"}]}], " ", "=", " ", "v"}]}], " ", 
             "*)"}], "\[IndentingNewLine]", 
            RowBox[{"(*", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Global`fullAmatG", "=", "fullAmat"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "w", ",", "errLoc", ",", "psiSpanLoc", ",", "popgr8", ",", 
                 "popex16", ",", "popgr8Weighted"}], "}"}], "=", 
               RowBox[{"phivCompiled", "[", 
                RowBox[{
                 RowBox[{
                 "tDiffs", "\[LeftDoubleBracket]", "j", 
                  "\[RightDoubleBracket]"}], ",", "fullbvecOn", ",", "w", ",",
                  "fullfluorvecOn", ",", 
                 RowBox[{"trep", "/", "tspanMaxFactor"}], ",", "tol", ",", 
                 "m", ",", "indVgMaxEx", ",", 
                 RowBox[{"VerbosityLevel", "\[Rule]", 
                  RowBox[{
                   RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}], "-", 
                   "1"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", "*)"}], 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{
              "Solver", " ", "for", " ", "constant", " ", "light", " ", 
               "field", " ", "based", " ", "on", " ", 
               RowBox[{"Mathematica", "'"}], "s", " ", "routine", " ", 
               RowBox[{"MatrixExp", "[", 
                RowBox[{"m", ",", "v"}], "]"}]}], ",", " ", 
              RowBox[{"faster", " ", "than", " ", 
               RowBox[{"phiv", "[", "]"}], " ", "and", " ", 
               RowBox[{"phivCompiled", "[", "]"}], " ", "in", " ", "many", 
               " ", "cases"}]}], "  ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{"w", "=", 
             RowBox[{"Re", "[", 
              RowBox[{
               RowBox[{"MatrixExp", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                  "tDiffs", "\[LeftDoubleBracket]", "j", 
                   "\[RightDoubleBracket]"}], "*", "fullAmat"}], ",", 
                 RowBox[{"(", 
                  RowBox[{"w", "+", "sol"}], ")"}]}], "]"}], "-", "sol"}], 
              "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "errLoc", ",", "psiSpanLoc", ",", "popgr8", ",", "popex16", ",",
                "popgr8Weighted"}], "}"}], "=", 
             RowBox[{"phivMatrixExp", "[", 
              RowBox[{
               RowBox[{
               "tDiffs", "\[LeftDoubleBracket]", "j", 
                "\[RightDoubleBracket]"}], ",", "w", ",", "grStates", ",", 
               "exStates", ",", "fullfluorvecOn", ",", "indVgMaxEx", ",", 
               RowBox[{"VerbosityLevel", "\[Rule]", 
                RowBox[{
                 RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}], "-", 
                 "1"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"tu13", "=", 
             RowBox[{"TimeUsed", "[", "]"}]}], ";", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}], ">", 
                "4"}], "||", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}], ">", 
                  "3"}], "&&", 
                 RowBox[{"i", "\[Equal]", "1"}]}], ")"}]}], ",", 
              RowBox[{
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\<    Subspan \>\"", ",", "j", ",", "\"\</\>\"", ",", 
                 RowBox[{"Length", "[", "relativeI", "]"}], ",", 
                 "\"\< of \>\"", ",", 
                 RowBox[{"fns", "*", 
                  RowBox[{
                  "tDiffs", "\[LeftDoubleBracket]", "j", 
                   "\[RightDoubleBracket]"}]}], ",", "\"\< ns, I: \>\"", ",", 
                 "IMesoNow", ",", " ", "\"\< W/m^2, t: \>\"", ",", 
                 RowBox[{"1.0*^6", 
                  RowBox[{"(", 
                   RowBox[{"tend", "+", 
                    RowBox[{"0.5", "*", 
                    RowBox[{
                    "tDiffs", "\[LeftDoubleBracket]", "j", 
                    "\[RightDoubleBracket]"}]}]}], ")"}]}], ",", 
                 "\"\< us, DfLaserNow: \>\"", ",", 
                 RowBox[{"1.0*^-6", "\[CapitalDelta]fLaserNow"}], ",", 
                 "\"\< MHz, Phase: \>\"", ",", 
                 RowBox[{
                 "phase", "\[LeftDoubleBracket]", "j", 
                  "\[RightDoubleBracket]"}], ",", 
                 "\"\<, CPU time {PsiMeso,MatrixExp}: \>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"tu12", "-", "tu11"}], ",", 
                   RowBox[{"tu13", "-", "tu12"}]}], "}"}], ",", 
                 "\"\< s\>\""}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}],
             ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"err", ",", "errLoc"}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"psiSpanLoc", "\[LeftDoubleBracket]", 
              RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "+=", 
             "tend"}], ";", 
            RowBox[{"(*", " ", 
             RowBox[{"Advance", " ", "time", " ", "axis", " ", 
              RowBox[{"(", 
               RowBox[{
               "tend", " ", "is", " ", "the", " ", "time", " ", "from", " ", 
                "beginning", " ", "of", " ", "first", " ", "pulse"}], ")"}]}],
              " ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{"psiSpan", "=", 
             RowBox[{"Join", "[", 
              RowBox[{"psiSpan", ",", "psiSpanLoc"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"tend", "+=", 
             RowBox[{
             "tDiffs", "\[LeftDoubleBracket]", "j", 
              "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"popex", "=", 
             RowBox[{"Join", "[", 
              RowBox[{"popex", ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"fns", "*", "tend"}], ",", 
                  RowBox[{"Total", "[", 
                   RowBox[{"getPops", "[", 
                    RowBox[{"w", ",", "fullfluorvecOn"}], "]"}], "]"}]}], 
                 "}"}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"popgr8All", "=", 
             RowBox[{"Join", "[", 
              RowBox[{"popgr8All", ",", "popgr8"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"popex16All", "=", 
             RowBox[{"Join", "[", 
              RowBox[{"popex16All", ",", "popex16"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"popgr8WeightedAll", "=", 
             RowBox[{"Join", "[", 
              RowBox[{"popgr8WeightedAll", ",", "popgr8Weighted"}], "]"}]}], 
            ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
         RowBox[{"(*", 
          RowBox[{"For", "[", "j", "]"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"popgr", ",", 
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"getPops", "[", 
              RowBox[{"w", ",", "fullbvecOn"}], "]"}], ",", "8"}], "]"}]}], 
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "Scale", " ", "time", " ", "axis", " ", "to", " ", "ns", " ", "to", 
           " ", "avoid", " ", "precision", " ", "loss", " ", "in", " ", 
           RowBox[{"Integrate", "[", "]"}]}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"psiSpan", "\[LeftDoubleBracket]", 
           RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "*=", 
          "fns"}], ";", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "Divide", " ", "return", " ", "flux", " ", "samples", " ", "by", 
           " ", "average", " ", "intensity"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"psiSpan", "\[LeftDoubleBracket]", 
           RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "/=", 
          "Iavg"}], ";", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "Integrate", " ", "Flux", " ", "during", " ", "each", " ", 
            RowBox[{"period", ".", " ", "Prepend"}], " ", "last", " ", 
            "value", " ", "of", " ", "previous", " ", "span", " ", "in", " ", 
            "order", " ", "to", " ", "properly", " ", "begin", " ", "the", 
            " ", 
            RowBox[{"integral", ".", " ", "Changed"}], " ", "to", " ", 
            "InterpolationOrder"}], "\[Rule]", 
           RowBox[{
            RowBox[{
            "1", " ", "to", " ", "correctly", " ", "integrate", " ", "long"}],
             "-", 
            RowBox[{"span", " ", "data", " ", "points"}]}]}], "  ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"hh", "=", 
          RowBox[{"Interpolation", "[", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"psiSpanAll", "\[LeftDoubleBracket]", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", "All"}], "\[RightDoubleBracket]"}], 
               "}"}], ",", "psiSpan"}], "]"}], ",", 
            RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"Must", " ", "use", " ", 
             RowBox[{"NIntegrate", "[", "]"}], " ", "with", " ", "Method"}], 
            "\[Rule]", 
            RowBox[{"\"\<Spline\>\"", " ", "in", " ", 
             RowBox[{"Interpolation", "[", "]"}]}]}], ",", " ", 
           RowBox[{"not", " ", 
            RowBox[{"Integrate", "[", "]"}]}]}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"psiAvg", "=", 
          RowBox[{
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"hh", "[", "tns", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"tns", ",", 
               RowBox[{"hh", "\[LeftDoubleBracket]", 
                RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], 
               ",", 
               RowBox[{"hh", "\[LeftDoubleBracket]", 
                RowBox[{"1", ",", "1", ",", "2"}], 
                "\[RightDoubleBracket]"}]}], "}"}]}], "]"}], "/", 
           RowBox[{"(", 
            RowBox[{"fns", "*", "trep"}], ")"}]}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"groundPops", "=", 
          RowBox[{"filterPops", "[", 
           RowBox[{"w", ",", "fullbvecOn", ",", "vg"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"excitedPops", "=", 
          RowBox[{"filterPops", "[", 
           RowBox[{"w", ",", "fullfluorvecOn", ",", "vg"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"excitedPopsAll", ",", "excitedPops"}], "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"For", " ", "debugging", " ", "only"}], ";", " ", 
           RowBox[{"remove", " ", "later"}]}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}], ">", "7"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Print", "[", 
             RowBox[{"ListLinePlot", "[", 
              RowBox[{"excitedPops", ",", 
               RowBox[{"Mesh", "\[Rule]", "All"}], ",", 
               RowBox[{"AxesOrigin", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"0.0", ",", "0.0"}], "}"}]}], ",", 
               RowBox[{"PlotRange", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1.0"}], ",", "1.0"}], "}"}], ",", "All"}], 
                 "}"}]}], ",", 
               RowBox[{"Frame", "\[Rule]", "True"}], ",", 
               RowBox[{"FrameLabel", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<Frequency (GHz)\>\"", ",", 
                  "\"\<Excited State Population\>\""}], "}"}]}]}], "]"}], 
             "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"Convert", " ", "velocity", " ", "classes"}], ",", " ", 
           RowBox[{
            RowBox[{"based", " ", "on", " ", "current", " ", "time"}], "-", 
            RowBox[{"dependent", " ", 
             RowBox[{"sol", "'"}], "n"}]}]}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"OptionValue", "[", "VGMethod", "]"}], "===", 
             "ConvertDM"}], " ", "&&", " ", 
            RowBox[{"i", "<", "iVGfreezeLoc"}]}], ",", "\[IndentingNewLine]", 
           
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"This", " ", "is", " ", "a", " ", "kludge"}], "..."}], 
            " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"NDitherLoc", "=", 
             RowBox[{"1", "+", 
              RowBox[{"Sign", "[", 
               RowBox[{"FWHMbw", "/.", "params1"}], "]"}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"speclist", "=", 
             RowBox[{"MapThread", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"#3", ",", 
                  RowBox[{"#1", "/", 
                   RowBox[{"(", 
                    RowBox[{"-", 
                    RowBox[{"Subtract", "@@", "#2"}]}], ")"}]}]}], "}"}], 
                "&"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Total", "/@", 
                  RowBox[{"Partition", "[", 
                   RowBox[{
                    RowBox[{"Total", "/@", 
                    RowBox[{"Partition", "[", 
                    RowBox[{
                    RowBox[{"fullfluorvecOn", "  ", "w"}], ",", 
                    RowBox[{"First", "[", "syst", "]"}]}], "]"}]}], ",", 
                    "NDitherLoc"}], "]"}]}], ",", 
                 RowBox[{"vg", "\[LeftDoubleBracket]", 
                  RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}], ",", 
                 RowBox[{"vg", "\[LeftDoubleBracket]", 
                  RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}]}], 
                "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"lastvg", "=", "vg"}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{"makeVg", "[", 
              RowBox[{"speclist_", ",", "atdata1_", ",", "params_", ",", 
               RowBox[{"opts", ":", 
                RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], "  ", "*)"}],
             "\[IndentingNewLine]", 
            RowBox[{"vg", "=", 
             RowBox[{"makeVg", "[", 
              RowBox[{"speclist", ",", 
               RowBox[{"Last", "[", "syst", "]"}], ",", "rfparams1", ",", 
               "nfopts"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"w", "=", 
             RowBox[{"convertDM", "[", 
              RowBox[{"w", ",", "lastvg", ",", "vg"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"fullfluorvecOn", "=", 
             RowBox[{"Flatten", "@", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"Evaluate", "@", 
                 RowBox[{"Take", "[", 
                  RowBox[{"fullfluorvecOn", ",", 
                   RowBox[{
                    RowBox[{"Length", "[", "fullfluorvecOn", "]"}], "/", 
                    RowBox[{"Length", "[", "lastvg", "]"}]}]}], "]"}]}], ",", 
                
                RowBox[{"{", 
                 RowBox[{"Length", "[", "vg", "]"}], "}"}]}], "]"}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
             "velocity", " ", "group", " ", "index", " ", "of", " ", 
              "maximum", " ", "excitation"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"excitedPopsHelp", "=", 
             RowBox[{"filterPops", "[", 
              RowBox[{"w", ",", "fullfluorvecOn", ",", "vg"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"help1", "=", 
             RowBox[{"Abs", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"vg", "\[LeftDoubleBracket]", 
                 RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "-", 
                RowBox[{"0.5", "*", 
                 RowBox[{"NaturalWidth", "[", "2", "]"}]}]}], "/.", 
               RowBox[{"Last", "[", "syst", "]"}]}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"indVgMaxEx", "=", 
             RowBox[{
              RowBox[{"Position", "[", 
               RowBox[{"help1", ",", 
                RowBox[{"Min", "[", "help1", "]"}]}], "]"}], 
              "\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}], ">", 
               "3"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Print", "[", 
                RowBox[{"\"\<    indVgMaxEx: \>\"", ",", "indVgMaxEx"}], 
                "]"}], ";"}]}], "]"}], ";"}], "\[IndentingNewLine]", ",", " ", 
           RowBox[{"(*", " ", "ELSE", " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"excitedPopsHelp", "=", "excitedPops"}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"psiSpanAll", "=", 
          RowBox[{"Join", "[", 
           RowBox[{"psiSpanAll", ",", "psiSpan"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"psiAvgTotal", "+=", "psiAvg"}], ";", "\[IndentingNewLine]", 
         
         RowBox[{"errAll", "=", 
          RowBox[{"Join", "[", 
           RowBox[{"errAll", ",", 
            RowBox[{"{", "err", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
         
         RowBox[{"psiAvgHist", "=", 
          RowBox[{"Join", "[", 
           RowBox[{"psiAvgHist", ",", 
            RowBox[{"{", "psiAvg", "}"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "Scale", " ", "w", " ", "to", " ", "compensate", " ", "for", " ", 
           "small", " ", "normalization", " ", "errors"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"w", "*=", 
            RowBox[{"1.0", "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"popgr", "\[LeftDoubleBracket]", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", "2"}], "\[RightDoubleBracket]"}], 
               "+", 
               RowBox[{"popex", "\[LeftDoubleBracket]", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", "2"}], "\[RightDoubleBracket]"}]}], 
              ")"}]}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "Terminate", " ", "iteration", " ", "if", " ", "two", " ", 
           "subsequent", " ", "psi", " ", "values", " ", "are", " ", "close", 
           " ", "to", " ", "each", " ", "other"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"terminationCriterion", "=", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{
               RowBox[{"psiAvgLast", "/", "psiAvg"}], "-", "1.0"}], "]"}], 
             "<", "TerminationThresh"}], "&&", 
            RowBox[{"i", ">", "4"}]}], ")"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"Save", " ", "data", " ", 
            RowBox[{"file", ":", " ", 
             RowBox[{"first", " ", "4", " ", "iterations"}]}]}], ",", " ", 
           RowBox[{
           "then", " ", "once", " ", "per", " ", "CPU", " ", "hour", " ", 
            "at", " ", "the", " ", "most"}], ",", " ", 
           RowBox[{"then", " ", "last"}]}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"fwriteCriterion", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"StringLength", "[", "fname", "]"}], ">", "0"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"i", "<", "5"}], "||", "terminationCriterion", "||", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"TimeUsed", "[", "]"}], "-", "tuLast"}], ")"}], ">", 
              "3600.0"}], "||", 
             RowBox[{"i", "\[Equal]", "nperiods"}]}], ")"}]}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"Global`res", "=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"terminationCriterion", "||", "fwriteCriterion", "||", 
             RowBox[{"i", "\[Equal]", "nperiods"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
             "psiAvg", ",", "psiAvgTotal", ",", "psiSpanAll", ",", 
              "psiAvgHist", ",", "Iavg", ",", "popgr8All", ",", "popex16All", 
              ",", "popgr8WeightedAll", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"PhiVErrors", "\[Rule]", "errAll"}], ",", 
                RowBox[{"PsiIavg", "\[Rule]", "psiIavg1"}], ",", 
                RowBox[{"GroundPopulation", "\[Rule]", "popgr"}], ",", 
                RowBox[{"ExcitedPopulation", "\[Rule]", "popex"}], ",", 
                RowBox[{"FinalGroundPops", "\[Rule]", "groundPops"}], ",", 
                RowBox[{"FinalExcitedPops", "\[Rule]", "excitedPops"}], ",", 
                RowBox[{"ExcitedPops", "\[Rule]", "excitedPopsAll"}], ",", 
                RowBox[{"LastDM", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"w", ",", "vg"}], "}"}]}], ",", 
                RowBox[{"RFParamsOut", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"rfparams1", ",", "params1", ",", "opts"}], 
                  "}"}]}]}], "}"}]}], "}"}], "\[IndentingNewLine]", ",", 
            RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"fwriteCriterion", ",", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{
             "Make", " ", "sure", " ", "\"\<res\>\"", " ", "does", " ", "not",
               " ", "appear", " ", "in", " ", "the", " ", "variable", " ", 
              "list", " ", "of", " ", "this", " ", "Module", " ", 
              RowBox[{"(", 
               RowBox[{
               "must", " ", "not", " ", "appear", " ", "green", " ", "in", 
                " ", "the", " ", "following", " ", "line"}], ")"}]}], ",", 
             " ", 
             RowBox[{
             "otherwise", " ", "it", " ", "cannot", " ", "be", " ", "loaded", 
              " ", "by", " ", 
              RowBox[{"Get", "[", "]"}], " ", "into", " ", "the", " ", 
              "global", " ", 
              RowBox[{"context", "!"}]}]}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Export", "[", 
             RowBox[{"fname", ",", "Global`res"}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"tuLast", "=", 
             RowBox[{"TimeUsed", "[", "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}], ">", 
               "2"}], ",", 
              RowBox[{
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\< ==> Saved (intermediate) results to \>\"", ",", 
                 "fname"}], "]"}], ";"}]}], "]"}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"tu2", "=", 
          RowBox[{"TimeUsed", "[", "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}], ">", "1"}], 
           ",", 
           RowBox[{
            RowBox[{"Print", "[", 
             RowBox[{
             "\"\<  Period \>\"", ",", "i", ",", 
              "\"\< done, CPU time {PsiMeso,MatrixExp,Rest}: \>\"", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tu12", "-", "tu11"}], ",", 
                RowBox[{"tu13", "-", "tu12"}], ",", 
                RowBox[{
                 RowBox[{"TimeUsed", "[", "]"}], "-", "tu13"}]}], "}"}], ",", 
              "\"\< s, tot matrix prep time: \>\"", ",", "tPrep", ",", 
              "\"\<s, psi avg: \>\"", ",", "psiAvg", ",", "\"\<\\n\>\""}], 
             "]"}], ";"}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "Terminate", " ", "iteration", " ", "if", " ", "two", " ", 
           "subsequent", " ", "psi", " ", "values", " ", "are", " ", "close", 
           " ", "to", " ", "each", " ", "other"}], " ", "*)"}], 
         RowBox[{"If", "[", 
          RowBox[{"terminationCriterion", ",", 
           RowBox[{
            RowBox[{"Print", "[", 
             RowBox[{"\"\< Last two psi values differ by only \>\"", ",", 
              RowBox[{"100.0", "*", 
               RowBox[{"Abs", "[", 
                RowBox[{
                 RowBox[{"psiAvgLast", "/", "psiAvg"}], "-", "1.0"}], "]"}]}],
               ",", "\"\<%, terminating iteration now.\>\""}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Break", "[", "]"}], ";"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"psiAvgLast", "=", "psiAvg"}], ";"}]}], 
       "\[IndentingNewLine]", "]"}], ";", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"For", "[", "i", "]"}], ",", 
        RowBox[{"main", " ", "loop", " ", "done"}]}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "===", "===", "===", "===", "===", "===", "===", "===", "==="}], "=", 
        " ", 
        RowBox[{
         RowBox[{"MAIN", " ", "LOOP", " ", "END"}], " ", "===", "===", "===", 
         
         RowBox[{"==", 
          RowBox[{
          "===", "===", "===", "===", "===", "===", "===", "==="}]}]}]}], " ",
        "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"OptionValue", "[", "VerbosityLevel", "]"}], ">", "0"}], ",",
         "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{
          "\"\<Completed, psi averaged over last period: \>\"", ",", "psiAvg",
            ",", "\"\< ph/s/sr/atom/(W/m^2)\>\""}], "]"}], ";", 
         RowBox[{"Print", "[", 
          RowBox[{
          "\"\<accumulated psi over all periods: \>\"", ",", "psiAvgTotal", 
           " ", ",", "\"\<, psi from avg cw irradiance: \>\"", ",", 
           "psiIavg1"}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", "Global`res"}]}], "\[IndentingNewLine]", "]"}]}],
   ";"}]], "Input",
 InitializationCell->
  True],

Cell[" ", "Text",
 Editable->False,
 Selectable->False,
 CellFrame->{{0, 0}, {0, 2}},
 ShowCellBracket->False,
 CellMargins->{{0, 0}, {1, 1}},
 CellElementSpacings->{"CellMinHeight"->1},
 CellFrameMargins->0,
 CellFrameColor->RGBColor[0, 0, 1],
 CellSize->{
  Inherited, 4}]
}, Open  ]],

Cell[CellGroupData[{

Cell["End the private context", \
"Subsection"],

Cell[BoxData[
 RowBox[{"End", "[", "]"}]], "Input",
 InitializationCell->
  True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Epilog", \
"Section"],

Cell["This section protects exported symbols and ends the package.", \
"Text"],

Cell[CellGroupData[{

Cell["Protect exported symbols", \
"Subsection"],

Cell[BoxData[
 RowBox[{"Protect", "[", 
  RowBox[{"Evaluate", "[", 
   RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}]], "Input",
 InitializationCell->
  True]
}, Open  ]],

Cell[CellGroupData[{

Cell["End the package context", \
"Subsection"],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Input",
 InitializationCell->
  True]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{808, 751},
WindowMargins->{{316, Automatic}, {Automatic, 50}},
PrivateNotebookOptions->{"FileOutlineCache"->False,
"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
FrontEndVersion -> "6.0",
StyleDefinitions->"Default.nb",
$CellContext`TrackCellChangeTimes -> False
]

